<?php
/**
 * @name cloudman.php
 * @description webservice_servant au param  trage des clouds.
 * @author Nicolas Biersart <n.biersart@esia-sa.com>
 * @contributor
 * @copyright Nicolas Biersart 2016
 * @license
 * @esia 2.00
 * @version 1.0.0
 * @date 17/05/2016
 */
include_once DEVICE_CLASS;
include_once GESA_CLASS;
include_once MVCMODEL;

class Model_cloudman extends Model_esia
{
	static function gesa ($dbconnection)
	{
       $gesas = Model_esia::getNodebyType($dbconnection, null, 'gesa');
       //print_r($gesas);
       $json_gesa = array();
       foreach($gesas as $node)
       {
       		$gesa = Model_gesa::getInstanceGESA($dbconnection, $node->getId());
            $nbr = Model_gesaStat::count_service_execute($dbconnection, $node->getId());    

            $json_gesa[]=array($gesa->getSerialNumber(),$nbr);
        }               
        return $json_gesa;
	}
    
    static function nodecalc ($dbconnection)
    {
    	$query=$dbconnection->prepare("SELECT 'complexe' as type, count(*) as nbr
                                    FROM esia_device AS T1
                                    WHERE device_type NOT IN ('printer','PCWin','gesa','imprimante','application')
                                    AND device_ip_addr<>2130706433 
                                    AND 
                                        (SELECT count(*) FROM esia_services WHERE service_device_id = T1.device_id) > 1
                                    UNION 
                                    SELECT 'alive' as type,count(*) as nbr
                                    FROM esia_device AS T1
                                    WHERE device_type NOT IN ('printer','PCWin','gesa','imprimante')
                                    AND device_ip_addr<>2130706433
                                        AND (SELECT count(*) FROM esia_services WHERE service_device_id = T1.device_id) =1
                                    UNION 
                                    SELECT 'printer' as type,count(*) as nbr
                                    FROM esia_device AS T1
                                    WHERE device_type = 'imprimante'
                                    AND device_ip_addr<>2130706433
                                    UNION 
                                    SELECT 'pcWin' as type,count(*) as nbr
                                    FROM esia_device AS T1
                                    WHERE device_type = 'PCWin'
                                    AND device_ip_addr<>2130706433
                                    UNION 
									SELECT 'GESA' as type,count(DISTINCT gesa_sn) as nbr   			
    								FROM gesa_info
    								JOIN esia_device AS T1 ON device_id = gesa_device_id 
    			 					WHERE device_type = 'gesa'
                                    AND device_ip_addr<>2130706433");
    	
    	$query = Model_esia::executeStatement($query,array());
        $arr = array();
        while($row=$query->fetch(PDO::FETCH_OBJ))
        {
        	$arr[$row->type] = $row->nbr;
        }
        return $arr;
    }

	static function groupnodecalc ($dbconnection)
	{
    	$query=$dbconnection->prepare("SELECT device_group_id, device_group_name
                                       FROM esia_device_group
                                       WHERE device_group_parent is null");

        $query = Model_esia::executeStatement($query,array());
        $listgroupnode=array();                
        $groupnodes = array();
        while($row=$query->fetch(PDO::FETCH_OBJ))
        {
        	$groupnodes[] = array('device_group_id'=>$row->device_group_id,
            					  'device_group_name'=>$row->device_group_name);
        }

        foreach($groupnodes as $groupnode)
        {
        	$query = Model_esia::getGroupDeviceIn($dbconnection,$groupnode['device_group_id']);
            $query=$query[0];

            $tab_id_node = array();
            $tmp = array('device_group_name'=>null,'printer'=>0,'GESA'=>0,'complexe'=>0,'alive'=>0,'pcWin'=>0);
            if($query['child']!=null)
            {
            	$tab_id_node[]=$query['id'];
                $tab_id_node=nodeOrGroupNode($dbconnection,$query);
                $tmp=numberofnodebyGroupNode($dbconnection,$tab_id_node,$groupnode['device_group_name']);
                $tmp2 = array('device_group_name'=>null,'printer'=>0,'GESA'=>0,'complexe'=>0,'alive'=>0,'pcWin'=>0);
                foreach ($tmp as $key) 
                {
                	$tmp2['device_group_name']=$key['device_group_name'];
                    $tmp2['printer']=$key['printer']+$tmp2['printer'];
                    $tmp2['GESA']=$key['GESA']+$tmp2['GESA'];
                    $tmp2['complexe']=$key['complexe']+$tmp2['complexe'];
                    $tmp2['alive']=$key['alive']+$tmp2['alive'];
                    $tmp2['pcWin']=$key['pcWin']+$tmp2['pcWin'];
              	}
                $listgroupnode[]=array($tmp2);
            }
            else
            {
            	$tab_id_node[]=$query['id'];
                $listgroupnode[]=numberofnodebyGroupNode($dbconnection,$tab_id_node,$groupnode['device_group_name']);
            }                                        
        }
        return $listgroupnode;
	}
        
	static function nodecalcByUnity ($dbconnection)
    {
    	$query=$dbconnection->prepare("SELECT DISTINCT gesa_sn,device_name,gesa_device_id
    								   FROM gesa_info
    								   JOIN esia_device ON device_id = gesa_device_id
    								   GROUP BY gesa_sn, device_name,gesa_device_id");    	

        $query = Model_esia::executeStatement($query,array());            
        $gesasn = array();
        while($row=$query->fetch(PDO::FETCH_OBJ))
        {
            $gesasn[] = array('id' =>$row->gesa_device_id,
        	                   'sn'=>$row->gesa_sn,
        					'name'=>$row->device_name);
        } 

        $arr=array();
        if(!empty($gesasn))
        {
        	$query=$dbconnection->prepare("SELECT gesa_sn, count(device_id) as alive
	                                       FROM gesa_info
	                                       JOIN gesa_connected ON connected_gesa_id = gesa_device_id
	                                       JOIN esia_device AS T1 ON device_id = connected_device_id 
	                                       WHERE device_type NOT IN ('printer','PCWin','gesa','imprimante','application')
	                                       AND (SELECT count(*) FROM esia_services WHERE service_device_id = T1.device_id) =1
	                                       GROUP BY gesa_sn");
	
	        $query = Model_esia::executeStatement($query,array());            
	        $alive = array();
	        while($row=$query->fetch(PDO::FETCH_OBJ))
	        {
	        	$alive[] = array('sn'=>$row->gesa_sn,
	                             'alive'=>$row->alive,
	                         );
	        } 
	
	        $query=$dbconnection->prepare("SELECT gesa_sn, count(device_id) as advanced_node
	                                       FROM gesa_info
	                                       JOIN gesa_connected ON connected_gesa_id = gesa_device_id
	                                       JOIN esia_device AS T1 ON device_id = connected_device_id 
	                                       WHERE device_type NOT IN ('printer','PCWin','gesa','imprimante','application')
	                                       AND (SELECT count(*) FROM esia_services WHERE service_device_id = T1.device_id) >1
	                                       GROUP BY gesa_sn");
	
	        $query = Model_esia::executeStatement($query,array());            
	        $advanced_node = array();
	        while($row=$query->fetch(PDO::FETCH_OBJ))
	        {
	        	$advanced_node[] = array('sn'=>$row->gesa_sn,
	                                     'advanced_node'=>$row->advanced_node,
	                                   );
	        } 
	
	        $query=$dbconnection->prepare("SELECT gesa_sn, count(device_id) as nbr
	                                       FROM gesa_info
	                                       JOIN gesa_connected ON connected_gesa_id = gesa_device_id
	                                       JOIN esia_device ON device_id = connected_device_id 
	                                       WHERE device_type = 'PCWin'
	                                       GROUP BY gesa_sn, device_type;");
	
	        $query = Model_esia::executeStatement($query,array());            
	        $pcwin_type = array();
	        while($row=$query->fetch(PDO::FETCH_OBJ))
	        {
	        	$pcwin_type[] = array('sn'=>$row->gesa_sn,                                           
	                                  'pc'=>$row->nbr,
	                               );
	        } 
	                                           
	
	        $query=$dbconnection->prepare("SELECT gesa_sn, count(device_id) as nbr
	                                       FROM gesa_info
	                                       JOIN gesa_connected ON connected_gesa_id = gesa_device_id
	                                       JOIN esia_device ON device_id = connected_device_id 
	                                       WHERE device_type = 'imprimante'
	                                       GROUP BY gesa_sn, device_type;");
	
	        $query = Model_esia::executeStatement($query,array());            
	        $print_type = array();
	        while($row=$query->fetch(PDO::FETCH_OBJ))
	        {
	            $print_type[] = array('sn'=>$row->gesa_sn,                                           
	        	                      'printer'=>$row->nbr);
	        } 
		
	        foreach ($gesasn as $node) 
	        {
	            $arr [$node['sn']] = array('id'=>$node['id'],'name'=>$node['name'],'advanced_node'=>0,'alive'=>0,'pc'=>0,'printer'=>0);
	        }
	
	        foreach ($advanced_node as $node) 
	        {
	        	if(array_key_exists($node['sn'], $arr))
	            {
	            	if($node['advanced_node']!=null)
	                {
	                	$arr [$node['sn']] = array_merge($arr[$node['sn']], array('advanced_node'=>$node['advanced_node']));
	                }
	                else
	                {
	                	$arr [$node['sn']] = array_merge($arr[$node['sn']], array('advanced_node'=>0));
	                }
	            }	       
	        }
	
	        foreach ($alive as $node) 
	        {
	        	if(array_key_exists($node['sn'], $arr))
	            {         
	            	if($node['alive']!=null)
	                {
	                	$arr[$node['sn']] = array_merge($arr[$node['sn']], array('alive'=>$node['alive']));
	                }
	                else
	                {
	                	$arr[$node['sn']] = array_merge($arr[$node['sn']], array('alive'=>0));   
	                }
	            }            
	        }
	
	        foreach ($pcwin_type as $node) 
	        {
	        	if(array_key_exists($node['sn'], $arr))
	            {    
	            	if($node['pc']!=null)
	                {     
	                	$arr[$node['sn']] = array_merge($arr[$node['sn']], array('pc'=>$node['pc']));  
	                }
	                else
	                {
	                	$arr[$node['sn']] = array_merge($arr[$node['sn']], array('pc'=>0));   
	                }                                  
	            }
	        }
	
	        foreach ($print_type as $node) 
	        {
	        	if(array_key_exists($node['sn'], $arr))
	            {  
	            	if($node['printer']!=null)
	                {       
	                	$arr[$node['sn']] = array_merge($arr[$node['sn']], array('printer'=>$node['printer']));                                    
	                }
	                else
	                {
	                	$arr[$node['sn']] = array_merge($arr[$node['sn']], array('printer'=>0));
	                }
	            }
	        }
         }
         return $arr;
	}
        
    static function gesalink ($dbconnection)
    {
    	$query=$dbconnection->prepare("SELECT device_name, count(*) as nbr
                                       FROM esia_device
                                       JOIN gesa_connected ON connected_gesa_id = device_id
                                       WHERE device_type='gesa'
                                       GROUP BY device_name
                                       UNION 
	                                   SELECT 'nolink',  count(*)
                                       FROM esia_device
                                       WHERE device_type<>'gesa' AND device_id NOT IN (SELECT DISTINCT connected_device_id FROM gesa_connected)");
        $query = Model_esia::executeStatement($query,array());
        $arr = array();
        while($row=$query->fetch(PDO::FETCH_OBJ))
        {
        	$arr[$row->device_name] = $row->nbr;
        }
        return json_encode($arr);
    }
        
    static function numberService ($dbconnection)
    {
    	$query=$dbconnection->prepare("SELECT count(*)  AS nbr
        		                       FROM esia_services
                	                   JOIN esia_device ON device_id = service_device_id
                                	   WHERE device_id NOT IN (SELECT DISTINCT connected_device_id
                                                               FROM gesa_connected)
                                       AND     service_delete=FALSE
                                	   AND device_ip_addr<>2130706433");
    	$query = Model_esia::executeStatement($query,array());
        $row=$query->fetch(PDO::FETCH_OBJ);
        $nbr_service_gesa  = $row->nbr;
        $query=$dbconnection->prepare("SELECT COUNT(*) AS nbr
        		                       FROM esia_services
                  	                   JOIN esia_device ON device_id = service_device_id
                                	   WHERE service_delete=FALSE
                                	   AND device_ip_addr<>2130706433");
        $query = Model_esia::executeStatement($query,array());
        $row=$query->fetch(PDO::FETCH_OBJ);
        $nbr_service  = $row->nbr;
        return array($nbr_service_gesa,$nbr_service);
    }
        
	/**
	 * @detail retourne un array contenant les paramètres utlisés
	 * @param PDO $dbconnection
	 * @param array $param contient les param du block
	 * @retval unknown[][]|NULL[][]
	 * @throw void
	 */
	
	static function nodeOrGroupNode($dbconnection,$param)
	{
	    $tab_id_node=array();
	
	    $tab_id_node[]=$param['id'];
	
	    foreach ($param as $value) 
	    {
	        if(is_array($value))
	        {
	            foreach ($value as $val) 
	            {
	                $tab_id_node[]=$val['id'];
	                if($val['child']!=null)
	                {
	                    $tab_id_node[]=nodeOrGroupNode($dbconnection,$val['child']);
	                }
	            }            
	        }
	    }
	    return $tab_id_node;
	}
	
	static function numberofnodebyGroupNode($dbconnection,$tab_id_node,$name)
	{
	    $listgroupnode=array();
	    foreach ($tab_id_node as $id) 
	    {
	        $sql="SELECT 'complexe' as type, count(*) as nbr
	                FROM esia_device AS T1
	                JOIN esia_device_group_in ON device_id = group_in_device_id
	                JOIN esia_device_group ON device_group_id= group_in_device_group_id
	                WHERE device_type NOT IN ('printer','PCWin','gesa','aa_groupNode','imprimante','application') 
	                AND device_group_id = :id
	                AND device_ip_addr<>2130706433 
	                AND (SELECT count(*) FROM esia_services WHERE service_device_id = T1.device_id) > 1
	                        UNION 
	                                SELECT 'alive' as type,count(*) as nbr
	                                FROM esia_device AS T1
	                                JOIN esia_device_group_in ON device_id = group_in_device_id
	                                JOIN esia_device_group ON device_group_id= group_in_device_group_id
	                                WHERE device_type NOT IN ('printer','PCWin','gesa','aa_groupNode','imprimante','application')
	                                AND device_group_id = :id
	                                AND device_ip_addr<>2130706433 
	                                AND (SELECT count(*) FROM esia_services WHERE service_device_id = T1.device_id) =1
	                        UNION 
	                                SELECT 'printer' as type,count(*) as nbr
	                                FROM esia_device AS T1
	                                JOIN esia_device_group_in ON device_id = group_in_device_id
	                                JOIN esia_device_group ON device_group_id= group_in_device_group_id
	                                WHERE device_type = 'imprimante'
	                                AND device_group_id = :id
	                                AND device_ip_addr<>2130706433 
	                        UNION 
	                                SELECT 'pcWin' as type,count(*) as nbr
	                                FROM esia_device AS T1
	                                JOIN esia_device_group_in ON device_id = group_in_device_id
	                                JOIN esia_device_group ON device_group_id= group_in_device_group_id
	                                WHERE device_type = 'PCWin'
	                                AND device_group_id = :id
	                                AND device_ip_addr<>2130706433 
	                        UNION 
	                                SELECT 'GESA' as type,count(*) as nbr
	                                FROM esia_device AS T1
	                                JOIN esia_device_group_in ON device_id = group_in_device_id
	                                JOIN esia_device_group ON device_group_id= group_in_device_group_id
	                                WHERE device_type = 'gesa'
	                                AND device_group_id = :id
	                                AND device_ip_addr<>2130706433 ";
	
	        $query= $dbconnection->prepare($sql);
	        $query = Model_esia::executeStatement($query,array(':id'=>$id));
	        $arr = array();
	        while($row=$query->fetch(PDO::FETCH_OBJ))
	        {                               
	                $arr['device_group_name']= $name;
	                $arr[$row->type] = $row->nbr;
	        }        
	        $listgroupnode[]=$arr;
	    }
	    return $listgroupnode;
	} 
}

?>
