<?php
/*****************************/
/* Projet Esia 						  */
/*											  */
/*Biersart Nicolas mars 2010 */
/*****************************/

$path = $_SERVER['DOCUMENT_ROOT'];
include_once "$path/common.php";
include_once "$path/esia.conf.php";
include_once "$path/Model_cloudman.php";
$checklicence="/usr/local/esia/licence/validate_licence";

$navbar->addElement($lang['ABOUT'], '/about.php',$ICONS['warning']);

try
{
	$dbconnection = new PDO('pgsql:host='.DB_HOST.';port='.DB_PORT.';dbname='.DB_NAME, DB_USERNAME, DB_PWD);
	$dbconnection->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_WARNING);

	$is_esia_admin_rule = ($user->getDroits($dbconnection,"esia_administration") ==1);
	$is_esia_device_rule = ($user->getDroits($dbconnection,"esia_device") ==1);

	$smarty->assign('is_admin_rule',$is_esia_admin_rule);
	$smarty->assign('is_device_rule',$is_esia_device_rule);
}
catch(Exception $e)
{
	echo 'PDO SQL ERROR: '.$e->getMessage().'<br />';
	echo 'N   : '.$e->getCode();
}

if(!isset($_GET['action']))
{
	$smarty->assign('action','main');
}
elseif($_GET['action']=='about')
{
	$smarty->assign('licegi','');
	$smarty->assign('licid','');
	try
	{
		$licegi = Model_esia::getLicenceInformation($dbconnection,'LICENCE_EGIDE');
		if(!empty($licegi))
		{
			$smarty->assign('licegi',$licegi['type']);
			$smarty->assign('licid',$licegi['id']);
		}
	}
	catch(EsiaDbException $ex) //On ne fait rien si exeption levée
	{
	}
    $info = php_uname();
    $os = shell_exec('cat /etc/debian_version');
	$output = shell_exec('ls -l --full-time /var/lib/dpkg/info/esia-interface.list | tr -s " " " "');
	if (preg_match('/(\d+)-(\d+)-(\d+)\s+(\d+)\:(\d+)\:(\d+)/', $output,$matches))
	{
		$date = "$matches[3]/$matches[2]/$matches[1] $matches[4]:$matches[5]:$matches[6]";
	}

	$output = shell_exec('dpkg -l|grep esia-interface | tr -s " " " "');
	if (preg_match('/esia-interface\s+(\d.*\d)/', $output,$matches))
	{
		$version = $matches[1];
	}

	$smarty->assign('action','about');
	$smarty->assign('version',$version);
	$smarty->assign('date',$date);
	$smarty->assign('os_info',"Debian version $os<br />$info");
}
elseif($_GET['action']=='licence')
{
    if(isset($_FILES["licencefile"]))
    {
        try
        {
            $licence = file_get_contents($_FILES["licencefile"]["tmp_name"]);
            $flag=Model_esia::updateLicenceInformation($dbconnection,$licence);
            if($flag != 0)
            {
                $smarty->assign('l_licence_upload_err',  $lang['UPLOAD_LICENCE_FILE_ERR']);
            }
            $licence_type='LICENCE';
            if(preg_match('#Type\:\s?(.*)\n#',$licence,$regs))
            {
            	if($regs[1]=='Egide'||$regs[1]=='Egide-client')
            	{
            		$licence_type='LICENCE_EGIDE';
            	}
            }
            $licence = Model_esia::getLicenceInformation($dbconnection,$licence_type);
            $exec=$checklicence.' -t '.$licence_type;
            if($licence_type=='LICENCE_EGIDE')
            {
            	$orig = Model_esia::getLicenceInformation($dbconnection,'LICENCE');
            	if(strpos($orig['type'],'Mercury')===FALSE || strpos($orig['type'],'Universe')===FALSE)
            	{
            		throw new EsiaDbException('bad licence');
            	}
            	if($licence['node'] != $orig['node'])
            	{
            		throw new EsiaDbException('node not correspond');
            	}
            }
            exec($exec,$output,$ret);
            if($ret==0)
            {
                $smarty->assign('licence',  $licence);
                $smarty->assign('l_licence_upload_ok',  $lang['UPLOAD_LICENCE_UPLOAD_SUCCESS']);
            }
            else
            {
            	Model_esia::cleanLicenceInformation($dbconnection,$licence_type);
                $smarty->assign('l_licence_upload_err',  $lang['LICENCE_ACTIVATED_FAILED'].'<br />'.$output[0]);
                if(!is_executable($checklicence))
                {
                    $smarty->assign('l_licence_upload_err',  $lang['LICENCE_INSTALL_CORRUPT']);
                }
            }
        }
        catch(EsiaDbException $e)
        {
            if($e->getMessage() == 'Licence file expired')
            {
                $smarty->assign('l_licence_upload_err',  $lang['UPLOAD_LICENCE_FILE_EXPIRED']);
            }
            elseif($e->getMessage() == 'node not correspond')
            {
            	$smarty->assign('l_licence_upload_err',  $lang['BAD_LICENCE_NUMBER']);
            }
            elseif($e->getMessage() == 'bad licence')
            {
            	$smarty->assign('l_licence_upload_err',  $lang['BAD_LICENCE_TYPE']);
            }
            else
            {
            	echo 'here';
                $smarty->assign('l_licence_upload_err',  $lang['UPLOAD_LICENCE_FILE_ERR']);
            }
        }
    }
	$smarty->assign('action','licence');
	$smarty->assign('version',$version);
	$smarty->assign('date',$date);
	$smarty->assign('os_info',"Debian version $os<br />$info");
}
elseif ($_GET['action']=='delete_message')
{
	$msg=Model_esia::getCommunicationMsg($dbconnection,$_GET['id']);
	$msg=$msg[0];
	$smarty->assign('del_msg',$msg);
	$smarty->assign('action','delete_message');
	if(!empty($_POST['id']) && isset($_POST['id']))
	{
		try
		{
			if($msg['getcontent']=='html')
			{
				$file = $path."/data/template_msg/message_".$_GET['id'].".html";
				unlink($file);
			}
			Model_esia::delCommunicationMsg($dbconnection,$_GET['id']);
			$smarty->assign('l_success',$lang['ADM_MSG_DELETE_OK']);
			$smarty->assign('action','delete_message_ok');
		}
		catch (EsiaDbException $e)
		{
			$smarty->assign('l_error',$e->getMessage());
		}
	}
}
elseif($_GET['action']=='consumption')
{
    if($user->getDroits($dbconnection,"esia_administration") ==1 && $user->getDroits($dbconnection,"esia_device") ==1)
    {
    	$nodecalc = array();
    	$nodecalc = Model_cloudman::nodecalc($dbconnection);
    	$smarty->assign('nodecalc',$nodecalc);
        if(strpos($licence['type'],'Mercury') !== false)
        {
            $nbr = Model_esia::countNodeNumberForLicence($dbconnection);
            $smarty->assign('MercuryclientConsumption',$nbr);
            $smarty->assign('licence_max',$licence['node']);

            $merc = Model_esia::getMercuryClient($dbconnection);
            $smarty->assign('Mercuryclient',$merc);
        }
    	$arr = array();
    	$arr = Model_cloudman::nodecalcByUnity($dbconnection);
    	// Use check_gesa plugin to get gesa list
    	$gesaconnected = array();
    	$cmd = '/usr/local/esia/plugins/check_gesa -C check-unity-state -G 0000';
    	exec($cmd, $output, $code);
    	if($code == 0)
    	{
    		// If cmd succeed check if we found our gesa serial in the list
    		foreach($output as $row)
    		{
    			// Get SN from list rows (sn=public_ip)
    			$rowSerial = explode('=', trim($row))[0];
    			$gesaconnected[] = $rowSerial;
    		}
    	}

    	foreach ($arr as $sn => &$node)
    	{
    		$state = 'disconnected';
    		if(in_array($sn,$gesaconnected ))
    		{
    			$state = 'connected';
    		}
    	    $node['state'] = $state;
    	}
    	$smarty->assign('nodecalcByUnity',$arr);
    	$smarty->assign('action','consumption');
    }
    else
    {
        $smarty->assign('no_header',true);
        $smarty->display('no_access.html');
        exit(0);
    }
}
elseif($_GET['action']=='maj_msg_date')
{
	$key = array_search($_GET['title'], $lang);
	$today = date("Y-m-d");
	$date = date_create($today);
	date_add($date,date_interval_create_from_date_string('1 day'));
	if($key==false)
	{
		Model_esia::reloadDateMsg($dbconnection,$_GET['title'],date_format($date,'d/m/Y'));
	}
	else
	{
		Model_esia::reloadDateMsg($dbconnection,$key,date_format($date,'d/m/Y'));
	}
	exit (0);
}
elseif($_GET['action']=='maj_msg_show')
{
	$smarty->assign('action','delete_message_ok');
	try
	{
		if(isset($_GET['id']) && !empty($_GET['id']))
		{
			Model_esia::updateMessageUserRead($dbconnection,$_GET['id'],$user->getId());
		}
		$smarty->assign('l_success',$lang['READ']);
	}
	catch (EsiaDbException $e)
	{
		$smarty->assign('l_error',$e->getMessage());
	}

	if($_GET['exit']!="yes")
	{
		exit (0);
	}
}
elseif($_GET['action']=='message' || $_GET['action']=='message_overall')
{
	if(isset($_GET['id']) && !empty($_GET['id']))
	{
		$msg = Model_esia::getCommunicationMsg($dbconnection,$_GET['id']);
		$msg = $msg[0];

		if($msg['getcontent']=='db')
		{
			$message = $lang[$msg['message']];
			echo '<div class="blockView_title"><td>'.$message.'</td></div>';
		}
		elseif($msg['getcontent']=='html')
		{
			$html_code = disguise_curl($msg['message']);
			echo $html_code;
		}
		elseif($msg['getcontent']=='rss')
		{
			echo $msg['message'];
		}
		else
		{
			$message = $msg['message'];
			echo '<div class="blockView_title"><td>'.$message.'</td></div>';
		}

		if($msg['show']==FALSE && $msg['getcontent']!='html')
		{
			Model_esia::updateShowMsg($dbconnection,$msg['title'],true);
		}
	}
	else
	{
		$com_msg = Model_esia::getCommunicationNewMsg($dbconnection,$user->getId(),$user->getDroits($dbconnection,"esia_administration"),true);
		$list_message = array();

		foreach($com_msg as $row => $innerArray)
		{
			$list_message[$i]['id']=$innerArray['id'];
			$list_message[$i]['type']=$innerArray['type'];
			$list_message[$i]['getcontent']=$innerArray['getcontent'];
			if($innerArray['getcontent']=='db')
			{
				$list_message[$i]['title']=$lang[$innerArray['title']];
				$list_message[$i]['message']=$lang[$innerArray['message']];
			}
			else
			{
				$list_message[$i]['title']=$innerArray['title'];
				$list_message[$i]['message']=$innerArray['message'];
			}
			$list_message[$i]['start_date']=date_format(new DateTime($innerArray['start_date']),'d/m/Y');
			$list_message[$i]['end_date']=date_format(new DateTime($innerArray['end_date']),'d/m/Y');
			$list_message[$i]['show']=$innerArray['show'];
			$i++;
		}

		$smarty->assign('list_message',$list_message);
		$smarty->assign('action',$_GET['action']);
	}
}

$smarty->display('about.html');

?>
