<?php
/**
 * @name account.php
 * @description page où l'utilisateur peut modifier ses données personneles (mot de passe,mail,etc)
 * @author Nicolas Biersart <n.biersart@esia-network.com>
 * @contributor
 * @copyright Nicolas Biersart 2012
 * @license
 * @esia 1.00
 * @version 1.0.0
 * @date 16/04/2013
 */
include_once 'common.php';
//on inclus la classe modem de l'administration pour l'update de l'utilisateur
include_once 'Model_adm.php';
include_once 'Model_esia.php';
//on test si la valeur existe si non on la set à null
if(!isset($_GET['update']))
{
	$_GET['update']=null;
}
if($_GET['update']=="true")	//traitement de l'update
{
	if($_POST['name']==$user->getName())//on vérifie la correspondance entre les noms d'utilisateurs
	{
		if($_POST['password'] == $_POST['confipassword'])//on vérifie si les mot de passe sont identique
		{
			if($user->checkEmail($_POST['email']))//test de l'email
			{
				try
				{
					if(isset($_POST['password'])&& !empty($_POST['password']))
					{
						Model_adm::UpdateUserPassword($dbconnection,$user,$_POST['password']);
					}
					$user->setEmail($_POST['email']);
					$user->setLang($_POST['lang']);

					switch ($_POST["select_home_page"])
					{
						case 'dashboard':
							$homepage=$_POST['select_home_page_dashboard'];
							break;

						case 'url':
							$homepage=$_POST['home_page'];
							break;

						default:
							$homepage="/index.php";
							break;
					}
					$user->setHomePage($homepage);
					//on met à jour les informations de l'utilisateur
					Model_adm::UpdateUser($dbconnection,$user,$_POST['password']);
					$smarty->assign('adm_user_update_success',$lang['ADM_USER_UPDATE_SUCCESS']);
					if(isset($_POST['tutoriel']))
					{
						$user->resetTutoriel();
						Model_esia::updateTutoriel($dbconnection,$user);
					}
				}
				catch(EsiaDbException $e)//si une erreur c'est produite
				{
					$smarty->assign('adm_user_update_failed',$e->getMessage());
				}
			}
			else
			{
				$smarty->assign('adm_user_update_failed',"email is invalid");
			}
		}
		else
		{
			$smarty->assign('adm_user_update_failed',"password is not same");
		}
	}
	else
	{
		$smarty->assign('adm_user_update_failed',"user is not same");
	}
}

$navbar->addElement($lang['ACCOUNT'], '/account.php',$ICONS['warning']);

//info pour le formulaire
$smarty->assign('user_name', $user->getName());
$smarty->assign('user_lang', $user->getLang());
$smarty->assign('user_id', $user->getId());
$smarty->assign('user_inscription', $user->getInscriptionTime());
$smarty->assign('user_mail', $user->getEmail());
$smarty->assign('home_page', $user->getHomePage());

if($user->getHomePage() == '/index.php')
{
	$smarty->assign('home_page_type', 'empty');
}
else
{
	if(is_numeric($user->getHomePage()))
	{
		$smarty->assign('home_page_type', 'dashboard');
	}
	else
	{
		$smarty->assign('home_page_type', 'url');
	}
}

//variable de langue
$smarty->assign('l_username',$lang['ADM_USERNAME']);
$smarty->assign('l_email', $lang['ADM_EMAIL']);
$smarty->assign('l_password', $lang['ADM_PASSWORD']);
$smarty->assign('l_confirmed_password', $lang['ADM_CONFIRMED_PASSWORD']);
$smarty->assign('l_inscription_time',$lang['ADM_INSCRIPTION_TIME']);
$smarty->assign('l_lang',$lang['ADM_LANG']);
$smarty->assign('l_cancel',$lang['CANCEL']);

//info pour la page d'accueil
$dashboards = Model_esia::getDashboards($dbconnection,null,$user->getId());
foreach($dashboards['default'] as &$dash)
{
	if(strpos($dash['name'],'LANG_')!==false)
	{
		$key = preg_replace('#LANG_#','',$dash['name']);
		$dash['name'] = $lang[$key];
	}
}
$smarty->assign('user_dashboard', $dashboards);

$smarty->assign('l_update',$lang['MODIF']);
$smarty->display('account.html');
?>
