<?php
/**
 * @name maintenance
 * @description script gérant l'accès au mode maintenance d'Esia
 * @author Nicolas Biersart <n.biersart@esia-sa.com>
 * @contributor
 * @copyright Nicolas Biersart 2017
 * @license
 * @esia 3.10
 * @version 3.1.0
 * @date 8/11/2017
 */
$path = $_SERVER['DOCUMENT_ROOT'];
include_once $path.'common.php';
include_once $path.'/Model_adm.php';
$temps = microtime();
$temps = explode(' ', $temps);
$debut = $temps[1] + $temps[0];
if(!isset($_GET['category']))
{
    $_GET['category'] ='maintenance';
}

if($_GET['category'] =='maintenance')
{
    //
    //CREATION VALEUR CONSTANTE
    //
    $MAINTENANCE_MODE = array('NOEXECUTION'=>'NOEXEC','NOALERT'=>'EXEC','FIRSTERROR'=>'FIRSTERROR');
    $smarty->assign('MODE_MAINTENANCE',$MAINTENANCE_MODE);

    $MAINTENANCE_HOUR = array();
    for($i=0;$i < 24; $i++)
    {
        if($i<10)
        {
            $time='0'.$i;
        }
        else
        {
             $time=$i;
        }
        $MAINTENANCE_HOUR[]=$time.':00';
        $MAINTENANCE_HOUR[]=$time.':15';
        $MAINTENANCE_HOUR[]=$time.':30';
        $MAINTENANCE_HOUR[]=$time.':45';
    }
    $smarty->assign('HOUR_MAINTENANCE',$MAINTENANCE_HOUR);
    if(!isset($_GET['action']))
    {
        $_GET['action'] ='view';
    }
    //
    //DEBUT DE LA PAGE
    //
    if(isset($_GET['id']) &&is_numeric($_GET['id']) )
    {
        $smarty->assign('adm_group_id',$_GET['id']);
    }
    elseif(isset($_POST['id'])&&is_numeric($_POST['id']) )
    {
        $_GET['id'] = $_POST['id'];
    }

    $NodeList = Model_esia::newgetNodeList($dbconnection,$user->getId(),$_GET['id'],Model_esia::NODE_INSTANCE);
    if($user->getDroits($dbconnection,"esia_maintenance") == 1)
    {
        if(!isset($_GET['view']))
        {
            try
            {
                 $smarty->assign('action', $_GET['action']);
                //suppression
                if($_GET['action']=='delete')
                {
                    if( is_numeric($_GET['planned_id']))
				    {
                    	Model_adm::deleteServiceMaintenancePlan($dbconnection,$_GET['planned_id']);
                    	$smarty->assign('maintenance_success',$lang['MAINTENANCE_PLAN_DELETE_SUCCESS']);
				    }
				    elseif(is_numeric($_GET['conf_id']))
				    {
					    Model_adm::deleteCyclicMaintenance($dbconnection, $_GET['conf_id']);
					    $smarty->assign('maintenance_success',$lang['MAINTENANCE_CYCLIC_DELETE_SUCCESS']);
				    }
                   	$_GET['view']='default';
                   	$smarty->assign('adm_group_id',$_GET['id']);
                }
                elseif($_GET['action']=='next')
                {
                	if(is_numeric($_GET['conf_id']))
                	{
                		Model_adm::passNextMaintenance($dbconnection, $_GET['conf_id']);
                		$smarty->assign('maintenance_success',$lang['MAINTENANCE_CYCLIC_NEXT_SUCCESS']);
                	}
                	$_GET['view']='default';
                	$smarty->assign('adm_group_id',$_GET['id']);
                }
                //AJout
                elseif(isset($_POST['id'])&&is_numeric($_POST['id']) )
                {
                    $starting = DateTime::createFromFormat('d/m/Y H:i',$_POST['datestart'].' '.$_POST['hour']);
                    $arr = array();
                    foreach($NodeList as $node)
                    {
                        $services = Model_esia::getServices($dbconnection,$node->getId());
                        foreach($services as $serv)
                        {
                            if(isset($_POST['maint_'.$serv['id']]))
                            {
                                $arr[] = $serv['id'];
                            }
                        }
                    }
                    //Ajout d'une nouvelle maintenance
                    if(isset($_POST['iscycle']))
                    {
                        $during = $_POST['during'].' '.$_POST['duringunity'];
                        $interval = $_POST['interval'].' '.$_POST['intervalunity'];
                        //maintenance cyclique
                        if($_POST['mode'] =='FIRSTERROR')
                        {
                        	$first = $_POST['firsterror'].' '.$_POST['firsterrorunity'];
                        	Model_adm::addCyclicMaintenance($dbconnection,$arr,$_POST['mode'], $starting,$during,$interval,$first );
                        }
                        else
                        {
                        	Model_adm::addCyclicMaintenance($dbconnection,$arr,$_POST['mode'], $starting,$during,$interval );
                        }
                    }
                    else
                    {
                        $format='P'.$_POST['during'];
                        switch($_POST['duringunity'])
                        {
                            case 'min': $format='PT'.$_POST['during'].'M'; break;
                            case 'hour': $format='PT'.$_POST['during'].'H'; break;
                            case 'day': $format.='D';break;     
                            case 'week': $format='P'.($_POST['during']*7).'D';break;          
                            default: $format.='M';break;
                        }
                        //maintenance OneSHOT
                        $interval = new DateInterval($format);
                        $end = clone $starting;
                        $end->add($interval);     
                        $first=0;
                        if($_POST['mode'] =='FIRSTERROR')
                        {
                        	$multi=1;
                        	switch($_POST['firsterrorunity'])
                        	{
                        		case 'hour':  $multi=60; break;
                        		case 'day':  $multi=60*24; break;
                        		case 'week':  $multi=60*24*7; break;
                        		case 'month':  $multi=60*24*7*30; break;
                        		default: $multi=1; break;
                        	}
                        	$first = $_POST['firsterror'] * $multi;
                        }
                        Model_adm::addServiceMaintenancePlan($dbconnection,$arr,$_POST['mode'], $starting,$end,$first);
                    } 
                    $smarty->assign('maintenance_success',$lang['MAINTENANCE_PLAN_SUCCESS']);
                    $_GET['view']='default';
                    $smarty->assign('adm_group_id',$_GET['id']);
                }
                if($_GET['action']=='nextmaintenance')
                {
                    $arrid = array();
                    foreach($NodeList as $node)
                    {
                         $arrid[]= $node->getId();
                    }
                    $services = Model_adm::getNextMaintenancePlan($dbconnection,null,$arrid);
                    $arr = array();
				    $typemaintenance_inv =array_flip($MAINTENANCE_MODE);
                    foreach($services as $serv)
                    {
                        $common_name = Model_esia::getCommonName($lang,$serv['service_name'],$serv['plugin_name']);
                        $tmp_start = preg_replace('#\+[0-9]*#','',$serv['start']);
                        $tmp_end = preg_replace('#\+[0-9]*#','',$serv['end']);
                        //conversion date
                        $start = DateTime::createFromFormat ('Y-m-d H:i:s',$tmp_start);                
                        $end = DateTime::createFromFormat ('Y-m-d H:i:s',$tmp_end);   
                        $now = new DateTime();
                        $isDeletable = 1;
                        if( ($start->getTimestamp() - $now->getTimestamp()) < 660 )
                        {
                             $isDeletable = 0;
                        }
                        $arr[] =array('id'=> $serv['id'],
                        				'name'=>$serv['service_name'],
                        				'common'=>$common_name,
                        				'type'=>$typemaintenance_inv[$serv['type']],
                        				'start'=>$start->format('d-m-Y H:i:s'),
                        				'end'=>$end->format('d-m-Y H:i:s'),
                        				'isdeletable' =>$isDeletable,
                        				'nodename'=> $serv['device_name'] );  
                    }
                    $smarty->assign('service_maintenance_plan',$arr);
                    $services = Model_adm::getCyclicMaintenancePlan($dbconnection,null,$arrid);
                    $arr = array();
                   // print_r($services);
                    foreach($services as $serv)
                    {
                        $common_name = Model_esia::getCommonName($lang,$serv['service_name'],$serv['plugin_name']);
                        $serv['start'] = preg_replace('#\+[0-9]*#','',$serv['start']);
                        $serv['start'] = preg_replace('#\.[0-9]*$#','',$serv['start']);
                        $serv['interval'] = replace_lang_var($serv['interval'],$lang);
                        $serv['during'] = replace_lang_var($serv['during'],$lang);
                        //conversion date
                        $start = DateTime::createFromFormat ('Y-m-d H:i:s',$serv['start']);                 
                        
                        $arr[] =array('id'=> $serv['id'],
                        			'name'=>$serv['service_name'],
                        			'common'=>$common_name,
                        			'type'=>$typemaintenance_inv[$serv['type']],
                                    'start'=>$start->format('d-m-Y H:i:s'),
                        			'interval'=>$serv['interval'],
                        			'during'=>$serv['during'],
                        			'nodename'=> $serv['device_name']);  
                    }
                    $smarty->assign('service_cyclic_maintenance_plan',$arr);        
                }
                else
                {
                    $arr = array();
                    foreach($NodeList as $node)
                    {
                        $services = Model_esia::getServices($dbconnection,$node->getId());
                        foreach($services as $serv)
                        {
                            $common_name = Model_esia::getCommonName($lang,$serv['name'],$serv['check_plugin_name']);
                            $arr[] =array('id'=> $serv['id'],'name'=>$serv['name'],'common'=>$common_name,'nodename'=> $serv['device_name']);
                        }
                    }
                    $smarty->assign('list_service',$arr);
                }
            }
            catch(EsiaDbException $e)
            {
	            //au niveux de la requête de la base de donnée cela arrive si on demande les infos d'un noeud qui n'existe pas
	            $smarty->assign('node_bad_access',$lang['NODE_NO_ACCESS']);
	            $smarty->assign('node_bad_access_1',$lang['NODE_NO_ACCESS_1']);
            }
        }
        //affiche les tabulations
        if($_GET['view']=='default')
        {
            $smarty->assign('show_menu', 'yes');
        }
    }
    //affichage de la page
    $temps = microtime();
    $temps = explode(' ', $temps);
    $fin = $temps[1] + $temps[0];

    // On affiche la différence entre des deux valeurs
    $smarty->assign('execute_time',round(($fin - $debut),6) );

    $smarty->display('action_group_maintenance.html');
}
elseif($_GET['category'] =='alert')
{
    if($user->getDroits($dbconnection,"esia_device") == 1)
    {
        if(!isset($_GET['action']))
        {
            $_GET['action'] ='view';
        }
        if( $_GET['action']=='update')
        {
            try 
            {
                $esialog = new EsiaLog(FILE_LOG,$user->getName());
	            if(!empty($_POST['formAlertingTable']))
	            {
	            	$arr = json_decode($_POST['formAlertingTable'],true);
	            	Model_adm::updateServiceProgramAlert($dbconnection, $arr);
	            	$esialog->write('ESIA ALERT', 'UPDATE SUCCESS ');
	            	$SUCCESS[] = $lang['ADM_USER_UPDATE_SUCCESS'];
	            }
            }
            catch(Exception $e)
            {
            	//suprime le message d'erreur duplicate key
            	if(preg_match('#.*pending_primary_key.*#', $e->getMessage()))
            	{
            		$esialog->write('ESIA ALERT', 'UPDATE SUCCESS ');
            		$SUCCESS[] = $lang['ADM_USER_UPDATE_SUCCESS'];
            	}
            	else
            	{
            		$esialog->write('ESIA ALERT', 'UPDATE FAILED '.$e->getMessage());
            		$ERROR[]=array('name'=>$lang['ADM_PLUGIN_SOFTWARE_ALERTING_UPDATE_FAILED'],'message'=>$e->getMessage());
            	}
            }
            $_GET['action']='view';    
        }
        $smarty->assign('action', $_GET['action']);
        $smarty->assign('SUCCESS', $SUCCESS);
        $smarty->assign('ERROR', $ERROR);
        $NodeList = Model_esia::newgetNodeList($dbconnection,$user->getId(),$_GET['id'],Model_esia::NODE_INSTANCE);
        $list = array();
        foreach($NodeList as $node)
        {
		    $plugins = Model_esia::getServices($dbconnection,$node->getId());
		    foreach($plugins as $service)
		    {
                    $common_name = Model_esia::getCommonName($lang,$service['name'],$service['check_plugin_name']);
			        $list[]=array('id'=>$service['id'],
                            'common'=>$common_name,
                            'nodename'=> $node->getName(),
					        'name'=>$service['name'],
					        'alert_prog_id'=>$service['alerting_program_id'],
					        'alert_prog_name'=>$service['alerting_program_name'],
                            'alert_prog_param'=>$service['alerting_program_parameter'],
                            'alert_prog_ok'=>$service['alerting_program_ok'],
                            'alert_prog_warning'=>$service['alerting_program_warning'],
                            'alert_prog_critical'=>$service['alerting_program_critical'],   
                            'alert_prog_unknown'=>$service['alerting_program_unknown']                           
			        );
            }
        }
        $smarty->assign('groupid', $_GET['id']);
        $smarty->assign('list_service', $list);
        //on récupère les programmes d'alertes
		$alerting = Model_esia::getAlertingSoftware($dbconnection);
		foreach ($alerting as $key => $program)
		{
            $alerting[$program['id']]['default_parameter'] = preg_replace('#\$USERMAIL#',$user->getEmail() ,$alerting[$program['id']]['default_parameter']);
        } 
        $smarty->assign('list_alerting', $alerting);
    }
    $smarty->display('action_group_alert.html');
}
function replace_lang_var($var , $lang )
{
	$tmp = preg_replace('#days#',$lang['DAYS'],$var);
	$tmp = preg_replace('#day#',$lang['DAY'],$tmp);
	$tmp = preg_replace('#mon#',$lang['MONTH'],$tmp);
	return $tmp;
}
?>

