<?php
/**
 * @name node_control
* @description script PHP appellé en AJAX, Affiche l'état des service ainsi que son historique ou celui du noeud
* @author Nicolas Biersart <n.biersart@esia-network.com>
* @contributor
* @copyright Nicolas Biersart 2012
* @license
* @esia 1.00
* @version 1.0.0
* @date 19/11/2012
*/
$temps = microtime();
$temps = explode(' ', $temps);
$debut = $temps[1] + $temps[0];

$path = $_SERVER['DOCUMENT_ROOT'];
include_once $path.'/common.php';
include_once $path.'/Model_adm.php';
include_once $path.'/Model_esia.php';
include_once $path.'/plugin/gesa/model_gesa.php';

if($user->getDroits($dbconnection,"esia_administration") ==1 && $user->getDroits($dbconnection,"esia_device") ==1)
{
	if($_POST['gesaid'] != 0 && !empty($_POST['name']))
	{
		$esialog = new EsiaLog(FILE_LOG,$user->getName());
		// Verifier si on doit remplacer UNITY
		if(isset($_POST["replaceUnity"])&&!empty($_POST["replaceUnity"]) && $_POST["replaceUnity"]!="none")
		{
		    try
		    {
		        $idNewUnity=$_POST['gesaid'];
		        $idOldUnity=$_POST["replaceUnity"];
		        if($idNewUnity!=$idOldUnity)
		        {
		            $listnodeofUnity = array();
		            $listnodeofUnity = Model_esia::replaceUnity($dbconnection,$idNewUnity,$idOldUnity);
		            foreach ($listnodeofUnity as $tuple)
		            {
		                Model_adm::reloadService($dbconnection,$tuple['idDevice']);
		            }
		        }
		    }
		    catch (EsiaDbException $e)
		    {
		        $smarty->assign('l_error',$e->getMessage());
		    }
		    catch(Exception $e)
		    {
		        $smarty->assign('l_error',$e->getMessage());
		    }
		    
		    try{
		        $node = Model_esia::InstanceNode($dbconnection,$_POST['replaceUnity']);
		        $node->setName($_POST['name']);
		        
		        if(!empty($_POST['description'])){
		          $node->setDescription($_POST['description']);
		        }
		          
		        if(!empty($_POST['nodegroup']))
		        {
		            $devgroup = $_POST['nodegroup'];
		            $node->setGroupList($devgroup);
		        }
		        
		        //mise à jour du noeud
		        Model_adm::updateDevice($dbconnection,$node);
		        $smarty->assign('gesasuccess',$_POST['gesaid']);
		    }
		    catch(EsiaDbException $e)
		    {
		        $smarty->assign('gesaerror_nodeid',$_POST['gesaid']);
		        $smarty->assign('gesaerror_nodename',$_POST['name']);
		        $smarty->assign('gesaerror_nodedesc',$_POST['description']);
		        $smarty->assign('adm_dev_list_group',$_POST['nodegroup']);
		        $err_treat=1;
		        $esialog->write('ESIA UNITY', 'INSERT_FAILED '.$e->getMessage());
		        $smarty->assign('gesaerror',$e->getMessage().'<br />'.$lang['ADM_SW_ADD_INSERT_DEVICE_FAILED']);
		    }
		}
		else
		{
    		try 
    		{
    			$node = Model_esia::InstanceNode($dbconnection,$_POST['gesaid']);
    			$node->setName($_POST['name']);
    			$node->setDescription($_POST['description']);
    			$devgroup=array();
    			if(isset($_POST['nodegroup'])&&!empty($_POST['nodegroup']))
    			{
    				$devgroup = $_POST['nodegroup'];
    			}
    			$node->setGroupList($devgroup);
    			//mise à jour du noeud
    			Model_adm::updateDevice($dbconnection,$node);
    			$esialog->write('ESIA UNITY', 'add gesa unity '.$node->getName().' success');
    			$smarty->assign('gesasuccess',$_POST['gesaid']);
    			//chemin d'accès au repertoire du plugin contenant les templates
    			$arr = Model_esia::getWebPlugin($dbconnection,false,'WEBP_IMPORT');
    			if(count($arr) > 0)
    			{
    				$smarty->assign('Webimport',$arr[0]);
    			}
    			
    			//ScanRapide n'a pas lieu si la gesa n'a pas d'ip locale
    			$scan=array();
    			$scan['type']='SNMP';
    			$scan['communities']='public,read';
    			
    			$gesa=Model_gesa::getInstanceGESA($dbconnection,$node->getID());
    			$gesa->constructDevice($node);
    			
    			$scan['agent'] = $gesa->getSerialNumber();
    			
    			$addr = $gesa->getLocalIPaddress();
    			$mask = '255.255.255.0';
    			
    			$int_addr = ip2long($addr);
    			$int_mask = ip2long($mask);
    			$int_net = $int_addr & $int_mask;
    			$int_bc = $int_addr | (~ $int_mask);
    						
    			//Si l'integer vaut 0, alors elle n'est pas définie, 3758096384 => 224.0.0.0
    			if( $int_net != 0 && $int_bc <= 3758096384){
    				$int_first = $int_net+1;
    				$int_last = $int_bc-1;
    			
    				$scan['firstaddr'] = long2ip($int_first);
    				$scan['endaddr'] = long2ip($int_last);
    				
    				$smarty->assign('scan',$scan);
    			}
    			
    			//Ajout plugin gesa_health
    			try{
    				$result = Model_esia::getServices($dbconnection,$node->getID());
    				$is_present = false;
    				foreach($result as $plugin)
    				{
    					if($plugin['name'] == 'GESA_HEALTH')
    					{
    						$is_present=true;
    						break;
    					}
    				}
    				//is_present informe si le plugin est déjà appliqué sur le noeud de la unity
    				if($is_present==false)
    				{
    					$srv_fields = array_shift(Model_esia::getPlugin($dbconnection,'GESA_HEALTH'));
    					$srv_fields['parameter'] = "-S ".$gesa->getSerialNumber()." -p 5666 -c check_gesa -t 50";
    					Model_adm::addService(
    							$dbconnection,
    							$srv_fields['name'],
    							$srv_fields['id'],
    							$node->getID(),
    							$srv_fields['interval_time'],
    							$srv_fields['parameter'],
    							$srv_fields['priority'],
    							null,null,null,null,null
    							);
    				}
    			}
    			catch(Exception $ex){
    				$warnings[]=sprintf($lang['IMPORT_HOSTS_ADD_PLUGIN_ERROR'],ICMP_PLUGIN_NAME,$ex->getMessage());
    			}
    		}
    		catch(EsiaDbException $e)
    		{
    			$smarty->assign('gesaerror_nodeid',$_POST['gesaid']);
    			$smarty->assign('gesaerror_nodename',$_POST['name']);
    			$smarty->assign('gesaerror_nodedesc',$_POST['description']);
    			$smarty->assign('adm_dev_list_group',$_POST['nodegroup']);
    			$err_treat=1;
    			$esialog->write('ESIA UNITY', 'INSERT_FAILED '.$e->getMessage());
    			$smarty->assign('gesaerror',$e->getMessage().'<br />'.$lang['ADM_SW_ADD_INSERT_DEVICE_FAILED']);
    		}
    		
    	}
	}
	$gesas = Model_esia::getNewGesa($dbconnection,$user->getId(),true);
	$arr = array();
	
	$newGesasKeys = array();
	foreach($gesas as $gesa)
	{
	    $newGesasKeys[$gesa->getId()] = true;
		$arr[]=array('id'=>$gesa->getId(),
					 'name'=>$gesa->getName(),
					'sn'=>$gesa->getSerialNumber(),
				 	 'ip'=>$gesa->getLocalIPaddress(),
				     'Remoteip'=>$gesa->getIPAddress(),
					'MacAddress'=>$gesa->getMacAddress(),
					'type'=>$gesa->getGesaType(),
					
		);
	}
	$smarty->assign('gesa_new_connected',null);
	$smarty->assign('gesas',$arr);

	//on va rechercher les groupes de noeuds
	$arr = Model_esia::getGroupDevice($dbconnection);
	//echo'<pre>'; print_r($arr); echo '</pre>';
	$select =array();
	foreach($arr as $top)
	{
		$select[]=array('id'=>$top['id'],'name'=>$top['fullpath']);
	}
	$smarty->assign('adm_nodegroup', $select);
	//print_r($gesa);
		
	$query = Model_esia::getNodebyType($dbconnection,null,'gesa');
	$list=array();
	foreach ($query as $tuple)
	{
	    if(empty($newGesasKeys[$tuple->getId()])){
		$list[]=array('id'=>$tuple->getId(),
						'name'=>$tuple->getName(),);
	    }
	}
	
	$smarty->assign('ListUnity', $list);
}
else
{
	
}


//affichage de la page
$temps = microtime();
$temps = explode(' ', $temps);
$fin = $temps[1] + $temps[0];

if(!$user->isFinishingTutoriel(2)) {
	$smarty->assign('seeTutos',2);
}
if(!$user->isFinishingTutoriel(3)) {
	$smarty->assign('seeTutosnext',3);
}


// On affiche la différence entre des deux valeurs
$smarty->assign('execute_time',round(($fin - $debut),6) );
$smarty->display('addNewGesa.html');
?>
