#!/usr/bin/php
<?php

$time_first = time();
$time_date = date('d-m H:i');

$options = getopt("f:c:D");
$ini_conf=array();
if(!empty($options["c"]))
{
	$_SERVER['DOCUMENT_ROOT'] = $options["c"];
	$configfile = $_SERVER['DOCUMENT_ROOT'].'/esia.conf.php';
}
else
{
	$configfile = '/usr/local/esia/public_html/esia.conf.php';
	$_SERVER['DOCUMENT_ROOT']='/usr/local/esia/public_html/';
}
if(file_exists($configfile)===FALSE)
{
	echo "Configuration file not exist $configfile\n";
	exit(1);
}
$DEBUG=FALSE;
if(isset($options["D"]))
{
	$DEBUG=TRUE;
}
$flow = null;
if(!empty($options["f"]))
{
	$flow = $options["f"];
}
include_once $configfile;
include_once MVCMODEL;
include_once $_SERVER['DOCUMENT_ROOT'].'/Model_adm.php';
try
{
    echo "Connexion base de donnée\n";
    //connection à la base de donnée
    try
    {
	    $dbconnection = new PDO('pgsql:host='.DB_HOST.';port='.DB_PORT.';dbname='.DB_NAME, DB_USERNAME, DB_PWD);
	    $dbconnection->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_WARNING);
    }
    catch(Exception $e)
    {
	    echo 'PDO SQL ERROR: '.$e->getMessage().'<br />';
	    echo 'N° : '.$e->getCode();
        exit(1);
    }
    $MAXDAY = Model_esia::getConfiguration($dbconnection,'RSS_PURGE_MESSAGE');
    $MAXDAY = $MAXDAY['RSS_PURGE_MESSAGE']['value'];
    
$arrContextOptions=array(
    "ssl"=>array(
        "verify_peer"=>false,
        "verify_peer_name"=>false,
    ),
);  
    $sqlinsert = "INSERT INTO rss_message(message_title, message_description, message_link, message_author, message_image, message_channel_id,message_date_publish, message_sign)
	              SELECT :title,:descr,:link,:author,:path,:chanid,:datepublish,:sign
                  WHERE NOT EXISTS( SELECT message_id FROM rss_message WHERE message_sign=:checksign)";
	$queryinsert= $dbconnection->prepare($sqlinsert);
	$channels = Model_esia::getRSSChannel($dbconnection,$flow,'REMOTE');
    foreach($channels as $chan)
    {
    	try 
    	{
	    	if(!empty($chan['url']) && $chan['enable'] ==1)
	    	{
	    		Trace($DEBUG,$chan);
	    		Trace($DEBUG,"GET ".$chan['url']);
	    		$content=FALSE;
	    		// FORCE DU MAL SI on se masque pas comme un navigateur:
	    		// Error 403: permission denied pour DEll, 
	    		// Protocol error HTTP2 pour HP
	    		// connection timeout pour APC
	    		if(preg_match('#hpe.com|apc.com|dell.com#',$chan['url']))
	    		{
	    			Trace($DEBUG,"MASK FIREFOX ");
	    			$ch = curl_init();
	    			curl_setopt($ch, CURLOPT_URL, $chan['url']);
	    			curl_setopt($ch, CURLOPT_HTTP_VERSION, CURL_HTTP_VERSION_2);
	    			curl_setopt($ch, CURLOPT_USERAGENT,'Mozilla/5.0 (X11; Linux x86_64; rv:109.0) Gecko/20100101 Firefox/116.0');
	    			curl_setopt($ch, CURLOPT_ENCODING, 'gzip, deflate');
	    			curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
	    			curl_setopt($ch, CURLOPT_HTTPHEADER,array(
	    				'Accept: text/html,application/xhtml+xml,application/xml;q=0.9,*/*;q=0.8',
	    				'Accept-Language: en-US,en;q=0.5',
	    				'Connection: keep-alive',
	    				'Upgrade-Insecure-Requests: 1',
	    			));
	    			$content = curl_exec($ch);
	    			curl_close($ch);
	    		}
	    		else 
	    		{
		        	$content = @file_get_contents($chan['url'], false, stream_context_create($arrContextOptions));
	    		}
		        if( $content===FALSE)
		        {
		        	$err = error_get_last();
		        	Trace($DEBUG,$err);
		        	if(preg_match('#426 Upgrade Required#',$err['message']) || preg_match('#HTTP request failed#',$err['message']))
		        	{
		        		Trace($DEBUG,"passage HTTP2");
		        		$ch = curl_init();
		        		curl_setopt($ch, CURLOPT_URL, $chan['url']);
		        		curl_setopt($ch, CURLOPT_HTTP_VERSION, CURL_HTTP_VERSION_2);
		        		curl_setopt($ch, CURLOPT_HTTPGET, true);
		        		curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
		        		$content = curl_exec($ch);
		        		curl_close($ch);
		        	}
		        }
		        echo "Récupération du channel ".$chan['name'];
		       // Trace($DEBUG,$content);
		        if(preg_match('#<\/rss>(\s.*)$#', $content))
		        {
		        	$content = preg_replace('#<\/rss>(\s.*)$#','</rss>',$content);
		        }
		        Trace($DEBUG,$content);
		        $sxe = new SimpleXMLElement(trim($content), LIBXML_NOCDATA);
		        if (property_exists($sxe, 'channel')) 
		        {
		        	echo " RSS FORMAT\n";
		        	$items = $sxe->channel->item;
		        	if(count($items)==0)
		        	{
		        		
		        		$items = $sxe->item;
		        	}
		        	$image="";
		        	if(empty($chan['image'])&& property_exists($sxe->channel, 'image'))
		        	{
		        		$path_data_logo='/data/rss/image/';
		        		$tmppath = $chan['name'].'_'.$chan['id'];
		        		$tmppath = preg_replace('#\s+#','_',$tmppath);
		        		$tmppath = preg_replace('#\/#','_',$tmppath);
		        		$tmppath = urlencode($tmppath);
		        		$tmppath= $path_data_logo.$tmppath;
		        		Trace($DEBUG, "IMAGE: file save to: ".$_SERVER['DOCUMENT_ROOT']."$tmppath");
		        		if(empty(glob($_SERVER['DOCUMENT_ROOT']."$tmppath.*"))) // Si elle n'existe pas déjà
		        		{
		        			$img=null;
		        			Trace($DEBUG,"IMAGE download url: ".(string)$sxe->channel->image->url);
		        			if(preg_match('#hpe.com|apc.com|dell.com#',$chan['url']))
		        			{
		        				Trace($DEBUG,"IMAGE: MASK FIREFOX ");
		        				$ch = curl_init();
		        				curl_setopt($ch, CURLOPT_URL, (string)$sxe->channel->image->url);
		        				curl_setopt($ch, CURLOPT_HTTP_VERSION, CURL_HTTP_VERSION_2);
		        				curl_setopt($ch, CURLOPT_USERAGENT,'Mozilla/5.0 (X11; Linux x86_64; rv:109.0) Gecko/20100101 Firefox/116.0');
		        				curl_setopt($ch, CURLOPT_ENCODING, 'gzip, deflate');
		        				curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
		        				curl_setopt($ch, CURLOPT_HTTPHEADER,array(
		        					'Accept: text/html,application/xhtml+xml,application/xml;q=0.9,*/*;q=0.8',
		        					'Accept-Language: en-US,en;q=0.5',
		        					'Connection: keep-alive',
		        					'Upgrade-Insecure-Requests: 1',
		        				));
		        				$img = curl_exec($ch);
		        				curl_close($ch);
		        			}
		        			else 
		        			{
		        				$img =  file_get_contents((string)$sxe->channel->image->url);
		        			}
		        			$filename = file_put_contents($_SERVER['DOCUMENT_ROOT']."$tmppath", $img);
							//Test des extentions
							$ext='svg';
							//exec()
							$meta  = mime_content_type($_SERVER['DOCUMENT_ROOT']."$tmppath");
							
							Trace($DEBUG,"IMAGE: ".print_r($meta,true));
							if($meta !==false)
							{
		        				$base = array("image/jpeg"=>"jpg",
		        					"image/jpg"=>"jpg",
		        					"image/JPG"=>"jpg",
		        					"image/png"=>"png",
		        					"image/gif"=>"gif",
		        					"image/vnd.microsoft.icon"=>"ico",
		        					"image/ico"=>"ico",
		        					"image/bmp"=>"bmp",
									"image/webp"=>"webp");
		        				if(array_key_exists($meta, $base))
		        				{
		        					$ext=$base[$meta];
		        				}
							}
							Trace($DEBUG,"IMAGE: file = ".$_SERVER['DOCUMENT_ROOT']."$tmppath.$ext");
							rename($_SERVER['DOCUMENT_ROOT']."$tmppath",$_SERVER['DOCUMENT_ROOT']."$tmppath.$ext");
							$image = "$tmppath.$ext";
		        		}
		        	}
		        	if(empty($chan['description']) || !empty($image))
		        	{
		        		$language = (string)$sxe->channel->language;
		        		$description= (string)$sxe->channel->description;
		        		$description = mb_convert_encoding($description, "UTF-8");
		        		$rss_category=array();
		        		Trace($DEBUG,"CATEGORY:");
		        		foreach($sxe->channel->category as $cat)
		        		{
		        			$rss_category[]=(string)$cat;
		        		}
		        		Trace($DEBUG,$rss_category);
		        		$rrs_array=array();
		        		foreach($rss_category as $cat)
		        		{
		        			$id = Model_esia::getRSSCategory($dbconnection,$cat);
		        			if(empty($id))
		        			{
		        				$id = model_adm::addRSSCategory($dbconnection, $cat, "");
		        				$rrs_array[]=$id;
		        			}
		        			else
		        			{
		        				$rrs_array[]=$id[0]['id'];
		        			}
		        		}
		        	//	print_r($rrs_array);
		        	//	exit(0);
		        	
		        		Model_adm::updateRSSChannel($dbconnection, $chan['id'],$chan['name'], $description, 'REMOTE', $chan['url'], $language, $image, 1, $rrs_array);
		        		
		        	}
		        	foreach($items as $message)
			        {
			        	$date=(string)$message->pubDate;
			        	if(empty($date))
			        	{
			        		$date= new DateTime();
			        		$date->setTimezone(new DateTimeZone('GMT'));
			        		$date =$date->format(DateTimeInterface::RSS);
			        	}
			        	$writedate = new DateTime($date);
			        	$now = new DateTime();
			        	$now = $now->sub(new DateInterval('P'.$MAXDAY.'D'));
			        	if($writedate < $now )
			        	{
			        		Trace($DEBUG,"SKYP ".$message->title." date ".$date);
			        		continue;
			        	}
			        	$sign = $message->title.$chan['id'].$date;
			            $sign = sha1($sign);
			            $image = "";
			            if(!empty($message->image))
			            {
			            	$image=$message->image;
			            }
			            $rsscategory = "";
			     
			            if(!empty($message->category))
			            {
			            	$rsscategory=$message->category;
			            }
			            
			            $description="";
			            if(!empty($message->description))
			            {
			            	$description=$message->description;
			            }
			            Model_adm::addMessage($dbconnection, $chan['id'], 
			            						$message->title, 
			            						$description, 
			            						$message->link, 
			            						$message->author, 
			            						$image, 
			            						$rsscategory,
			            						$sign,
			            						$date
			            						);
			            //echo $message->title."\n";
			        }
		        }
		        else 
		        {
		        	if(empty($chan['description']))
		        	{
		        		$language ="";
		        		$description= (string)$sxe->title;
		        		$description= $description.(string)$sxe->subtitle;
		        		$description = mb_convert_encoding($description, "UTF-8");
		        		$rss_category= "";
		        		Model_adm::updateRSSChannel($dbconnection, $chan['id'],$chan['name'], $description, 'REMOTE', $chan['url'], $language, $image, 1, $rss_category);
		        	}
		        	//On passe en FORMAT ATOM
		        	foreach($sxe->entry as $message)
		        	{
		        		$date = (string)$message->published;
		        		if(empty($date))
		        		{
		        			$date = $message->updated;
		        		}
		        		$writedate = new DateTime($date);
		        		$now = new DateTime();
		        		$now = $now->sub(new DateInterval('P90D'));
		        		if($writedate < $now )
		        		{
		        			Trace($DEBUG,"SKYP ".$message->title." date ".$date);
		        			continue;
		        		}
		        		$sign = $message->title.$chan['id'].$date;
		        		$sign = sha1($sign);
		        		$image = "";
		        		if(!empty($message->image))
		        		{
		        			$image=$message->image;
		        		}
		        		$rsscategory = "";
		        		if(!empty($message->category))
		        		{
		        			$rsscategory=$message->category;
		        		}
		        		$description="";
		        		if(!empty($message->summary))
		        		{
		        			$description=$message->summary;
		        		}
		        		$link = $message->link;
		        		if(!empty($link))
		        		{
		        			$attr = $message->link['href'][0];
		        			$link = $attr[0];
		        		}
		        		$author="";
		        		if(!empty($message->author->name))
		        		{
		        			$author=$message->author->name;
		        		}
		        		Model_adm::addMessage($dbconnection, $chan['id'],
		        			$message->title,
		        			$description,
		        			$link,
		        			$author,
		        			$image,
		        			$rsscategory,
		        			$sign,
		        			$date
		        			);
		        		//echo $message->title."\n";
		        	}
		        }
		        
    		}
    	} 
    	catch(NewsException $e) 
    	{
    		echo "CHANNEL ".$chan['name']."EXCEPTION: ".$e->getMessage()."\n";
    	}
    	catch(securityException $e)
    	{
    		echo "CHANNEL ".$chan['name']."EXCEPTION: ".$e->getMessage()."\n";
    	}
    	catch(Exception $e)
    	{
    		
    		echo "CHANNEL ".$chan['name']."EXCEPTION: ".$e->getMessage()."\n";
    	}
    }
 	//CLEAN OLD MESSAGE
    Model_adm::purgeRSSOldMessage($dbconnection,$MAXDAY);
}
catch(Exception $e)
{
    echo "EXCEPTION: ".$e->getMessage()."\n";
}
exit(0);
function Trace($debug,$msg)
{
	if($debug)
	{
		if(is_array($msg))
		{
			print_r($msg);
		}
		else 
		{
			echo "DEBUG: $msg\n";
		}
	}
}
?>
