<?php

$path = $_SERVER['DOCUMENT_ROOT'];
include_once $path.'/common.php';
include_once $path.'/Model_adm.php';

$esia_type = Model_esia::getConfiguration($dbconnection,'ESIA_TYPE');
$smarty->assign('esia_type',$esia_type['ESIA_TYPE']['value']);

$esialog = new EsiaLog(FILE_LOG,$user->getName());

if($user->getDroits($dbconnection,"esia_device") ==1)
{
	include_once DEVICE_CLASS;
	include_once MVCMODEL;
	include_once $path.'/libs/logo_oid.hash.php';
	try
	{
		if(isset($_GET['action']))
		{
			$action = $_GET['action'];
		}
		$dev = new Device();
		if($action=="treat_create")
		{
			//le noeud doit avoir une IP
			if(isset($_POST['ip'])&&!empty($_POST['ip'])) $tip = $_POST['ip'];
			else $tip="0.0.0.0";
			$tip = preg_replace('#\s+#','',$tip);
			$dev->setIPAddress($tip);
			//le noeud doit avoir un nom
			if(isset($_POST['name'])&&!empty($_POST['name']))
			{
				$dev->setName($_POST['name']);
				try
				{
					$devgroup=array();
					if(isset($_POST['nodegroup'])&&!empty($_POST['nodegroup']))
						$devgroup = $_POST['nodegroup'];
					$dev->setGroupList($devgroup);include_once $path.'/libs/logo_oid.hash.php';
					//ancien système de groupe regarder pour supprimer dans le futur
					if(isset($_POST['groupe'])&&!empty($_POST['groupe']))
						$dev->setgroup(strtolower($_POST['groupe']));
					$dev->setType('application');
					$_POST['type']='application';
					$dev->setDescription($_POST['description']);
					//Ajout du noeud
					$dev->setId(Model_adm::addNode($dbconnection,$dev));
					$esialog->write('ESIA NODE', 'add node '.$dev->getName().' success');
					//Mise à jour des droits d'accès (groupe root)
					Model_adm::addDeviceInDefaultGroup($dbconnection,$dev);
					$esialog->write('ESIA NODE', 'addDeviceInDefaultGroup '.$dev->getName().' success');
					$smarty->assign('adm_sw_insert_grp_OK', 'SUCCESS');
					//redirection si il y a un plugin web pour ce type de noeud
					$type = Model_esia::getWebPluginByNodeType($dbconnection, $_POST['type']);
					$smarty->assign('l_adm_insert_success', $lang['ADM_INSERT_SUCCESS']);
					//PARTIE SERVICE
					try
					{
						//on ajout ou modifie un service
						$warning='FALSE';
						$critical='FALSE';
						$unknown='FALSE';
						$ok='FALSE';
						if(!empty($_POST['unknown'])) $unknown='TRUE';
						if(!empty($_POST['warning'])) $warning='TRUE';
						if(!empty($_POST['critical'])) $critical='TRUE';
						if(!empty($_POST['ok'])) $ok='TRUE';
												
						if(isset($_POST['paramAlerting']) && !empty($_POST['paramAlerting']))
						{
							$_POST['alerting_parameter'] = $_POST['paramAlerting'];
						}
						$_POST['interval']=300000;
						
						$plugin_application = Model_esia::getPlugin($dbconnection,'CORR_APPLICATION');
						Model_adm::addService($dbconnection,$_POST['name'],$plugin_application[0]['id'],$dev->getId(),$_POST['interval'],"-w ".$_GET['widget']." -u ".$user->getID(),3,$_POST['alerting'],$_POST['alerting_parameter'],$unknown,$warning,$critical,$ok);
						$esialog->write('ESIA SERVICE', 'ADD '.$_POST['name'].' on node id'.$dev->getId());
						$smarty->assign('l_adm_add_plugin_success',$lang['ADM_PLUGIN_ADD_SUCCESS']);
					
					}
					catch(EsiaDbException $e)
					{
						$esialog->write('ESIA SERVICE','INSERT/UPDATE FAILED '.$e->getMessage());
						$ERROR[]=array('name'=>'INSERT/UPDATE SERVICE ERROR','message'=>$e->getMessage());
						$id=$dev->getId();
					}
					$smarty->assign('adm_device', $dev);
				}
				catch(DeviceException $e)
				{
					$ERROR[]=array('name'=>'CONNECTION_FAILED','message'=>$e->getMessage());
					$smarty->assign('adm_connection_FAILED', $e->getMessage());
					$err_treat=1;
				}
				catch(EsiaDbException $e)
				{
					$err_treat=1;
					$esialog->write('ESIA NODE', 'INSERT_FAILED '.$e->getMessage());
						
					if(preg_match("/device_name_unique/",$e->getMessage()))
					{
						$ERROR[]=array('name'=>'INSERT_NODE_FAILED','message'=>$lang['ADM_INSERT_DEVICE_FAILED_DUPLICATE_NAME']);
					}
					else
					{
						$ERROR[]=array('name'=>'INSERT_NODE_FAILED','message'=>$e->getMessage().'<br />');
					}
				}
			}
		}
		if($action=='success_assign')
		{
			$smarty->assign('adm_success_nodeid',$dev->getId());
		}
		if($action=="create" && isset($_GET['widget']) &&!empty($_GET['widget']))
		{
			//on veut ajouter un noeud virtuel
			$smarty->assign('adm_dev', 'create');
			$smarty->assign('adm_dev_list_group',array());
			$smarty->assign('user_mail',$user->getEmail());
	
			$smarty->assign('widget',$_GET['widget']);
			//on récupère les programmes d'alertes
			try{
				$alerting = Model_esia::getAlertingSoftware($dbconnection);
				foreach ($alerting as $k=>$programAlert)
				{
					$alerting[$programAlert['id']]['default_parameter'] = preg_replace('#\$USERMAIL#',$user->getEmail() ,$alerting[$programAlert['id']]['default_parameter']);
				}
			}
			catch(Exception $e)
			{
				echo "Error : ".$e->getMessage()."\n";
			}
			catch(EsiaDbException $e)
			{
				$ERROR[]=array('name'=>'DB ERROR','message'=>$e->getMessage());
			}
			$smarty->assign('list_alerting', $alerting);
			//on va rechercher les groupes de noeuds
	
			$arr = Model_esia::getGroupDevice($dbconnection,null,$user->getId());
			$select =array();
			foreach($arr as $top)
			{
				$select[]=array('id'=>$top['id'],'name'=>$top['fullpath']);
			}
			$smarty->assign('adm_nodegroup', $select);
		}
	}
	catch(Exception $e)
	{
		$ERROR[]=array('name'=>'Unknown Error','message'=>$e->getMessage());
	}
}

$smarty->display($path.'/dashboard/template/add_virtual_node.html');
?>
