<?php
/*DESCRIPTION: inclus les variables habituelles pour la gestion d'une widget et vérifie les droits d'accès
 *APRES l'inclusion du common_widget les variables suivantes sont créées:
 *PHP:
 *      $action l'action passé dans l'url ou 'view'
 *      $widget un tableau associatif reprenant les paramètre de la widget
 * SMARTY
 *      $widget les informations de la widget
 *      $parameter les parametre de la widget (JSON)
 *      $action l'action passé dans l'url ou 'view'
 */
include("./common_widget.php");
$params=$widget['option'];
$NodeId_or_GroupNodeId=array();
if(isset($params['nodeid']))
{
    foreach($params['nodeid'] as $val)
    {
        $NodeId_or_GroupNodeId[] = array('id'=>$val);
    }
}
elseif(isset($params['groupnodeid']))
{
    $arrid=array();
    foreach ($params['groupnodeid'] as $groupnode )
    {
        $arrid[] = $groupnode;
    }
    $tab_group_node = Model_esia::getAllNodeofGroup($dbconnection,$user->getId(),$arrid);
    foreach ($tab_group_node as $node)
    {
        $NodeId_or_GroupNodeId[] = array('id'=>$node->getId(),'parent'=>$node->getGroup(),'idgroup'=>$node->getGroupId());
    }
}
if($action =='update')
{
    if(isset($_POST['widgetid'])&&!empty($_POST['widgetid']))
    {
        try
        {
            $widget = getPostDefaultParams($widget,$_POST);
            $params = $widget['option'];
            //Option des noeuds
            if(isset($params['nodeid']))
            {
                if($_POST['select_elem']!=null)
                {
                    $params['nodeid']=$_POST['select_elem'];
                }
                else
                {
                    $params['nodeid']=array();
                }
            }
            elseif(isset($params['groupnodeid']))
            {
                if($_POST['select_elem']!=null)
                {
                    $params['groupnodeid']=$_POST['select_elem'];
                }
                else
                {
                    $params['groupnodeid']=array();
                }
            }
            elseif(isset($params['pluginid']))
            {
                if($_POST['select_elem']!=null)
                {
                    $params['pluginid']=$_POST['select_elem'];
                }
                else
                {
                    $params['pluginid']=array();
                }
            }
            elseif(isset($params['service']))
            {
                if($_POST['services']!=null)
                {
                    $params['service']=$_POST['services'];
                }
                else
                {
                    $params['service']=array();
                }
            }
            if(isset($_POST['check_unknown']))
            {
                $params['show_unknown']='unknown';
                $params['show_pending']='pending';
            }
            else
            {
                $params['show_unknown']='none';
                $params['show_pending']='none';
            }
            if(isset($_POST['check_blink']))
            {
                $params['blink']='blink';
            }
            else
            {
                $params['blink']='none';
            }
            $params['type'] = $_POST['type'];
            $params['service_or_node'] = $_POST['service_or_node'];
            $params['all_service'] = $_POST['all_service'];
            $params['all_node'] = $_POST['all_node'];

            Model_esia::updateWidget($dbconnection, $widget['id'], $widget['name'], $widget['description'], $widget['during'], $params);
            $smarty->assign('l_success',$lang['UPDATE_DASHBOARD_SUCCESS']);
            $smarty->assign('widget',$widget);
        }
        catch(Exception $e)
        {
            $smarty->assign('l_error',$e->getMessage());
        }
    }
    //recupération des styles
    $title = getWidgetStyle($params['title']['style'],14,'left','#575759');
    $description = getWidgetStyle($params['description']['style'],12,'left','#575759');
    $smarty->assign('titlestyle',$title);
    $smarty->assign('descriptionstyle',$description);
    $smarty->assign('type',$params['type']);
    $smarty->assign('service_or_node',$params['service_or_node']);
    $smarty->assign('all_node',$params['all_node']);
    $smarty->assign('all_service',$params['all_service']);
    if(empty($params['show_unknown']))
    {
        $params['show_unknown']='unknown';
        $params['show_pending']='pending';
    }
    $smarty->assign('check_pending',$params['show_pending']);
    $smarty->assign('check_unknown',$params['show_unknown']);

    $list=array();
    if(isset($params['nodeid']))
    {
        //Récupération des noeuds
        $nodes = Model_esia::getNodeList($dbconnection,$user->getId(),null,Model_esia::NODE_INSTANCE);
        if($params['all_node']=='on' || $params['all_service']=='on')
        {
            foreach($nodes as $node)
            {
                $list[]=array('id'=>$node->getId(),
                    'name'=>$node->getGroup().'>'.$node->getName(),
                    'selected'=>'yes'
                );
            }
        }
        else
        {
            foreach($nodes as $node)
            {
                $selected='no';
                if(in_array($node->getId(),$params['nodeid']))
                {
                    $selected='yes';
                }
                $list[]=array('id'=>$node->getId(),
                    'name'=>$node->getGroup().'>'.$node->getName(),
                    'selected'=>$selected
                );
            }
        }
        $smarty->assign('title',$lang['DASHBOARD_NODE_LINKED']);
        $smarty->assign('descr',$lang['DASHBOARD_SELECT_NODE']);
    }
    elseif(isset($params['groupnodeid']))
    {
        $group_node = Model_esia::getNodeGroupHierarchyByUser($dbconnection,$user->getId());
        if($params['all_node']=='on' || $params['all_service']=='on')
        {
            foreach($group_node as $node)
            {
                $list[]=array('id'=>$node['id'],
                    'name'=>$node['name'],
                    'selected'=>'yes');
            }
        }
        else
        {
            foreach($group_node as $node)
            {
                $selected='no';
                if(in_array($node['id'],$params['groupnodeid']))
                {
                    $selected='yes';
                }

                $list[]=array('id'=>$node['id'],
                    'name'=>$node['name'],
                    'selected'=>$selected);
            }
        }
        $smarty->assign('descr',$lang['DASHBOARD_SELECT_GROUP_NODE']);
        $smarty->assign('title',$lang['DASHBOARD_GROUP_NODE_LINKED']);
    }
    elseif(isset($params['pluginid']))
    {
        //Récupération des plugins
        $plugins = Model_esia::getPlugin($dbconnection);
        $list=array();
        foreach($plugins as $plugin)
        {
            $selected='no';
            if(in_array($plugin['id'],$params['pluginid']))
            {
                $selected='yes';
            }
            $list[]=array('id'=> $plugin['id'],
                'name'=>$plugin['name'],
                'selected'=>$selected
            );
        }
        $smarty->assign('descr',$lang['PLUGINS']);
        $smarty->assign('title',$lang['DASHBOARD_PLUGIN_LINKED']);
    }
    //Récupération des services
    elseif(isset($params['service']))
    {
        if(!empty($params['service']))
        {
            $services = Model_esia::getServices($dbconnection,null,$params['service']);
            foreach($services as $ser)
            {
                if(!in_array($ser['device_id'],$listnode))
                {
                    $listnode[]=$ser['device_id'];
                }
                $listservice[]=$ser['id'];
            }
            $smarty->assign('serviceid',$listservice);
        }
        $nodes = Model_esia::getNodeList($dbconnection,$user->getId(),null,Model_esia::NODE_INSTANCE);
        foreach($nodes as $node)
        {
            $selected='no';
            if(in_array($node->getId(),$listnode))
            {
                $selected='yes';
            }
            $list[]=array('id'=>$node->getId(),
                'name'=>$node->getGroup().'>'.$node->getName(),
                'selected'=>$selected

            );
        }
        $smarty->assign('descr',$lang['DASHBOARD_NODE_LINKED']);
        $smarty->assign('title',$lang['DASHBOARD_SELECT_NODE']);
    }
    $smarty->assign('dash_list_select', $list);
}
elseif($action =="getservice")
{
    if(isset($_GET['nodeid']))
    {
        $tablenodeid = json_decode($_GET['nodeid']);
        $list=array();
        foreach($tablenodeid as $nodeid)
        {
            $node = Model_esia::InstanceNode($dbconnection, $nodeid);
            if($user->getAccess($dbconnection, "device_view",$node->getName())==1)
            {
                $services = Model_esia::getServices($dbconnection,$node->getId());
                foreach ($services as $service)
                {
                    $common_name = Model_esia::getCommonName($lang, $service['name'],$service['check_plugin_name']);
                    $list[$service['id']]=$node->getName().' > '.$common_name;
                }
            }
        }
        echo json_encode($list);
        exit(0);
    }
}
elseif($action =='getInfo')
{
    $errors = array();
    if($params['all_node']=='on' || $params['all_service']=='on')
    {
        $AllNode = Model_esia::getNodeList($dbconnection,$user->getId(),null,Model_esia::NODE_INSTANCE);
        foreach($AllNode as $node)
        {
            $arrerr = model_esia::getNodeError($dbconnection,$node->getId(),null,$_GET['status']);
            $i = 0;

            foreach($arrerr as $err)
            {
                $common_name = Model_esia::getCommonName($lang, $err['service'],$err['plugin_name']);
                $arrerr[$i]["common"]= $common_name;
                $i++;
            }
            $errors[]= $arrerr;
        }
    }
    elseif(isset($params['pluginid']))
    {
        $listerr=array();
        foreach($params['pluginid'] as $plugin)
        {
            $arrerr = Model_esia::getPluginByCurrentState($dbconnection,$plugin,$_GET['status']);
            foreach($arrerr as $err)
            {
                $common_name = Model_esia::getCommonName($lang, $err['service'],$err['plugin_name']);
                $listerr[] = array('common'=>$common_name,
                    'error'=>$err['type'],
                                    'type'=>$err['type'],
                                    'message'=>$err['message'],
                                    'device'=>$err['device_name'],
                                    'plugin_name'=>$err['plugin_name']
                );

            }
        }
        $errors[]= $listerr;
    }
    elseif(isset($params['service']))
    {
        $errors = array();
        foreach($params['service'] as $service)
        {
            $arrerr = model_esia::getServiceByCurrentState($dbconnection,$service,$_GET['status']);
            $i = 0;
            foreach($arrerr as $err)
            {
                $common_name = Model_esia::getCommonName($lang, $err['service'],$err['plugin_name']);
                $arrerr[$i]["common"]= $common_name;
                $i++;
            }
            $errors[]= $arrerr;
        }
    }
    else
    {
        foreach($NodeId_or_GroupNodeId as $node)
        {
            $arrerr = model_esia::getNodeError($dbconnection,$node['id'],null,$_GET['status']);
            $i = 0;

            foreach($arrerr as $err)
            {
                $common_name = Model_esia::getCommonName($lang, $err['service'],$err['plugin_name']);
                $arrerr[$i]["common"]= $common_name;
                $i++;
            }
            $errors[]= $arrerr;
        }
    }
    $serviceError=0;
    foreach($errors as $error)
    {
        foreach($error as $service)
        {
            $serviceError++;
        }
    }

    $smarty->assign('serviceError',$serviceError);
    $smarty->assign('errors',$errors);
}
elseif($action =='getInfoDonut')
{
    $errors = array();
    $nbr_error=0;
    $nbr_node=0;
    if($params['all_service']=='on')
    {
    	$arr = model_esia::countServiceAllState($dbconnection,$user->getId());
    	foreach($arr as $key => $item)
    	{
    		//echo strlower($key);
    		if($_GET['status'] == strtolower($key))
    		{
    			$errors[] = $item;
    		}
    	}
    }
    elseif($params['all_node']=='on')
    {
    	$arr = model_esia::countStateAllNode($dbconnection,$user->getId());
    	foreach($arr as $key => $item)
    	{
    		if($_GET['status'] == strtolower($key))
    		{
    			$errors[] = $item;
    		}
    	}
    }
    elseif(isset($params['pluginid']))
    {
    	$nbr=0;
        foreach($params['pluginid'] as $plugin)
        {
            $arrerr = Model_esia::getPluginByCurrentState($dbconnection,$plugin,$_GET['status']);
            $nbr = $nbr + count($arrerr);
        }
        
        $errors[] = $nbr;
    }
    elseif(isset($params['service']))
    {
    	$nbr=0;
        foreach($params['service'] as $service)
        {
            $arrerr = Model_esia::getServiceByCurrentState($dbconnection,$service,$_GET['status']);
            $nbr = $nbr + count($arrerr);
        }
        $errors[] = $nbr;
    }
    else
    {
    	$nbr=0;
        foreach($NodeId_or_GroupNodeId as $node)
        {
            $arrerr = Model_esia::getNodeError($dbconnection,$node['id'],null,$_GET['status']);
            $nbr = $nbr + count($arrerr);
        }
        $errors[] = $nbr;
    }
    $smarty->assign('errors',$errors);
}
else
{
    $state['ok']=0;
    $state["warning"]=0;
    $state["critical"]=0;
    $state["unknown"]=0;
    $state["pending"]=0;
    if($params['all_node']=='on')
    {
        $state = model_esia::countStateAllNode($dbconnection,$user->getId());
        $state['ok']=$state['ok'];
    }
    elseif ($params['all_service']=='on')
    {
        $arr = model_esia::countServiceAllState($dbconnection,$user->getId());
        $state['ok']=$arr['OK'];
        $state["warning"]=$arr['warning'];
        $state["critical"]=$arr['critical'];
        $state["unknown"]=$arr['unknown'];
        $state["pending"]=$arr['maintenance']+$arr['pending']+$arr['waiting'];
    }
    elseif(!empty($params['service']))
    {
        $state = model_esia::countServiceAllState($dbconnection,$user->getId(),$params['service']);
    }
    elseif(!empty($params['nodeid']))
    {
        if($params['service_or_node']=='node') // En nombre de noeuds
        {
            $state = model_esia::countStateAllNode($dbconnection,$user->getId(),$params['nodeid']);
            $state['ok']=$state['ok'];
        }
        else // En nombre de services
        {
            $state = model_esia::countNodeState($dbconnection,$params['nodeid']);
        }
    }
    elseif(!empty($NodeId_or_GroupNodeId))
    {
        $tab_id_nod = array();
        foreach($NodeId_or_GroupNodeId as $node)
        {
            $tab_id_nod[]=$node['id'];
        }

        if(!empty($tab_id_nod))
        {
            if($params['service_or_node']=='node') // En nombre de noeuds
            {
                $state = model_esia::countStateAllNode($dbconnection,$user->getId(),$tab_id_nod);
                $state['OK']=$state['ok'];
            }
            else
            {
                $state = model_esia::countNodeState($dbconnection,$tab_id_nod);
            }
        }
        else
        {
            $smarty->assign('action','empty');
        }
    }
    elseif(!empty($params['pluginid']))
    {
        $state = model_esia::countServiceAllStateByPlugins($dbconnection,$params['pluginid'],$user->getId());
    }
    else
    {
        $smarty->assign('action','empty');
    }

    $ar=array_count_values($state);
    if($ar[0] == 7)
    {
        $smarty->assign('action','empty');
    }
    else
    {
        $smarty->assign('state',$state);
    }
    $titlesize=0;
    //la taille du titre corrige les bugs sur le donut, pie et ring
    if(preg_match('#font\-size:([0-9]*)px;#',$params['title']['style'],$regs))
    {

        $titlesize = $regs[1];
        if($titlesize < 42)
        {
            $titlesize = 45;
        }
        //on augmente la hauteur du titre (20 = margin-bottom du titre de la widget + 5px du margin soit 30 )
        $titlesize = $titlesize +30;
    }
    widgetTranslateNameDescription($widget,$smarty,$lang);
    $smarty->assign('title_height',$titlesize);
    //BUG avec le donut, il ne se resize pas automatique
    if($params['type']=='donut' || $params['type']=='pie')
    {
        //on va rechercher le nombre de pixel de la tuile
        $tile = model_esia::getTiles($dbconnection,$widget['tile']);
        $tile = array_pop($tile);
        $descsize=0;
        //la taille de la description s'il y en a une
        if(!empty($widget['description']))
        {
            if(preg_match('#font\-size:([0-9]*)px;#',$params['description']['style'],$regs))
            {
                $descsize=$regs[1];
            }
        }
        $height = $tile['height']-$descsize-$titlesize;
        $smarty->assign('height',$height);
    }
}
$smarty->display($path.'/dashboard/template/view_4state.html');
?>
