<?php
/*DESCRIPTION: inclus les variables habituelles pour la gestion d'une widget et vérifie les droits d'accès
 *APRES l'inclusion du common_widget les variables suivantes sont créées:
 *PHP:
 *      $action l'action passé dans l'url ou 'view'
 *      $widget un tableau associatif reprenant les paramètre de la widget
 * SMARTY
 *      $widget les informations de la widget
 *      $parameter les parametre de la widget (JSON)
 *      $action l'action passé dans l'url ou 'view'
 */



/*
INSERT INTO dashboard_view(
        view_id,
        view_name,
        view_file_path,
        view_during,
        view_default_height,
        view_default_width,
        view_default_option)
VALUES(
    DEFAULT,
    'DASHBOARD_BACKUP_TABLE',
    '/dashboard/view_backup_table.php?id=:widgetid',
    30,
    100,
    300,
    '{"title":{"style":"text-align: center; font-size:15px; color:#575759;"},"description":{"style":"text-align: center; margin:auto;font-size:12px;"},"table":{"class":"arraytop","style":"width:60%; height:60%; margin: auto; border-spacing: 10px 10px;"},"td":{"style":"font-size:50px;"}}');
*/
include "./common_widget.php";
$path = $_SERVER['DOCUMENT_ROOT'];
$webp_name='Backup';

$language = $user->getLang();
$arr = Model_esia::getWebPlugin($dbconnection,false,$webp_name);
$apache_plugin_path = $arr[0]['apache_path'];
include_once $path.$apache_plugin_path.'inc/Model_Backup.php';
include_once $path.$apache_plugin_path.'/lang/'.$language.'.php';

$params=$widget['option'];
if($action =='update')
{
    try
    {
        $nodes = Model_esia::getNodebyType($dbconnection,NULL,'backup server');
        $server_list = array();
        foreach($nodes as $node)
        {
            $server_list[$node->getID()] = $node->getName();
        }
        natcasesort($server_list);

        $smarty->assign('server_list',$server_list);

        if(isset($_POST['widgetid'])&&!empty($_POST['widgetid']))
        {
	    if( empty( $_POST['nodeid']) || empty( $_POST['job_or_source']) )
	    {
		throw new Exception('Missing important parameter');
	    }

            $widget = getPostDefaultParams($widget,$_POST);
            $params['nodeid'] = $_POST['nodeid'];
            $params['job_or_source'] = $_POST['job_or_source'];
            $params['period'] = $_POST['period'];
            $params['items'] = $_POST['items'];

            Model_esia::updateWidget($dbconnection, $widget['id'], $widget['name'], $widget['description'], $widget['during'], $params);
            $smarty->assign('l_success',$lang['UPDATE_DASHBOARD_SUCCESS']);
            $smarty->assign('widget',$widget);
            $widget['option'] = $params;
        }
    }
    catch(Exception $e)
    {
        $smarty->assign('l_error',$e->getMessage());
    }
    $title = getWidgetStyle($params['title']['style'],14,'left','#575759');
    $description = getWidgetStyle($params['description']['style'],12,'left','#575759');

    $smarty->assign('nodeid',$widget['option']['nodeid']);
    $smarty->assign('job_or_source',$widget['option']['job_or_source']);
    if( empty($widget['option']['period']) )
    {
        $widget['option']['period'] = 7;
    }
    $smarty->assign('period',$widget['option']['period']);
    $smarty->assign('items',$widget['option']['items']);

    $smarty->assign('titlestyle',$title);
    $smarty->assign('descriptionstyle',$description);
    $smarty->display($path.'/dashboard/template/view_backup_table.html');

}
else if( $action == 'getItemList')
{
    if( isset($_REQUEST['nodeid']) && isset($_REQUEST['job_or_source']))
    {
        $node_id = $_REQUEST['nodeid'];
        $job_or_source = $_REQUEST['job_or_source'];
        if( in_array($job_or_source,array('job','source')))
        {
            $item_list = Model_Backup::getAllBackupsName($dbconnection,$node_id,$job_or_source);
            $ret = array();
            foreach($item_list as $item)
            {
                $ret[urlencode($item)] = $item;
            }
            echo json_encode($ret);
            exit(0);
        }
    }
}
else
{
    $path = $_SERVER['DOCUMENT_ROOT'];
    $webp_name='Backup';

    $arr = Model_esia::getWebPlugin($dbconnection,false,$webp_name);
    $apache_plugin_path = $arr[0]['apache_path'];
    $template_path= $path.$apache_plugin_path.'templates/';

    $_GET['id'] = $widget['option']['nodeid'];
    $_GET['action'] = $widget['option']['job_or_source'];

    $smarty->assign('isWidget',TRUE);
    $smarty->assign('dashboard_path',$path.'dashboard/template/');
    $smarty->assign('template_path',$template_path);
    $smarty->assign('plugin_path',$apache_plugin_path);

    $title = getWidgetStyle($params['title']['style'],14,'left','#575759');
    $description = getWidgetStyle($params['description']['style'],12,'left','#575759');

    $smarty->assign('titlestyle',$title);
    $smarty->assign('descriptionstyle',$description);

        $only_nodes = array();
    foreach( $widget['option']['items'] as $item )
    {
   	$only_nodes[] = str_replace('+',' ',$item);
    }

    $_GET['only_nodes'] = $only_nodes;
    $_GET['max_days'] = $widget['option']['period'];
    include_once($path.$apache_plugin_path.'page/bck_gantt_view.php');

//    $smarty->display($template_path.'bck_gantt_view.html');

    //$smarty->display($path.'/dashboard/template/view_generic.html');

}
?>
