<?php
/*DESCRIPTION: inclus les variables habituelles pour la gestion d'une widget et vérifie les droits d'accès
 *APRES l'inclusion du common_widget les variables suivantes sont créées:
 *PHP:
 *      $action l'action passé dans l'url ou 'view'
 *      $widget un tableau associatif reprenant les paramètre de la widget
 * SMARTY
 *      $widget les informations de la widget
 *      $parameter les parametre de la widget (JSON)
 *      $action l'action passé dans l'url ou 'view'
 */
include "./common_widget.php";
$params = $widget['option'];
if($action =='update')
{
	if(isset($_POST['widgetid'])&&!empty($_POST['widgetid']))
	{
		try 
		{
			$widget = getPostDefaultParams($widget,$_POST);
			$params = $widget['option'];
			//Option des noeuds				
			$params['list_channel'] = $_POST['select_channel'];	
			$params['list_category'] = $_POST['select_category'];	
			$params['filter'] = $_POST['select_filter'];	
			$params['type'] = $_POST['type'];	
			// Affichage msg				
			if(empty($_POST['channel']))
			{
				$_POST['channel']='off';
			}
			if(empty($_POST['publishdate']))
			{
				$_POST['publishdate']='off';
			}
			$params['affiche_msg']=$_POST['affiche_msg'];
			$params['showchannel']=$_POST['channel'];
			$params['showmessage']=$_POST['message'];
			$params['showdate']=$_POST['publishdate'];
			$params['showauthor']=$_POST['author'];
			Model_esia::updateWidget($dbconnection, $widget['id'], $widget['name'], $widget['description'], $widget['during'], $params);
			$smarty->assign('l_success',$lang['UPDATE_DASHBOARD_SUCCESS']);
			$widget['option']=$params;
			$smarty->assign('widget',$widget);
		}
		catch(Exception $e)
		{
			$smarty->assign('l_error',$e->getMessage());
		}
	}
	if(empty($params['filter']))
	{
		$widget['option']['filter']='chan';
	}
	if(in_array(-1,$params['list_category']))
	{
		$category = Model_esia::getRSSCategory($dbconnection,'ESIA');
		$arr = array();
		foreach($category as $cat)
		{
			$arr[]=$cat['id'];
		}
		$widget['option']['list_category']=$arr;
	}
//	echo '<pre>';
//	print_r($widget['option']);
	//recupération des styles
	$title = getWidgetStyle($params['title']['style'],14,'left','#575759');
	$description = getWidgetStyle($params['description']['style'],12,'#575759');
	$smarty->assign('titlestyle',$title);
	$smarty->assign('descriptionstyle',$description);
	$smarty->assign('params',$widget['option']);			
    $channel = Model_esia::getRSSChannel($dbconnection);
    $smarty->assign('channels',$channel);
    $category = Model_esia::getRSSCategory($dbconnection);
 //   print_r($category);
    $smarty->assign('category',$category);
	$smarty->assign('title',$lang['DASHBOARD_MESSAGE_SELECTED']);
	$smarty->assign('descr',$lang['DASHBOARD_SELECT_NODE']);						
}
else
{	
	widgetTranslateNameDescription($widget,$smarty,$lang);
	$listchan =NULL;
    if(!empty($params['list_channel']) && !in_array(0,$params['list_channel']))
    {
		$listchan = $params['list_channel'];
	}  
    if(!empty($params['list_category']))
    {
	   	if(in_array(-1,$params['list_category']))
	  	{
	   		$arr = Model_esia::getRSSChannelByCategory($dbconnection,'ESIA',$user->getId());
	   		$listchan = $arr;
	   	}
	   	elseif( !in_array(0,$params['list_category']))
	   	{
	   		$arr = Model_esia::getRSSChannelByCategory($dbconnection,$params['list_category'],$user->getId());
	   		$listchan = $arr;
	   	}
	}
	if(!empty($params['affiche_msg']) &&  ($params['affiche_msg']=='show_tab_view' || $params['affiche_msg']=='affiche_tab_view'))
	{
		$messages = array();
		try 
		{
			$messages = Model_esia::getRSSMessages($dbconnection,$listchan,NULL,$user->getId());
		} 
		catch (Exception $e)
		{
			
		}
		
		$arr=array();
	    foreach($messages as $row => $msg)
	    {
	        $arr[]=array('channel_id'=>$msg['channel_id'],
	                      'channel_name'=>$msg['channel_name'],    
	                      'channel_type'=>$msg['channel_type'],
	                      'title'=>$msg['title'], 
	        			   'id'=>$msg['id'], 
	        				'message'=>$msg['message'],    
	                      'lang'=>$msg['lang'], 
	                      'link'=>$msg['link'],
	                      'author'=>$msg['author'],
	                      'publish'=>$msg['publish'],
	                      'type'=>$msg['type'],   
	                      'url'=>$msg['url']
	        );
	    }
	    $smarty->assign('messages',$arr);	
	}
	else 
	{	
		try 
		{		
			$readmsg = Model_esia::getRSSReadMessagesID($dbconnection, $user->getId(),$listchan);
			$messages = Model_esia::getRSSMessages($dbconnection,$listchan,NULL,$user->getId(),500,$readmsg);
			$notread  = count($messages);
			if($notread==500)
			{
				$notread=$notread.'+';
			}
		} 
		catch (Exception $e) 
		{
		}
		$smarty->assign('notread',$notread);
	}
}
$smarty->display($path.'/dashboard/template/view_com_msg.html');
?>
