<?php
/*DESCRIPTION: inclus les variables habituelles pour la gestion d'une widget et vérifie les droits d'accès
 *APRES l'inclusion du common_widget les variables suivantes sont créées:
 *PHP:
 *      $action l'action passé dans l'url ou 'view'
 *      $widget un tableau associatif reprenant les paramètre de la widget
 * SMARTY
 *      $widget les informations de la widget
 *      $parameter les parametre de la widget (JSON)
 *      $action l'action passé dans l'url ou 'view'
 */
$webplugin_path = $_SERVER['DOCUMENT_ROOT'];
include "./common_widget.php";
require_once '/usr/local/esia/public_html/plugin/egidescan/model_egidescan.php';
require_once '/usr/local/esia/public_html/plugin/egidescan/common_egidescan.php';
// $smarty->assign('view_type',$_GET['type']);
if($action =='update')
{
	//Code permettant l'administration du bloc
	
	$parameters = $widget['option'];
	
	if(isset($parameters['nodeid']))
	{
		$nodes = Model_esia::getNodeList($dbconnection, $user->getId(), NULL, Model_esia::NODE_ASSOC);
		$nodesList = array();
		foreach($nodes as $node)
		{
			$nodesList[] = array('id' => $node['id'], 'name' => $node['name']);
		}
		$smarty->assign('adm_list_node', $nodesList);
	}
	elseif(isset($parameters['groupnodeid']))
	{
		$list = Model_esia::getNodeGroupHierarchyByUser($dbconnection,$user->getId());
		$list_group_node=array();
		foreach($list as $node)
		{
			$selected='no';
			if(in_array($node['id'],$parameters['groupnodeid']))
			{
				$selected='yes';
			}
			
			$list_group_node[]=array('id'=>$node['id'],
				'name'=>$node['name'],
				'selected'=>$selected);
		}
		$smarty->assign('adm_list_group_node', $list_group_node);
	}
	
	$parameters = $widget['option'];
	
	$smarty->assign('param',$parameters);
	if(isset($_POST['widgetid'])&&!empty($_POST['widgetid']))
	{
		//on traite le formulaire
		try
		{
			//traite les données post pour le style du titre et de la description
			$widget = getPostDefaultParams($widget,$_POST);
			$parameters = $widget['option'];
			
			if(isset($parameters['nodeid']))
			{
				$parameters['nodeid']=$_POST['nodes'];
			}
			elseif(isset($parameters['groupnodeid']))
			{
				$parameters['groupnodeid']=$_POST['groupnodes'];
			}
			
			//traitement des variable POST

			Model_esia::updateWidget($dbconnection,$widget['id'], $widget['name'], $widget['description'], $widget['during'], $parameters);
			//la variable l_success est affichée en rouge dans le smarty
			$smarty->assign('l_success',$lang['UPDATE_DASHBOARD_SUCCESS']);
		}
		catch (EsiaDbException $e)
		{
			//la variable l_error est affichée en rouge dans le smarty
			$smarty->assign('l_error',$e->getMessage());
		}
		catch (Exception $e)
		{
			$smarty->assign('l_error',$e->getMessage());
		}
	}
	//récupération des styles:
	//recupération des styles
	$title = $parameters['title']['style'];
	$description = $parameters['description']['style'];
	$title = getWidgetStyle($title,14,'left','#575759');
	$description = getWidgetStyle($description,12,'left','#575759');
	$smarty->assign('titlestyle',$title);
	$smarty->assign('descriptionstyle',$description);
	$smarty->assign('path_widg',$widget['path']);
	//récupération des données pour l'affichage
	//on fixe le mode update
	$smarty->assign('action','update');
}


//chemin d'accès au template de votre block

else
{
	//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	
	$parameters = $widget['option'];

	$services_devices = getServicesDevices($dbconnection);

	$vulnerability_nodes = array() ;$h= 0 ; $matches = array();
	
	if(isset($parameters['nodeid']))
	{
		$nodes = $parameters['nodeid'] ;
	}
	elseif(isset($parameters['groupnodeid']))
	{
		$tab_group_node = Model_esia::getAllNodeofGroup($dbconnection,$userid,$parameters['groupnodeid']);
		foreach ($tab_group_node as $node)
		{
			$nodes[] = $node->getId();
		}
	}
	
	$vulnerability_nodes = Model_egidescan::getCVEByNodes($dbconnection,$nodes);
	
	$lang_fr_CVE_severity = $lang['EGIDE_CVE_SEVERITY_TYPE'];
	
	assignDonutAndVulnerabilities($smarty,$vulnerability_nodes,$lang_fr_CVE_severity,FALSE) ;

	$all_scores = Model_egidescan::getNumberGlobalByScoring($dbconnection,$user->getId());
	$classed_severity = array();
	for($i=0;$i<10;$i++)
	{
		$classed_severity[$i]=0;
	}
	foreach($all_scores as $value)
	{
		$domain = $value['domain'];
		if($domain==10)
		{
			$classed_severity[9] = $classed_severity[9] +  $value['number'];
		}
		else
		{
			$classed_severity[$domain] = $classed_severity[$domain] +  $value['number'];
		}
	}
	array_unshift($classed_severity, 'severity');
	
	$severity_class = array();
	for($i=0;$i<10;$i++)
	{
		$j = $i+1 ;
		$severity_class[$i]="$i - $j";
	}
	// array_unshift($severity_class, 'x');
	
	$smarty->assign('var_chart_culumn_x',$severity_class);
	$smarty->assign('var_chart_culumn_y',$classed_severity);

	
	$smarty->assign('widget_id',$widget['id']);	
	//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
}

$smarty->display($webplugin_path.'dashboard/template/egidescan_severity.html');

?>
