<?php
/*DESCRIPTION: inclus les variables habituelles pour la gestion d'une widget et vérifie les droits d'accès
 *APRES l'inclusion du common_widget les variables suivantes sont créées:
 *PHP:
 *      $action l'action passé dans l'url ou 'view'
 *      $widget un tableau associatif reprenant les paramètre de la widget
 * SMARTY
 *      $widget les informations de la widget
 *      $parameter les parametre de la widget (JSON)
 *      $action l'action passé dans l'url ou 'view'
 */
include("./common_widget.php");
$params=$widget['option'];
if($action =='update')
{
	if($params['type']=='abr' || empty($params['type']=='abr'))
	{
		$params['type']='abre';
	}
	if(isset($_POST['widgetid'])&&!empty($_POST['widgetid']))
	{
		try
		{
			$widget = getPostDefaultParams($widget,$_POST);
			$params = $widget['option'];
			$arr = array();
			if($_POST['select_elem']!=null)
			{
				$arr= $_POST['select_elem'];
			}
			if(isset($_POST['selectservices']))
			{
				$arr= $_POST['selectservices'];
			}
			if(isset($params['nodeid']))
			{
				$params['nodeid']=$arr;
			}
			elseif(isset($params['groupnodeid']))
			{
				$params['groupnodeid']=$arr;
			}
			elseif(isset($params['pluginid']))
			{
				$params['pluginid']=$arr;
			}
			elseif(isset($params['service']))
			{
				$params['service']=$arr;
			}
			
			if(isset($_POST['check_blink']))
			{
				$params['blink']='blink';
			}
			else
			{
				$params['blink']='none';
			}
			$params['type'] = $_POST['type'];
			Model_esia::updateWidget($dbconnection, $widget['id'], $widget['name'], $widget['description'], $widget['during'], $params);
			$smarty->assign('l_success',$lang['UPDATE_DASHBOARD_SUCCESS']);
			$widget['name']=$_POST['widgetname'];
			$widget['description']=$_POST['widgetdescription'];
			$smarty->assign('widget',$widget);
		}
		catch(Exception $e)
		{
			$smarty->assign('l_error',$e->getMessage());
		}
	}
	//recupération des styles
	$title = getWidgetStyle($params['title']['style'],14,'left','#575759');
	$description = getWidgetStyle($params['description']['style'],12,'#575759');
	$smarty->assign('titlestyle',$title);
	$smarty->assign('descriptionstyle',$description);
	$smarty->assign('type',$params['type']);
	$smarty->assign('parameter',$params);
	$listSelect=array();
	if(isset($params['nodeid']))
	{
		//Récupération des noeuds
		$nodes = Model_esia::getNodeList($dbconnection,$user->getId(),null,Model_esia::NODE_INSTANCE);
		foreach($nodes as $node)
		{
			$selected='no';
			if(in_array($node->getId(),$params['nodeid']))
			{
				$selected='yes';
			}
			$listSelect[]=array('id'=>$node->getId(),
				'name'=>$node->getGroup().'>'.$node->getName(),
				'selected'=>$selected
			);
		}
		$smarty->assign('title',$lang['DASHBOARD_NODE_LINKED']);
		$smarty->assign('descr',$lang['DASHBOARD_SELECT_NODE']);
	}
	elseif(isset($params['groupnodeid']))
	{
		//Récupération des noeuds
		$group = Model_esia::getNodeGroupHierarchyByUser($dbconnection,$user->getId());
		foreach($group as $grp)
		{
			$selected='no';
			if(in_array($grp['id'],$params['groupnodeid']))
			{
				$selected='yes';
			}
			$listSelect[]=array('id'=>$grp['id'],
				'name'=>$grp['name'],
				'selected'=>$selected);
		}
		$smarty->assign('descr',$lang['DASHBOARD_SELECT_GROUP_NODE']);
		$smarty->assign('title',$lang['DASHBOARD_GROUP_NODE_LINKED']);
	}
	elseif(isset($params['pluginid']))
	{
		//Récupération des plugins
		$plugins = Model_esia::getPlugin($dbconnection);
		foreach($plugins as $plug)
		{
			$selected='no';
			if(in_array($plug['id'],$params['pluginid']))
			{
				$selected='yes';
			}
			$listSelect[]=array('id'=> $plug['id'],
				'name'=>$plug['name'],
				'selected'=>$selected
			);
		}
		$smarty->assign('descr',$lang['PLUGINS']);
		$smarty->assign('title',$lang['DASHBOARD_PLUGIN_LINKED']);
	}
	//Récupération des services
	elseif(isset($params['service']))
	{
		if(!empty($params['service']))
		{
			$sers = Model_esia::getServices($dbconnection,null,$params['service']);
			foreach($sers as $ser)
			{
				if(!in_array($ser['device_id'],$listnode))
				{
					$listnode[]=$ser['device_id'];
				}
				$listservice[]=$ser['id'];
			}
			$smarty->assign('serviceid', $listservice);
		}
		$nodes = Model_esia::getNodeList($dbconnection,$user->getId(),null,Model_esia::NODE_INSTANCE);
		foreach($nodes as $node)
		{
			$selected='no';
			if(in_array($node->getId(),$listnode))
			{
				$selected='yes';
			}
			$listSelect[]=array('id'=>$node->getId(),
				'name'=>$node->getGroup().'>'.$node->getName(),
				'selected'=>$selected
			);
		}
		$smarty->assign('descr',$lang['DASHBOARD_SELECT_NODE']);
		$smarty->assign('title',$lang['DASHBOARD_NODE_LINKED']);
	}
	$smarty->assign('dash_list_select', $listSelect);
}
elseif($action =="getservice")
{
	if(!empty($_GET['nodeid']))
	{
		$tablenodeid = json_decode($_GET['nodeid']);
		$list=array();
		foreach($tablenodeid as $nodeid)
		{
			$node = Model_esia::InstanceNode($dbconnection, $nodeid);
			if($user->getAccess($dbconnection, "device_view",$node->getName())==1)
			{
				$services = Model_esia::getServices($dbconnection,$node->getId());
				foreach ($services as $service)
				{
					$common_name = Model_esia::getCommonName($lang, $service['name'],$service['check_plugin_name']);
					$list[$service['id']]=$node->getName().' > '.$common_name;
				}
			}
		}
		echo json_encode($list);
		exit(0);
	}
}
else
{
	$smarty->assign('parameter',$params);
	//Affichage
	$state['OK']=0;
	$state["warning"]=0;
	$state["critical"]=0;
	$state["unknown"]=0;
	$state["pending"]=0;
	if(!empty($params['service']))
	{
		$state = model_esia::countServiceAllState($dbconnection,$user->getId(),$params['service']);
	}
	elseif(!empty($params['nodeid']))
	{
		$state = model_esia::countNodeState($dbconnection,$params['nodeid']);
	}
	elseif(!empty($params['groupnodeid']))
	{
		$groups_node = Model_esia::getAllNodeofGroup($dbconnection,$user->getId(),$params['groupnodeid']);
		$arr = array();
		foreach ($groups_node as $node)
		{
			$arr[] = $node->getId();
		}
		if(!empty($arr))
		{
			$state = model_esia::countNodeState($dbconnection,$arr);
		}
		else
		{
			$smarty->assign('action','empty');
		}
	}
	elseif(!empty($params['pluginid']))
	{
		$state = model_esia::countServiceAllStateByPlugins($dbconnection,$params['pluginid'],$user->getId());
	}
	else
	{
		$smarty->assign('action','empty');
	}
	$globalstate="EMPTY";
	if(!empty($state))
	{
		if($state['critical'] > 0)
		{
			$globalstate='critical';
		}
		elseif($state['warning'] > 0)
		{
			$globalstate='warning';
		}
		elseif($state['unknown'] > 0)
		{
			$globalstate='unknown';
		}
		elseif($state['OK'] > 0)
		{
			$globalstate='OK';
		}
		elseif($state['pending'] > 0)
		{
			$globalstate='pending';
		}
	}
	$smarty->assign('globalstate',$globalstate);
}
$smarty->display($path.'/dashboard/template/view_flag_state.html');
?>