<?php
/*DESCRIPTION: inclus les variables habituelles pour la gestion d'une widget et vérifie les droits d'accès
 *APRES l'inclusion du common_widget les variables suivantes sont créées:
 *PHP:
 *      $action l'action passé dans l'url ou 'view'
 *      $widget un tableau associatif reprenant les paramètre de la widget
 * SMARTY
 *      $widget les informations de la widget
 *      $parameter les parametre de la widget (JSON)
 *      $action l'action passé dans l'url ou 'view'
 */
include "./common_widget.php";
if($action =='update')
{
    if(isset($widget['option']['type']))
	{
	    switch($widget['option']['type'])
	    {
	        case 'value': $smarty->assign('showtype', 'value'); break;
	        case 'gauge': $smarty->assign('showtype', 'gauge'); break;
	    }

	}
	if(isset($_POST['widgetid'])&&!empty($_POST['widgetid']))
	{
		try
		{
		    $widget = getPostDefaultParams($widget,$_POST);
		    $params = $widget['option'];

			//Option des noeuds
			$params['service']=$_POST['services'];
			$params['start']='-'.$_POST['startgraph'].'m';
			if(isset($widget['option']['type']))
			{
				$params['unity']=$_POST['unity'];
				$params['rrd']=$_POST['rrdname'];
			}
			$params['minimun']='';
			$params['maximun']='';
			if(!empty($_POST['gaugeMinimun'])||$_POST['gaugeMinimun']==0 )
			{
			    $params['minimun']=$_POST['gaugeMinimun'];
			}
			if(!empty($_POST['gaugeMaximun'])||$_POST['gaugeMaximun']==0 )
			{
			    $params['maximun']=$_POST['gaugeMaximun'];
			}
			$params['fontsize']=0;
			if(!empty($_POST['fontsize']))
			{
				if($_POST['fontsize'] > 10)
				{
					$params['fontsize']=$_POST['fontsize'];
				}
			}
			
			$params['calc_operator']=$_POST['calc_operator'];
			$params['calc_value']=$_POST['calc_value'];
            $params['select_rra']=$_POST['select_rra'];
			Model_esia::updateWidget($dbconnection, $widget['id'], $widget['name'], $widget['description'], $widget['during'], $params);
			$widget['option']=$params;
			$smarty->assign('l_success',$lang['UPDATE_DASHBOARD_SUCCESS']);
			$smarty->assign('widget',$widget);
			$smarty->assign('parameter',$params);

		}
		catch(Exception $e)
		{
			$smarty->assign('l_error',$e->getMessage());
		}
	}
	$params = $widget['option'];
	//recupération des styles
	$title = getWidgetStyle($params['title']['style'],14,'left','#575759');
	$description = getWidgetStyle($params['description']['style'],12,'#575759');
	$smarty->assign('titlestyle',$title);
	$smarty->assign('descriptionstyle',$description);
	$smarty->assign('type',$params['type']);
	if(empty($params['fontsize']))
	{
		$params['fontsize']=0;
	}
	$smarty->assign('parameter',$params);

	if(preg_match('#([0-9]*)m#',$params['start'],$regs))
	{
		$smarty->assign('rrdperiod',$regs[1]);
	}
	else
	{
		$smarty->assign('rrdperiod',60);
	}
	$titlecolor='#575759';
	if(preg_match('#color:([\#0-9A-Fa-f]*)#',$params['title']['style'],$regs))
	{
		$titlecolor=$regs[1];
	}
	$smarty->assign('type',$params['type']);
	$smarty->assign('serviceid',$params['service']);
	//Récupération des noeuds
	if(!empty($params['service']))
	{
		$service = Model_esia::getServices($dbconnection,null,$params['service']);
		$service = $service[0];
	}
	$nodes = Model_esia::getNodeList($dbconnection,$user->getId(),null,Model_esia::NODE_INSTANCE);
	$list=array();
	foreach($nodes as $node)
	{
		$selected='no';
		if($node->getId() == $service['device_id'])
		{
			$selected='yes';
		}
		$list[]=array('id'=>$node->getId(),
				'name'=>$node->getGroup().'>'.$node->getName(),
				'selected'=>$selected

		);
	}
	$smarty->assign('adm_list_node', $list);
}
elseif($action =="getservice")
{
	if(isset($_GET['nodeid'])&& is_numeric($_GET['nodeid']))
	{
		$node = Model_esia::InstanceNode($dbconnection, $_GET['nodeid']);
		if($user->getAccess($dbconnection, "device_view",$node->getName())==1)
		{
			$services = Model_esia::getServices($dbconnection,$node->getId());

			$list=array();
			foreach ($services as $service)
			{
                $rrds = Model_esia::getRRDInformationByServiceId($dbconnection,$service['id']);
                $arr = array();
                foreach($rrds as $rrd)
                {
                    if(array_key_exists($rrd['num'],$arr))
                    {
                        $arr[$rrd['num']] = $arr[$rrd['num']].':'.$rrd['name'];
                    }
                    else
                    {
                        $arr[$rrd['num']] = $rrd['name'];
                    }
                }
            //echo '<pre>';print_r($info);
				$common_name = Model_esia::getCommonName($lang, $service['name'],$service['check_plugin_name']);

				$list[$service['id']]=array('name'=>$common_name,'rrd'=>$arr);
			}
			echo json_encode($list,true);
			exit(0);
		}
	}
}
elseif($action =="getRRDservice")
{
	if(isset($_GET['nodeid'])&& is_numeric($_GET['nodeid']))
	{
		$node = Model_esia::InstanceNode($dbconnection, $_GET['nodeid']);
		if($user->getAccess($dbconnection, "device_view",$node->getName())==1)
		{
			$services = Model_esia::getServices($dbconnection,$node->getId(),$_GET['serviceid']);
			$services = array_pop($services);
			$rrd=array();
			$info = Model_esia::getRRDInformationByServiceId($dbconnection,$services['id']);
			foreach( $services['value'] as $key => $value)
			{
			    $inf =$info[$key];
			    $unity='%';
			    switch($inf['unity'])
			    {
			        case 'percent': $unity='%'; break;
			        case 'Bytes': $unity='B'; break;
			        case 'bytes': $unity='B'; break;
			        case 'celsius': $unity='°C'; break;
			        case 'Celsius': $unity='°C'; break;
			        case 'temperature': $unity='°C'; break;
			        default:$unity=$inf['unity']; break;
			    }
			    $rrd[]=array('name'=>$key,'value'=>$value,'unity'=>$unity,'rrd'=>$info);
			}
			$arr=array('rrd'=>$rrd);
			$arr['unity']=Model_esia::getRRDInformationByServiceId($dbconnection,$services['id']);
			echo json_encode($arr,true);
			exit(0);
		}
	}
}
if(empty($widget['option']['type']))
{
	if(!empty($_GET['type']))
	{
		$widget['option']['type']= $_GET['type'];
	}
}
if(isset($widget['option']['type']))
{
    $smarty->assign('showtype', $widget['option']['type']);
	if(!empty($widget['option']['service']))
	{
		if($widget['option']['fontsize']!=0)
		{
			$smarty->assign('fontsize',$widget['option']['fontsize']);
		}

		$service = Model_esia::getServices($dbconnection,null,$widget['option']['service']);
		$service = array_pop($service);
		foreach($service['value'] as $key => $value)
		{
		    if($widget['option']['rrd'] == $key)
		    {
		    	$val = $value;
		    	if($widget['option']['calc_operator'] != 'none' && !empty($widget['option']['calc_value'])  )
		    	{
		    		$cal = $widget['option']['calc_value'];
		    		switch($widget['option']['calc_operator'])
		    		{
		    			case '+': $val = $val + $cal; break;
		    			case '-': $val = $val - $cal; break;
		    			case '*': $val = round($val * $cal,1); break;
		    			case '/': $val = round($val / $cal,1); break;
		    			case '%': $val = $val % $cal; break;
		    			default: $val = $val;
		    		}
		    	}
		    	$smarty->assign('value',$val);
		    	$smarty->assign('rrdname',$key);
		        break;
		    }
		}

		//echo "<pre>";print_R($service);
		$smarty->assign('service',$service);
	}
	else
	{
		$smarty->assign($action,'empty');
	}
}
$smarty->display($path.'/dashboard/template/graph.html');
?>
