<?php
/*DESCRIPTION: inclus les variables habituelles pour la gestion d'une widget et vérifie les droits d'accès
 *APRES l'inclusion du common_widget les variables suivantes sont créées:
 *PHP:
 *      $action l'action passé dans l'url ou 'view'
 *      $widget un tableau associatif reprenant les paramètre de la widget
 * SMARTY
 *      $widget les informations de la widget
 *      $parameter les parametre de la widget (JSON)
 *      $action l'action passé dans l'url ou 'view'
 */
include "./common_widget.php";
$smarty->assign('view_type',$_GET['type']);
$plan=array();
if($action =='update')
{
	if(isset($_POST['widgetid'])&&!empty($_POST['widgetid']))
	{
		try
		{
			$widget = getPostDefaultParams($widget,$_POST);
			$params = $widget['option'];

			if($_GET['type']=='plan')
			{
				$params['plan'] = $_POST['plan'];
				$plan['id'] = $_POST['plan'];
			}
			Model_esia::updateWidget($dbconnection, $widget['id'], $widget['name'], $widget['description'], $widget['during'], $params);
			$smarty->assign('l_success',$lang['UPDATE_DASHBOARD_SUCCESS']);
			$widget['option']=$params;
			$smarty->assign('widget',$widget);
		}
		catch(Exception $e)
		{
			$smarty->assign('l_error',$e->getMessage());
		}
	}
	$params = $widget['option'];
	//recupération des styles
	$title = getWidgetStyle($params['title']['style'],14,'left','#575759');
	$description = getWidgetStyle($params['description']['style'],12,'#575759');
	$smarty->assign('titlestyle',$title);
	$smarty->assign('descriptionstyle',$description);
	$smarty->assign('type',$params['type']);
	$smarty->assign('parameter',$params);
	if($_GET['type']=='plan')
	{
		$smarty->assign('type_map','plan');
		//chemin d'accès au repertoire du plugin contenant les templates
		$arr = Model_esia::getWebPlugin($dbconnection,false,'WEBP_PLAN');
		$tpluginpath= $path.$arr[0]['apache_path'];
		include_once $tpluginpath.'/Model_plan.php';
		$plans = Model_plan::getPlans($dbconnection, $user->getId());
		$listplan = array();
		foreach ($plans as $plan)
		{
		    if($plan['name'] !='.ACCESS')
		    {
			    $listplan[] = array('id'=> $plan['id'],
						'name'=>$plan['name'],
				    );
		    }
		}
		$smarty->assign('plans',$listplan);
		$smarty->assign('selectplan',$params['plan']);
	}
	$smarty->assign('plan',$plan);
	$smarty->display($path.'/dashboard/template/plan.html');
}
else
{
	if($_GET['type']=='plan')
	{
	    $params = $widget['option'];
        if(!empty($params['plan']) && $params['plan'] != -1 )
        {
			$arr = Model_esia::getWebPlugin($dbconnection, false, 'WEBP_PLAN');
			// Check if the user still have acces to the plan (acces on plan could be removed after the creation of the dashboard using this plan). If user has acces to the plan display it else display an empty tile.
			$tpluginpath = $path . $arr[0]['apache_path'];
			include_once $tpluginpath . '/Model_plan.php';
			$access = Model_plan::getPlanUserAccess($dbconnection, $params['plan'], $user->getId());
			if (!empty($access) && $access !== 'NONE')
			{
				$planType = Model_plan::getPlanTypes($dbconnection, NULL, $params['plan'])[0];
				$planUrl = '/plugin/plan/' . explode('?', $planType['controller'])[0] . '?action=dash_plan&id=' . $params['plan'];
				$smarty->assign('planUrl', $planUrl);
				$smarty->assign('planId', $params['plan']);

				$smarty->display($path . '/dashboard/template/plan.html');
			}
			else
			{
				$smarty->assign('actionvide', 'empty');
				$smarty->display($path . '/dashboard/template/plan.html');
			}
        }
        else
        {
	         $smarty->assign('actionvide', 'empty');
	         $smarty->display($path . '/dashboard/template/plan.html');
	    }
	}
}
?>
