<?php
include "./common_widget.php";
$params=$widget['option'];

$errors = array();
if($action =='update')
{
	if(isset($_POST['widgetid'])&&!empty($_POST['widgetid']))
	{
		try
		{
			$widget = getPostDefaultParams($widget,$_POST);
			$params = $widget['option'];
			
			// Get items for each shield position (topleft, topright, ...)
			$params['items'] = $_POST['items'];

			Model_esia::updateWidget($dbconnection, $widget['id'], $widget['name'], $widget['description'], $widget['during'], $params);
			$smarty->assign('l_success',$lang['UPDATE_DASHBOARD_SUCCESS']);
			$smarty->assign('widget',$widget);
		}
		catch(Exception $e)
		{
			$smarty->assign('l_error',$e->getMessage());
		}
	}
	$title = getWidgetStyle($params['title']['style'],14,'left','#575759');
	$description = getWidgetStyle($params['description']['style'],12,'left','#575759');
	$smarty->assign('titlestyle',$title);
	$smarty->assign('descriptionstyle',$description);

	// Get nodes list
	$nodeList = array();
	$nodes = Model_esia::getNodeList($dbconnection, $user->getId(), NULL, Model_esia::NODE_ASSOC);
	foreach($nodes as $node)
	{
		if(empty($node['group']))
		{
			$node['group'] = $lang['GROUPNODE_ROOT'];
		}
		$nodeList[] = array(
			'id' => $node['id'],
			'name' => $node['group'] . '>' . $node['name'],
		);
	}
	$smarty->assign('nodeList', $nodeList);
	
	// Get groups list
	$groupList = array();
	$groups = Model_esia::getNodeGroupHierarchyByUser($dbconnection, $user->getId());
	foreach($groups as $group)
	{
		$groupList[] = array(
			'id' => $group['id'],
			'name' => $group['name'],
		);
	}
	$smarty->assign('groupList', $groupList);
	
	// Get selected items from widget params
	$smarty->assign('selectedList', $params['items']);
}
else
{
	$itemsList = array();
	$globalState = 'ok';
	$convStates = array(
		'critical' => 'critical',
		'warning' => 'warning',
		'unknown' => 'unknown',
		'ok' => 'ok',
		'maintenance' => 'ok',
		'acquitte' => 'ok',
		'pending' => 'ok',
	);
	$priroritiesStates = array("critical", "warning", "unknown", "ok");
	foreach($params['items'] as $position => $section)
	{
		// Title is the full title displayed on mouse hover. TitleSmall is the text of 8 char max displayed on the svg view
		$itemsList[$position]['title'] = $section['title'];
		$itemsList[$position]['titleSmall'] = $section['title'];
		if(strlen($itemsList[$position]['titleSmall']) > 8)
		{
			// If more than 8 chars the text will overflow the svg text so remove one char and add ... at the end
			$itemsList[$position]['titleSmall'] = substr($section['title'], 0, 7) . "&hellip;";
		}
		
		$sectionsState = 'ok';
		foreach($section['items'] as $number => $item)
		{
			try
			{
				if(!empty($item['id']) && !empty($item['type']))
				{
					// Get item name, state & page link
					$itemData = array(
						'name' => '',
						'state' => 'unknown',
						'link' => '',
					);
					$listState = array();
					
					if($item['type'] == 'node')
					{
						$node = Model_esia::InstanceNode($dbconnection, $item['id']);
						if(!empty($node))
						{
							// Get node page URL
							$pageControl = Model_esia::getPageControl($dbconnection, $node->getType());
							$pageControl = Model_esia::replacePageControlVariable($pageControl, $node);
							
							$nodeGroup = $node->getGroup();
							if(empty($nodeGroup))
							{
								$nodeGroup = $lang['GROUPNODE_ROOT'];
							}
							$itemData['name'] = $nodeGroup . '>' . $node->getName();
							$itemData['link'] = $pageControl;
							
							// Get states
							$listState = Model_esia::countNodeState($dbconnection, array($item['id']));
						}
					}
					elseif($item['type'] == 'group')
					{
						$group = Model_esia::getGroupDeviceIn($dbconnection, $item['id'])[0];
						//on va rechercher les groupes de noeuds
						if(!empty($group))
						{
							$parent = Model_esia::getParrentGroup($dbconnection, $item['id'])[0];
							if(!empty($parent))
							{
								$group['name'] = $parent['name'] . '>' . $group['name'];
							}
							$itemData['name'] = $group['name'];
							$itemData['link'] = "/node_index.php?nodegroup=" . $item['id'];
							
							// Get states
							$listState = Model_esia::getGroupNodeStates($dbconnection, $user->getId(), $item['id'], FALSE);
							$listState = array_shift($listState); // getGroupNodeStates return an array and we only need the first key which is not allways 0
						}
					}
					
					// Get most important state
					if(!empty($listState))
					{
						// Set all array keys to lowercase
						$listState = array_change_key_case($listState, CASE_LOWER);
						
						foreach($convStates as $p => $state)
						{
							if($listState[$p] > 0)
							{
								$itemData['state'] = $state;
								break;
							}
						}
					}
					$itemsList[$position]['items'][$number] = $itemData;
					
					// Update section state
					$sectionsState = getPriorityState($priroritiesStates, $sectionsState, $itemData['state']);
					// Update global state
					$globalState = getPriorityState($priroritiesStates, $globalState, $itemData['state']);
				}
			}
			catch(EsiaDbException | Exception $e)
			{
				$errors[] = 'ERROR on Node ID ' . $item['id'] . ': ' . $e->getMessage();
			}
		}
		$itemsList[$position]['state'] = $sectionsState;
	}
	
	if(!empty($errors))
	{
		$smarty->assign('l_error', implode('<br>', $errors));
	}
	
	$smarty->assign('itemsList', $itemsList);
	$smarty->assign('globalState', $globalState);
}

function getPriorityState($priorities, $a, $b)
{
	foreach($priorities as $state)
	{
		if(strcasecmp($state, $a) == 0 || strcasecmp($state, $b) == 0 )
		{
			return $state;
		}
	}
	
	// If not found in $priorities
	return 'unknown';
}

$smarty->display($path . '/dashboard/template/view_shield.html');
?>
