<?php
/*DESCRIPTION: inclus les variables habituelles pour la gestion d'une widget et vérifie les droits d'accès
 *APRES l'inclusion du common_widget les variables suivantes sont créées:
 *PHP:
 *      $action l'action passé dans l'url ou 'view'
 *      $widget un tableau associatif reprenant les paramètre de la widget
 * SMARTY
 *      $widget les informations de la widget
 *      $parameter les parametre de la widget (JSON)
 *      $action l'action passé dans l'url ou 'view'
 */
include "./common_widget.php";
if($action =='update')
{
    if(isset($_POST['widgetid'])&&!empty($_POST['widgetid']))
    {
        try
        {
            $widget = getPostDefaultParams($widget,$_POST);
            $params = $widget['option'];
            //Checkbox
            if(isset($_POST['check_warning']))
            {
                $params['warning']=1;
            }
            else
            {
                $params['warning']=0;
            }
            if(isset($_POST['check_critical']))
            {
                $params['critical']=1;
            }
            else
            {
                $params['critical']=0;
            }
            if(isset($_POST['check_unknown']))
            {
                $params['unknown']=1;
            }
            else
            {
                $params['unknown']=0;
            }
            if(isset($_POST['check_statusonly']))
            {
                $params['statusonly']=1;
            }
            else
            {
                $params['statusonly']=0;
            }
            if(isset($_POST['nbr_service']))
            {
            	$params['nbr_service']=1;
            }
            else
            {
            	$params['nbr_service']=0;
            }
            if(isset($_POST['nbr_device']))
            {
            	$params['nbr_device']=1;
            }
            else
            {
            	$params['nbr_device']=0;
            }
            $order = $_POST['inputordernodetype'];
            $order = json_decode($order);
            $params['order'] =$order;
            Model_esia::updateWidget($dbconnection, $widget['id'], $widget['name'], $widget['description'], $widget['during'], $params);
            $widget['option']=$params;
            $smarty->assign('l_success',$lang['UPDATE_DASHBOARD_SUCCESS']);
            $smarty->assign('widget',$widget);
        }
        catch(Exception $e)
        {
            $smarty->assign('l_error',$e->getMessage());
        }
    }
    //echo '<pre>';
    //print_r($params);
    //recupération des styles
    $title = getWidgetStyle($params['title']['style'],14,'left','#575759');
    $description = getWidgetStyle($params['description']['style'],12,'left','#575759');
    $smarty->assign('titlestyle',$title);
    $smarty->assign('descriptionstyle',$description);
    //on va rechercher les différents type de noeud enregistré
    $rows = Model_esia::getDeviceType($dbconnection);
    $smarty->assign('parameter',$widget['option']);
    $list_type=array();
    foreach($rows as $row)
    {
        $list_type[$row['id']]=array('id'=>$row['id'],'name'=>ucfirst($row['name']));
    }
    $smarty->assign('list_typenode',$list_type);
    $order=array();
    foreach($widget['option']['order'] as $row)
    {
        $order[]=array('id'=>$row,'name'=>ucfirst($list_type[$row]['name']));
    }
    $smarty->assign('list_order',$order);
}
else
{
    //AFFICHAGE DES DONNEES
    //on va rechercher les différents type de noeud enregistré
	widgetTranslateNameDescription($widget,$smarty,$lang);
    $rows = Model_esia::getDeviceType($dbconnection);
    $list_type=array();
    foreach($rows as $row)
    {
        $list_type[$row['id']]=$row['name'];
    }
    //AFFICHAGE DES DONNEES
    $arr = Model_esia::countNodeType($dbconnection,$user->getId(), Model_esia::NODE_COUNT_SERVICE_STATE);
    $order=array();
    //print_r($arr);
    $params = $widget['option'];
    //test du premier paramtère
    $arrtest = $params['order'];
    $arrtest = array_shift($arrtest);
    if($arrtest ==0)
    {
    	$params['order'] = array_keys($list_type);
    }
    foreach($params['order'] as $row)
    {
        $name = $list_type[$row];
        if($arrtest==0 && $arr[$name]['nbr_device']==0)
        {
        	continue;
        }
        $ok = $arr[$name]['ok'];
        $warning = $arr[$name]['warning'];
        $critical = $arr[$name]['critical'];
        $unknown = $arr[$name]['unknown'];
        if(empty($ok))
        {
            $ok=0;
        }
        if(empty($warning))
        {
            $warning=0;
        }
        if(empty($critical))
        {
            $critical=0;
        }
        if(empty($unknown))
        {
            $unknown=0;
        }
        if($params['statusonly'] == 0)
        {
            $order[]=array('name'=>$name,
                                'ok'=>$ok,
                                'warning'=>$warning,
                                'critical'=>$critical,
                                 'unknown'=>$unknown,
            					'nbr_device'=>$arr[$name]['nbr_device'],
            					'nbr_service'=>$arr[$name]['nbr_service']
            );
        }
        else
        {
            $status = 'none';
            $label="0/0";
            if($critical > 0)
            {
                $status = 'CRITICAL';
                $label="$critical/$ok";
            }
            elseif($warning > 0)
            {
                $status = 'WARNING';
                $label="$warning/$ok";
            }
            elseif($unknown > 0)
            {
                $status = 'UNKNOWN';
                $label="$unknown/$ok";
            }
            elseif($ok > 0)
            {
                $status = 'OK';
                $label="$ok/$ok";
            }
            $order[]=array('name'=>$name,
                'status'=>$status,
                'label'=>$label);
        }
    }
    $smarty->assign('list_order',$order);
}
$smarty->display($path.'/dashboard/template/view_tab_devicetype.html');
?>
