<?php
/*DESCRIPTION: inclus les variables habituelles pour la gestion d'une widget et vérifie les droits d'accès
 *APRES l'inclusion du common_widget les variables suivantes sont créées:
 *PHP:
 *      $action l'action passé dans l'url ou 'view'
 *      $widget un tableau associatif reprenant les paramètre de la widget
 * SMARTY
 *      $widget les informations de la widget
 *      $parameter les parametre de la widget (JSON)
 *      $action l'action passé dans l'url ou 'view'
 */
include "./common_widget.php";
if($action =='update')
{
	if(isset($_POST['widgetid'])&&!empty($_POST['widgetid']))
	{
		try
		{
		    $widget = getPostDefaultParams($widget,$_POST);
		    $params = $widget['option'];
            $params['column']['group'] = $_POST['input_wgt_grp'];
            $params['column']['message'] = $_POST['input_wgt_msg'];
            $params['column']['exec'] = $_POST['input_wgt_exec'];

		    //Option des noeuds
		    $order = $_POST['inputorderservice'];
		    $order = json_decode($order);
		    $params['order'] =$order;
		    
			Model_esia::updateWidget($dbconnection, $widget['id'], $widget['name'], $widget['description'], $widget['during'], $params);
			$widget['option']=$params;
			$smarty->assign('l_success',$lang['UPDATE_DASHBOARD_SUCCESS']);
			$smarty->assign('widget',$widget);

		}
		catch(Exception $e)
		{
			$smarty->assign('l_error',$e->getMessage());
		}
	}
	$params = $widget['option'];
	//recupération des styles
	$title = getWidgetStyle($params['title']['style'],14,'left','#575759');
	$description = getWidgetStyle($params['description']['style'],12,'#575759');
	$smarty->assign('titlestyle',$title);
	$smarty->assign('descriptionstyle',$description);
	$smarty->assign('type',$params['type']);
	$smarty->assign('parameter',$params);
	if(!empty($params['order']))
	{
	    
        $services=array();
        foreach($params['order'] as $row)
		{
			if(!empty($row))
            {
                $services[]=$row;
            }
		}
        if(!empty($services))
        {
	        $services = Model_esia::getServices($dbconnection,null,$services);
        }
	    $list=array();
	    foreach($services as $ser)
	    {
	        $common_name = Model_esia::getCommonName($lang, $ser['name'],$ser['check_plugin_name']);
	        
	        $list[$ser['id']]=array('id'=>$ser['id'],'name'=>$ser['device_name'].': '.$common_name);
	    }
	    $list_order=array();
	    foreach($params['order'] as $val)
	    {
			if(!empty($val))
            {
	            $list_order[]= $list[$val];
            }
	    }
	    $smarty->assign('list_order',$list_order);  
	}
	$list=array();
	$nodes = Model_esia::getNodeList($dbconnection,$user->getId(),null,Model_esia::NODE_INSTANCE);
	foreach($nodes as $node)
	{
	    $list[]=array('id'=>$node->getId(),
	        'name'=>$node->getGroup().'>'.$node->getName(),
	        'selected'=>'no');
	}
	$smarty->assign('list_nodes', $list);
}
elseif($action =="getservice")
{
    if(!empty($_GET['nodeid']) && is_numeric($_GET['nodeid']))
    {
        $node = Model_esia::InstanceNode($dbconnection, $_GET['nodeid']);
        if($user->getAccess($dbconnection, "device_view",$node->getName())==1)
        {
            $services = Model_esia::getServices($dbconnection,$node->getId());
            //echo '<pre>';print_r($services);
            $list=array();
            foreach ($services as $service)
            {
                $common_name = Model_esia::getCommonName($lang, $service['name'],$service['check_plugin_name']);
                $list[$service['id']]=$common_name;
            }
            echo json_encode($list,true);
            exit(0);
        }
    }
}
else
{
	if(!empty($widget['option']['order']))
	{
        $nodetype = array();
		$arr = Model_esia::getWebPluginByNodeType($dbconnection);
		foreach($arr as $row)
		{
			$nodetype[$row['type']]=$row['apache_path'].$row['control_page'];
		}
        $services=array();
        foreach($widget['option']['order'] as $row)
		{
			if(!empty($row))
            {
                $services[]=$row;
            }
		}
        if(!empty($services))
        {
	        $services = Model_esia::getServices($dbconnection,null,$services);
        }
     
        //echo '<pre>';print_r($services);echo'</pre>';
	    $list=array();
	    foreach($services as $ser)
	    {
			if(array_key_exists($ser['device_type'],$nodetype))
			{
				$page_control = Model_esia::replacePageControlVariable($nodetype[$ser['device_type']],array('id'=>$ser['device_id'],'name'=>$ser['device_name']));
			}
			else
			{
				$page_control = '/node_view.php?nodeid='.$ser['device_id'];
			}
            $groupnode='';
            if ($widget['option']['column']['group']=='on')
            {
                $node =  model_esia::InstanceNode($dbconnection,$ser['device_id']);
                $groupnode = array('name'=>$node->getGroup(),'id'=>$node->getGroupId()) ;
            }
	        $common_name = Model_esia::getCommonName($lang, $ser['name'],$ser['check_plugin_name']);
	        $out = preg_replace('#\|[a-z].*#',"\n",$ser['stdout']);
			$out = trim($out);
			if($ser['real_state']==0)
			{
		    	$lstatus = $lang['LGD_OK'];
			}
			elseif($ser['real_state']==1)
			{
				$lstatus = $lang['LGD_WARN'];
			}
			elseif($ser['real_state']==2)
			{
				$lstatus = $lang['LGD_CRI'];
			}
			elseif($ser['real_state']==3)
			{
				$lstatus = $lang['LGD_UNKNOWN'];
			}

	        $list[$ser['id']]=array('id'=>$ser['id'],
                                    'node'=>$ser['device_name'],
                                    'name'=>$$ser['name'],
                                    'common_name'=>$common_name,
                                    'message'=>$out,
                                    'state'=>$ser['state'],
                                    'real_state'=>$ser['real_state'],
                                    'lang_statut'=>$lstatus,
                                    'exec_time'=>$ser['last_exec_time'],
                                    'page_control'=>$page_control,
                                    'groupnode'=>$groupnode,
                            );
	    }
	    $list_order=array();
	    foreach($widget['option']['order'] as $val)
	    {
	        $list_order[]= $list[$val];
	    }
	    $smarty->assign('list_order',$list_order); 
	}
	else
	{
		$smarty->assign($action,'empty');
	}
}
$smarty->display($path.'/dashboard/template/view_tab_service.html');
?>
