<?php
/*DESCRIPTION: inclus les variables habituelles pour la gestion d'une widget et vérifie les droits d'accès
 *APRES l'inclusion du common_widget les variables suivantes sont créées:
 *PHP:
 *      $action l'action passé dans l'url ou 'view'
 *      $widget un tableau associatif reprenant les paramètre de la widget
 * SMARTY
 *      $widget les informations de la widget
 *      $parameter les parametre de la widget (JSON)
 *      $action l'action passé dans l'url ou 'view'
 */
include "./common_widget.php";
$smarty->assign('path',$dashboard['option']['path']);
$smarty->assign('logo',$dashboard['option']['imageHeader']);
$path_data_logo = $path.'/data/icon_dashboard/';
if($action =='deleteImage')
{
	$img=$_GET['img'];
	$id =$_GET['id'];

	$smarty->assign('ImageDel',$img);
	$smarty->assign('id',$id);
	$smarty->assign('action','deleteImage');

	if(!empty($_POST['idWid']) && isset($_POST['idWid']))
	{
		try
		{
			$returDelImg=unlink($path_data_logo."miniature/".$img);
			if($returDelImg==true)
			{
				$nameImg = explode("min_", $img);
				$returDelImg=unlink($path_data_logo.$nameImg[1]);
				if($returDelImg==true)
				{
					$deleteimage=true;
					$smarty->assign('l_success',$lang['DASHBOARD_DELETE_IMAGE_TEXT']);
					$smarty->assign('action','update');
					$action='update';
				}
				else
				{
					throw new Exception('File img not writable');
				}
			}
			else
			{
				throw new Exception('File img miniature not writable');
			}
		}
		catch (EsiaDbException $e)
		{
			$smarty->assign('l_error',$e->getMessage());
		}
		catch (Exception $e)
		{
			$smarty->assign('l_error',$e->getMessage());
		}
	}

}

if($action =='update')
{
	if(isset($_POST['widgetid'])&&!empty($_POST['widgetid']))
	{
		try 
		{				
		    $widget = getPostDefaultParams($widget,$_POST);
		    $params = $widget['option'];
			
			// Image Logo				
			if($_FILES['imageHeader']['name']!=null) // Si une nouvelle image
			{
				//test si il n'y a pas d'erreur
				if ($_FILES['imageHeader']['error'])
				{
					switch ($_FILES['imageHeader']['error'])
					{
						case 1: // UPLOAD_ERR_INI_SIZE
							throw new Exception('file exceeds the maximum size by server (php.ini)'); break;
						case 2: // UPLOAD_ERR_FORM_SIZE
							throw new Exception('file exceeds the maximum size by HTML form'); break;
						case 3: // UPLOAD_ERR_PARTIAL
							throw new Exception('File transfer was interrupted'); break;
						case 4: // UPLOAD_ERR_NO_FILE
							throw new Exception('the size of file was null'); break;
						default:  throw new Exception('Unknown error');
					}
				}
							
				if(!file_exists($path_data_logo.$_FILES['imageHeader']['name'])) // Si elle n'existe pas déjà
				{
					if(move_uploaded_file($_FILES['imageHeader']['tmp_name'],$path_data_logo.$_FILES['imageHeader']['name'])==true) // Si le dwl s'est bien passé
					{
						$params['imageHeader']="min_".$_FILES['imageHeader']['name'];
						$params['path']=$_FILES['imageHeader']['name'];
							
						//thumbnail creation
						preg_match("/.(\w*)$/", $_FILES['imageHeader']['name'], $match);
						if(is_array($match))
						{
							$file_ext=$match[1];
						}
						$thumbnail = $path_data_logo."miniature/min_".$_FILES['imageHeader']['name'];
						$upload_image = $path_data_logo.$_FILES['imageHeader']['name'];
			
						list($width,$height) = getimagesize($upload_image);
						$ratio = $width/$height;
						$NouvelleHauteur = 58;
						$NouvelleLargeur = (($width * (($NouvelleHauteur * 100)/$height))/100 );
			
						$thumb_create = imagecreatetruecolor($NouvelleLargeur,$NouvelleHauteur);
						$thumb_create_save = imagecreatetruecolor($width,$height);
			
						$white = imagecolorallocate($thumb_create, 255, 255, 255);
						imagefill($thumb_create, 0, 0, $white);
						
						$white = imagecolorallocate($thumb_create_save, 255, 255, 255);
						imagefill($thumb_create_save, 0, 0, $white);
						$file_ext = strtolower($file_ext);
						switch($file_ext)
						{
							case 'jpg':
							case 'jpeg':
								$source = imagecreatefromjpeg($upload_image);
								break;
							case 'png':
								$source = imagecreatefrompng($upload_image);
								break;
							case 'gif':
								$source = imagecreatefromgif($upload_image);
								break;
							case 'bmp':
								$source = imagecreatefrombmp($upload_image);
								break;
							default:
								$source = imagecreatefromjpeg($upload_image);
						}
							
						imagecopyresampled($thumb_create , $source, 0, 0, 0, 0, $NouvelleLargeur, $NouvelleHauteur, $width,$height);
						imagecopyresampled($thumb_create_save , $source, 0, 0, 0, 0, $width, $height, $width,$height);
			
						$size = min(imagesx($thumb_create), imagesy($thumb_create));
						$im2 = imagecrop($thumb_create, ['x' => 0, 'y' => 0, 'width' => $size, 'height' => $size]);
						switch($file_ext)
						{
							case 'jpg':
							case 'jpeg':
								imagejpeg($thumb_create_save,$upload_image);
								imagejpeg($im2,$thumbnail,100);
								break;
							case 'png':
								imagepng($thumb_create_save,$upload_image);
								imagepng($im2,$thumbnail,100);
								break;
							case 'gif':
								imagegif($thumb_create_save,$upload_image);
								imagegif($im2,$thumbnail,100);
								break;
							default:
								imagejpeg($thumb_create_save,$upload_image);
								imagejpeg($im2,$thumbnail,100);
								break;
						}
						imagedestroy($im2);
					}
					else
					{
						throw new Exception('File not download ');
					}
				}
			}
			else
			{
				$params['imageHeader']="min_". $_POST['imageLogo'];
				$params['path']=  $_POST['imageLogo'];
			}
			
			
			$smarty->assign('path',$params['path']);
			$smarty->assign('logo',$params['imageHeader']);
			
			
			Model_esia::updateWidget($dbconnection, $widget['id'], $widget['name'], $widget['description'], $widget['during'], $params);
			$widget['option']=$params;
			$smarty->assign('l_success',$lang['UPDATE_DASHBOARD_SUCCESS']);
			$smarty->assign('widget',$widget);
			$smarty->assign('parameter',$params);
		}
		catch (EsiaDbException $e)
		{
			$smarty->assign('l_error',$e->getMessage());
		}
		catch(Exception $e)
		{
			$smarty->assign('l_error',$e->getMessage());
		}
	}			
	
	$ListImage = ListNomImage($path_data_logo."miniature/");
	$smarty->assign('list_image',$ListImage);			
	
	//recupération des styles
	$title = getWidgetStyle($params['title']['style'],14,'left','#575759');
	$description = getWidgetStyle($params['description']['style'],12,'#575759');
	$smarty->assign('titlestyle',$title);
	$smarty->assign('descriptionstyle',$description);
	$smarty->assign('params',$widget['option']);

	$smarty->assign('title',$lang['DASHBOARD_MESSAGE_SELECTED']);
	$smarty->assign('descr',$lang['DASHBOARD_SELECT_NODE']);
}	
elseif($action !='deleteImage')
{
	$dashboard = model_esia::getWidget($dbconnection,$_GET['id'],$user->getId());
	$dashboard = $dashboard[0];
	$smarty->assign('action','view_img');
	$smarty->assign('path',$dashboard['option']['path']);
	$smarty->assign('logo',$dashboard['option']['imageHeader']);		
}

$smarty->display($path.'/dashboard/template/view_wig_img.html');

/**
 @brief retourne la liste des images
 @detail retourne la liste des images d'un folder donné. (Dans ce cas ci,
 @params string $pathFolder le path du dossier à traiter
 @retval	null|la liste des images triée alphabétiquement
 */

function ListNomImage($pathFolder)
{
	$ext_list = Array("jpg","JPG","jpeg","JPEG","bmp", "BMP", "gif","GIF", "png","PNG"); // Extensions de photo
	$listephotos = Array();
	$dossier = opendir($pathFolder);
	for($i=0; $f = readdir($dossier); $i++)
	{
		if(is_file($pathFolder.$f))
		{
			if($f!="logoFooter.jpg")
			{
				if(in_array(preg_replace("#(.+)\.(.+)#", "$2", $f), $ext_list))
				{
					$listephotos[$i] = $f;
				}
			}
		}
	}
	closedir($dossier);
	sort($listephotos);
	return $listephotos;
}

?>
