<?php

$path = $_SERVER['DOCUMENT_ROOT'];
$ESIA_WIDGET_NOTREE = TRUE;
include_once $path . '/common.php';
include_once $path . '/model_ts_adm.php';
// Gestion du table sorter
$params = array(
    'filters' => $_REQUEST['filters'],
	'order' => $_REQUEST['cols'],
	'size' => 50,
	'paging'=> 0,
);
if(isset($_GET['page']) && !empty($_GET['page']))
{
	$params['paging'] = $_GET['page'];
}
if(isset($_GET['size']) && !empty($_GET['size']))
{
	if($_GET['size'] == 'all')
	{
		$_GET['size'] = 100;
	}
	$params['size'] = $_GET['size'];
}

//Gestion des langues du système / utilisateur pour les données traduite.
$lang_abre = LANG;
if($user->getLang() != "")
{
	//configuration de la langue de l'application
	$lang_abre = $user->getLang();
}
if(file_exists($path . '/lang/' . $lang_abre . '.php'))
{
	include $path . '/lang/' . $lang_abre . '.php';
}

$admin = '';
if(!empty($_GET['admin']))
{
    $admin = $_GET['admin'];
}
$action = '';
if(!empty($_GET['action']))
{
    $action = $_GET['action'];
}

try
{
	if($admin == 'plugin')
    {
		if($action == 'listServices')
		{
			if(empty($_GET['id']) || !is_numeric($_GET['id']))
			{
				throw new Exception("Missing plugin id");
			}
			$dbData = Model_Adm_TableSort::ts_getServicesByPlugin($dbconnection, $_GET['id'], $params);

			// Define table columns
			$columns = array(
				0 => $lang['NODE'],
				1 => $lang['ADM_PLUGIN_SERVICE'],
				2 => $lang['ADM_PLUGIN_LINKED_PATTERN'],
				3 => $lang['STATUS'],
				4 => $lang['ADM_PLUGIN_PARAMETER'],
				5 => $lang['ADM_SERVICE_PARAMS_ORIGIN'],
				6 => $lang['ACTION'],
			);

			// Create table rows
			$rows = array();
			foreach($dbData['rows'] as $service)
			{
				// Create node name cell
				$cellNode = '<td>' . 
					'<a target="_parent" href="' . $service['page_control'] . '" title="' . $lang['ADM_NODE_GOTO'] . '">' .
						$service['device_name'] .
					'</a>' .
				'</td>';

				// Create actions cell
				$serviceUpdUrl = '/administration.php?admin=plugin&category=services&action=update&id=' . $service['plugin_id'] . '&serviceId=' . $service['id'];
				$serviceDelUrl = '/administration.php?admin=plugin&category=services&action=delete&id=' . $service['plugin_id'] . '&serviceId=' . $service['id'];
				$cellActions = '<td class="alignCenterTab actions-cell">' .
					'<a class="btnImg" href="' . $serviceUpdUrl . '" title="' . $lang['MODIF'] . '">' .
						'<img class="button" src="/theme/default-image/esia_update_button2.png" alt="' . $lang['MODIF'] . '"/>' .
					'</a>' .
					'<a class="btnImg" href="' . $serviceDelUrl . '" title="' . $lang['DELETE'] . '">' .
						'<img class="button" src="/theme/default-image/esia_delete_button.png" alt="' . $lang['DELETE'] . '"/>' .
					'</a>' .
				'</td>';

				// Create service name cell
				$cellService = '<td>' . 
					'<a href="' . $serviceUpdUrl . '" title="' . $lang['MODIF'] . '">' .
						$service['name'] .
					'</a>' .
				'</td>';

				// Create state cell
				switch($service['state'])
				{
					case 0:
					case 4:
						$cellState = '<td class="EventOK">' . $lang['LGD_OK'] . '</td>';
						break;
					case 1:
						$cellState = '<td class="EventCritical">' . $lang['LGD_CRI'] . '</td>';
						break;
					case 2:
						$cellState = '<td class="EventWarning">' . $lang['LGD_WARN'] . '</td>';
						break;
					default:
						$cellState = '<td class="EventUnknown">' . $lang['LGD_UNKNOWN'] . '</td>';
						break;
				}

				// Create parameters origin cell. Check service parameters to find if it comme from pattern, plugin or service (modified by user)
				$cellOrigin = $lang['SERVICE'];
				if(strcmp($service['parameter'], $service['pattern_plugin_parameter']) == 0)
				{
					$cellOrigin = $lang['PATTERN'];
				}
				elseif(strcmp($service['parameter'], $service['plugin_parameter']) == 0)
				{
					$cellOrigin = $lang['PLUGIN'];
				}

				$rows[] = array(
					$columns[0] => $cellNode,
					$columns[1] => $cellService,
					$columns[2] => $service['pattern_name'],
					$columns[3] => $cellState,
					$columns[4] => '<td><p>' . $service['parameter'] . '</p></td>',
					$columns[5] => $cellOrigin,
					$columns[6] => $cellActions,
				);
			}

			echo json_encode(array(
				'headers' => $columns,
				'rows' => $rows,
				'total_rows' => $dbData['total'],
			));
		}
	}
}
catch(EsiaDbException | Exception $e)
{
	echo json_encode($e->getMessage());
}
?>
