<?php
/**
 * @name index.php
 * @description page d'accueil de l'application ESIA
 * @author Nicolas Biersart <n.biersart@esia-network.com>
 * @contributor
 * @copyright Nicolas Biersart 2012
 * @license
 * @esia 1.00
 * @version 1.0.0
 * @date 29/11/2016
 */
//fonction qui force le navigateur à afficher la fenetre de téléchargement
//par défaut fichier de type image
function force_download($type='png')
{
	//on force le navigateur à afficher la fenêtre de téléchargement
	header('Content-Type: application/octet-stream');
	header('Content-disposition: attachment; filename=export.'.$type);
	header('Pragma: no-cache');
	header('Cache-Control: no-store, no-cache, must-revalidate, post-check=0, pre-check=0');
	header('Expires: 0');
}
//fonction qui dessine et affiche une image "No data"
function img_no_data()
{
	//pas de donnée à afficher service trop réçent
	$image = imagecreate(200,50);
	$blanc = imagecolorallocate($image, 255, 255, 255);
	$noir = imagecolorallocate($image, 0, 0, 0);
	imagestring($image, 4, 55, 5, "No data ", imagecolorallocate($image, 0, 0, 0));
	//imagestring($image, 4, 35, 15,"for this month", imagecolorallocate($image, 0, 0, 0));
	imagecolortransparent($image, $blanc);
	imagepng($image);
}
$rrdpath='/usr/local/esia/public_html/data/rra/';
$ESIA_WIDGET_NOTREE=true;
include_once 'common.php';
$rrdpath=RRA_DIRECTORY;
session_write_close();
if(!isset($_GET['start'])||empty($_GET['start']))
{
	$_GET['start']='-1d';
}
if(!isset($_GET['end'])||empty($_GET['end']))
{
	$_GET['end']='N';
}
if(isset($_GET['id']))
{
	try
	{
		$data_type="img";
		if(isset($_GET['DEBUG']))
		{
			echo'<pre>'.print_r($opts,true).'</pre>';
		}
		if(isset($_GET['action'])&&$_GET['action']=='export'&& isset($_GET['type'])&&$_GET['type']=='csv' )
		{
			if(!isset($_GET['DEBUG']))
			{
				force_download("csv");
			}
			$data_type="csv";
		}
		elseif(isset($_GET['action'])&&$_GET['action']=='export'&& isset($_GET['type'])&&$_GET['type']=='json' )
		{
			$data_type="json";
		}
		elseif(isset($_GET['action'])&&$_GET['action']=='export'&& isset($_GET['type'])&&$_GET['type']=='jsonC3' )
		{
			$data_type="jsonC3";
		}
		elseif(isset($_GET['action'])&&$_GET['action']=='export')
		{
			force_download();
		}
		else
		{
			//on affiche dans le navigateur (typiquement dans une balise img)
			header("Content-type: image/png");
		}
		//Préparation requete SQL général.
		$service = Model_esia::getServices($dbconnection,null,$_GET['id']);
		$service = $service[0];
        $par[':id'] = $_GET['id'];
        $subsql ="";
        if(!empty($_GET['num']) && is_numeric($_GET['num']))
        {
            if($_GET['num']!='none')
            {
                if($_GET['num'] == 0)
                {
                    $par[':num'] = $_GET['num'];
                    $subsql = "AND (rra_graph_num=:num OR rra_graph_num IS NULL)";
                }
                else
                {
                    $par[':num'] = $_GET['num'];
                    $subsql = "AND rra_graph_num=:num";
                }
            }
        }
        else
        {
            $subsql = "AND (rra_graph_num=rrd_graph_num OR (rra_graph_num IS NULL AND rrd_graph_num IS NULL))";
        }
        $sql = "SELECT service_id,service_name,service_parameter,service_last_stdout,device_name,plugin_name,
							rrd_type,rrd_regex,rrd_time,rrd_name,rrd_max,rrd_min,rrd_vertical_label,rrd_graph_color,rrd_graph_type,
							rrd_regex_threshold,rra_graph_num,rra_file_path
						FROM esia_services
						JOIN esia_service_rra_file ON service_id = rra_service_id
						JOIN esia_device ON device_id = service_device_id
						JOIN esia_plugins ON plugin_id = service_plugin_id
						JOIN rrd_plugins ON rrd_plugin_id=service_plugin_id
						WHERE service_id=:id $subsql
						ORDER BY rra_graph_num NULLS FIRST,rrd_graph_type,rrd_name;";
		//on recupère les données
		$query= $dbconnection->prepare($sql);
		$ret = $query->execute($par);
		if($ret===false)
		{
			$err = $query->errorInfo();
			echo "DB error: ".$err[2]."\n";
			exit(0);
		}
		$arr_rrd=$query->fetchAll(PDO::FETCH_OBJ);
		//liste les information pour générer le graphique et les sépares suivant leurs numéros (clé rrd_graph_num)
		$list_graphs=array();
		$list_file=array();


		foreach($arr_rrd as $row)
		{
			$num = $row->rra_graph_num;
			if(empty($row->rra_graph_num))
			{
				$num=0;
			}
			if(array_key_exists($row->rra_graph_num,$list_graphs))
			{
				array_push($list_graphs[$num],$row);
			}
			else
			{
				$list_graphs[$num][]=$row;
			}
           /* $nodename= preg_replace('#\s+#','_',$row->device_name);
            $nodename= preg_replace('#\/#','_',$nodename);
            $nodename= preg_replace('#\\\\#','_',$nodename);
			$filename = $rrdpath.$nodename.'_'.$row->plugin_name.$row->service_id.$row->rrd_graph_num.'.rrd';*/

			$filename = $rrdpath.$row->rra_file_path;
			if(is_file($filename) && !in_array($filename, $list_file))
			{
				$list_file[]=$filename;
			}
			if(!is_file($filename))
			{
				if($data_type=="jsonC3")
				{
					header('Content-Type: application/json');
					echo json_encode(array("nothing"));
					exit(0);
				}
				else
				{
					$rrd = img_no_data();
					exit(0);
				}
			}
		}
		//print_r($list_file);
		//
		//si le type demandé est CSV
		//
		$consolidation="AVERAGE";
		if(!empty($_GET['consolidation']))
		{
		    switch($_GET['consolidation'])
		    {
		        case 'MINIMUN':$consolidation='MIN';break;
		        case 'MAXIMUN':$consolidation='MAX';break;
		        default: $consolidation="AVERAGE";
		    }
		}
		if($data_type=="csv")
		{
			if(isset($_GET['DEBUG']))
			{
				echo'CSV export<br />';
			}
			//création du tableau d'exportation
			$i=0;
			$csv = array();
			$header["1date"] = "date";
			$nofound =array();
			$resol = 300;
			if($_GET['end']=='N')
			{
				$_GET['end'] = time();
			}
			elseif(preg_match('#\-([0-9]*)d#',$_GET['end'],$regs))
			{
				$_GET['end'] = time()-$regs[1]*24*60*60;
			}
			if($_GET['start']=='N')
			{
				$_GET['start'] = time();
			}
			elseif(preg_match('#\-([0-9]*)d#',$_GET['start'],$regs))
			{
				$_GET['start'] = time()-$regs[1]*24*60*60;
			}
			elseif(preg_match('#\-([0-9]*)h#',$_GET['start'],$regs))
			{
			    $_GET['start'] = time()-$regs[1]*60*60;
			}
			elseif(preg_match('#\-([0-9]*)w#',$_GET['start'],$regs))
			{
			    $_GET['start'] = time()-$regs[1]*24*60*60*7;
			}
			elseif(preg_match('#\-([0-9]*)m#',$_GET['start'],$regs))
			{
			    $_GET['start'] = time()-$regs[1]*24*60*60*30;
			}
			elseif(preg_match('#\-([0-9]*)y#',$_GET['start'],$regs))
			{
			    $_GET['start'] = time()-$regs[1]*24*60*60*365;
			}
			foreach($list_file as $file)
			{

			    $ret = rrd_fetch($file, array( $consolidation,"--start",intval(($_GET['start']/$resol)*$resol), "--end",intval(($_GET['end']/$resol)*$resol) ));
				echo rrd_error ();
				if(isset($_GET['DEBUG']))
				{
					foreach($ret['data'] as $key => $rrddata)
					{
						echo "COUNT: $key: ".count($rrddata).'<br />';
					}
					//echo'<pre>';print_r($ret);echo'</pre>';
				}
				//error_log(json_encode($ret));
				//echo'<pre>';print_r($ret);echo'</pre>';
				foreach($ret['data'] as $key => $rrddata)
				{
					if(!array_key_exists($key,$header))
					{
						$header[$key]=$key;
					}
					if($i==0)
					{
						foreach($rrddata as $time => $value)
						{
							$csv[$time]=array("1date"=>'"'.date('d/m/Y H:i:s',$time).'"',$key => preg_replace('#\.#',',',$value));
						}
						$i++;
					}
					else
					{
						$i++;
						foreach($rrddata as $time => $value)
						{
							//error_log(print_r($csv[$time], true));
							if(array_key_exists($time,$csv))
							{
								$csv[$time][$key]=preg_replace('#\.#',',',$value);
							}
							else
							{
								$flag=0;

								foreach($csv as $csvtime => $row)
								{
									$delta = $csvtime - $time;
									if(isset($_GET['DEBUG']))
									{
										//echo $flag.' DELTA:'.$key.' - '.$time.' = '.$delta.'<br/>';
									}
									if( $delta >= -(60) &&  $delta <=(60))
									{
										$csv[$time][$key]=preg_replace('#\.#',',',$value);
										$flag=1;
										break;
									}
								}
								if($flag ==0)
								{
									if(isset($_GET['DEBUG']))
									{
										//echo $flag.' '.$time.' == '.$value.'<br />';
									}
									if(array_key_exists($time,$nofound))
									{
										$nofound[$time] = array_merge($nofound[$time],array($key=>preg_replace('#\.#',',',$value)) );
									}
									else
									{
										$nofound[$time]=array($key=>preg_replace('#\.#',',',$value));
									}
								}
							}
							//$csv[$time][] = preg_replace('#\.#',',',$value);
						}
					}
				}
			}
			if(isset($_GET['DEBUG']))
			{
				echo'NOTFOUND <br />';
				//echo'<pre>';print_r($nofound);echo'</pre>';
			}
			if(count($nofound)>0)
			{
				$i++;
				foreach($csv as $time => $ligne)
				{
					//echo "LIGNE = ".count($ligne)." < $i <br />";
					$keyabsents = array_diff_key($header,$ligne);
					//print_r($keyabsent);
					if(!empty($keyabsents))
					{
						//chercher la clé manquante
						foreach($keyabsents as $key)
						{
							foreach($nofound as $nofoundtime => $row)
							{
								if(isset($_GET['DEBUG']))
								{
									echo $flag.' DELTA:'.$key.' - '.$time.' = '.$delta.'<br />';
								}
								$delta = $time - $nofoundtime;
								if( $delta >= -720 &&  $delta <=720)
								{
									$csv[$time][$key]= $nofound[$nofoundtime][$key];
									unset($nofound[$nofoundtime][$key]);
									break;
									//array_push($ligne,array_shift($nfline));
								}
							}
						}
					}
				}
			}
			$csv = array_merge(array($header),$csv);
			if(isset($_GET['DEBUG']))
			{
				echo'CSV <br />';
				echo'<pre>';print_r($csv);echo'</pre> NBR:'.$i;
			}
			foreach($csv as $time => $ligne)
			{
				ksort($ligne);
				$stringcsv = implode(";", $ligne);
				echo "$stringcsv\n";
			}
			exit(0);
		}
		//Type JSON
		elseif($data_type=="json")
		{
			header('Content-Type: application/json');
			$jsontable=array();
			$result="";
			foreach($list_file as $file)
			{
			    $ret = rrd_fetch($file, array( $consolidation, "--start",$_GET['start'],"--end", $_GET['end'] ));

				//suppression des caractère NaN de rrd.
				foreach ($ret['data'] as $datasource => $data)
				{
					$tabledata = array();
					foreach ($data as $time => $value)
					{
						if(is_nan($value))
						{
							$value=NULL;
						}
						//$result = $result . "['" . $labels[$i] . "'," . $values[$i] . "]";
						$tabledata[]=array(date('m-d-Y G:i:s',$time),$value);
					}
					$jsontable[$datasource]=$tabledata;
				}
			}
			$out = json_encode($jsontable);
			echo $out;
			exit(0);
		}
		elseif($data_type=="jsonC3")
		{
			header('Content-Type: application/json');
			$parameter = array();
			$convertRRDLabel2C3 = array('second'=>'second',
					'ms'=>'millisecond',
					'percent'=>'percent',
					'bps'=>'bps',
					'packet/s'=>'packetps',
					'temperature'=>'Celsius',
					'connections'=>'number',
					'Bytes' => 'bytes');
			foreach($arr_rrd as $row)
			{
				$parameter[$row->rrd_name] = array('name'=>$row->rrd_name,
								'unity'=>$row->rrd_vertical_label,
								'min'=>$row->rrd_min,
								'type' => Model_esia::RRD_GRAPH_TYPES_TO_C3[$row->rrd_graph_type],
						'color'=>$row->rrd_graph_color);
			}
			$globaljsonC3 = array();
			foreach($list_file as $file)
			{

			    if(isset($_GET['DEBUG']))
			    {
			        echo "CONSOLIDATION:$consolidation<br />";
			    }
			    $ret = rrd_fetch($file, array( $consolidation, "--start",$_GET['start'],"--end", $_GET['end'] ));
				//suppression des caractère NaN de rrd.
				$result="";
				//$date=array('x');
				$data = array();
				$global = array();
				$jsontable=array();
				$dateTable = $ret['data'];
				$last_val = true;
				$now = new DateTimeImmutable();
				$now = $now->getTimestamp();
				foreach ($ret['data'] as $datasource => $data)
				{
					foreach ($data as $time => $value) 
					{
						if ($time === array_key_last($data))
						{
							if(is_nan($value))
							{
								if(($now - $time) < 200 )
								{
									$last_val = false;
								}
							}
						}
						if($last_val == true)
						{
							$jsontable['x'][] = date('Y-m-d G:i:s',$time);
						}
					}
					array_pop($jsontable['x']);
					break;
				}

				//$j = 0;
				foreach ($ret['data'] as $datasource => $data)
				{
					$global['parameter'][] =$parameter[$datasource];
					foreach ($data as $time => $value)
					{
						if ($time !== array_key_last($data) || $last_val===true)
						{
							if(is_nan($value))
							{
								$value=0;
							}
							else
							{
								$value=round($value,2);
							}
							$jsontable[$datasource][] = $value;
						}
					}

					array_pop($jsontable[$datasource]);
					//$j++;
				}
				$global['data'] = $jsontable;
				$globaljsonC3[] = $global;
			}
			//print_r($jsontable);
			if(!empty($globaljsonC3))
				$out = json_encode($globaljsonC3);
			else //quand il n'y a pas de données à afficher.
				$out = json_encode(array("no_data"));

			echo $out;
			exit(0);
		}
		else
		{
			//liste des chemins d'accès au fichier temporaire RRD
			$rrd_files = array();
			 //echo '<pre>';
			//print_r($list_graphs);
			//on va générer les graphique rrd
			foreach($list_graphs as $arr_rrd)
			{
				//ouverture du fichier
				$row=$arr_rrd[0];
                $filename = $rrdpath.$row->rra_file_path;
				//création du titre
				$title = $row->device_name.' - '.$row->service_name;
				//option commune
				$opts = array( "--start", $_GET['start'],"--end",$_GET['end'],"--vertical-label=".$row->rrd_vertical_label,
					   "--title=$title",'--imgformat=PNG','--alt-autoscale-max','--rigid','--graph-render-mode=normal','--slope-mode');
				if($row->rrd_min!=-1)
				{
					$opts[]="--lower-limit=".$row->rrd_min;
				}
				foreach($arr_rrd as $row)
				{
					$val=$row->rrd_name.$row->service_id;
					$opts[]="DEF:".$row->rrd_name."=".$filename.":".$row->rrd_name.":AVERAGE";
					$opts[]="CDEF:".$val."=".$row->rrd_name;
				}
				foreach($arr_rrd as $row)
				{
					$val=$row->rrd_name.$row->service_id;
					/*$opts[]="DEF:".$row->rrd_name."=".$filename.":".$row->rrd_name.":AVERAGE";
					$opts[]="CDEF:".$val."=".$row->rrd_name;*/
					$opts[]=$row->rrd_graph_type.":".$row->rrd_name.$row->rrd_graph_color.":".$row->rrd_name;
					$opts[]="GPRINT:".$val.":LAST:Current\:%4.1lf %s ";
					$opts[]="GPRINT:".$val.":AVERAGE:Average\:%4.1lf %s ";
					$opts[]="GPRINT:".$val.":MAX:Maximum\:%4.1lf %s\\j";
					//trace des 2 lignes de seiul d'alerte
					if(@preg_match($row->rrd_regex_threshold,$row->service_parameter,$regs))
					{
						$opts[]="COMMENT:\\n";
						$opts[]="HRULE:".$regs[2]."#770505:".$row->rrd_name." critical threshold";
						$opts[]="COMMENT:\\n";
						$opts[]="HRULE:".$regs[1]."#997700:".$row->rrd_name." warning threshold";
					}
				}
				$ret = rrd_graph($rrdpath."rrd".$row->rra_graph_num.".png", $opts);
					if(isset($_GET['DEBUG']))
					{
						echo'<pre>'.print_r($opts,true).'</pre>';
					}
				if( !is_array($ret) )
			   	{
					if(isset($_GET['DEBUG']))
					{
			     			$err = rrd_error();
			    			echo "rrd_graph() ERROR: $err\n";
					}
				}
				else
				{
					//ok le fichier est généré.
					$rrd_files[$row->rra_graph_num] = $rrdpath."rrd".$row->rra_graph_num.".png";
				}
			}
			//header("Content-Length: " . filesize($rrdpath."rrd.png")*2));
			$graphimgs = array();
			$total_hauteur=0;
			$total_largeur=0;
			foreach($rrd_files as $files)
			{
				$rrd = imagecreatefrompng($files);
				$graphimgs[]= $rrd;
				$total_hauteur = $total_hauteur + imagesy($rrd);
				if($total_largeur <  imagesx($rrd))
				{
					$total_largeur = imagesx($rrd);
				}
			}
			//creation de l'image
			$image = imagecreatetruecolor($total_largeur,$total_hauteur);
		  	imagealphablending($image,false);
		  	imagesavealpha($image,true);
			//superposition des images
			$nextY = 0;
			for($i=0;$i<count($graphimgs);$i++)
			{
				$rrd = $graphimgs[$i];
				imagecopy($image, $rrd, 0, $nextY, 0, 0, imagesx($rrd), imagesy($rrd));
				$nextY = $nextY + imagesy($rrd);
			}
			imagepng($image);
		}
	}
	catch(EsiaDbException $e)
	{
		echo $e->getMessage();
	}
}
?>
