<?php
include_once DEVICE_CLASS;
include_once MVCMODEL;
include_once $path.'/plugin/gesa/model_gesa.php';
include_once '/usr/local/esia/keystore/scripts/keystore.lib.php';
include_once $path.'/libs/logo_oid.hash.php';

/**
 * @name adm_device.inc.php
 * @description Page gérant les noeuds (ajout,suppression,modification de noeud ou des services associé)
 * 				elle est incluse par la page administration.php
 * @author Nicolas Biersart <n.biersart@esia-network.com>
 * @contributor
 * @copyright Nicolas Biersart 2013
 * @license
 * @esia 1.00
 * @version 1.0.0
 * @date 10/04/2013
 */

$smarty->assign('adm_device', 'adm_device');
//vérification des droits d'accès
$SUCCESS=null;
$action='listNode';
$category='node';
if($user->getDroits($dbconnection,"esia_device") ==1)
{
	if(!empty($_SESSION['ADM_MESSAGE']))
	{
		if($_SESSION['ADM_MESSAGE']['TYPE']=='SUCCESS')
		{
			$SUCCESS[]=$_SESSION['ADM_MESSAGE']['MESSAGE'];
		}
		else
		{
			$ERROR[]=array('name'=>'Advance node error','message'=>$_SESSION['ADM_MESSAGE']['MESSAGE']);
		}
		unset($_SESSION['ADM_MESSAGE']);
	}
    try
    {
        //on récupère l'action demandée si il n'y a pas de demande on liste.
        if(isset($_GET['action']))
	    {
		    $action = $_GET['action'];
	    }
        //type de vue demandé
        //on récupère l'action demandée si il n'y a pas de demande on liste.
        if(isset($_GET['category']))
	    {
		    $category = $_GET['category'];
	    }
        $smarty->assign('category', $category);
        //chargement des informations sur le noeuds
        if(is_numeric($_GET['id']))
		{
            $node = Model_esia::InstanceNode($dbconnection,$_GET['id']);
            $smarty->assign('adm_node_id',$node->getId());
            $smarty->assign('adm_dev_id',$node->getId());
            $smarty->assign('adm_device_id',$node->getId());
            $smarty->assign('adm_device_id',$node->getId());
			$smarty->assign('adm_node_name',$node->getName());
        }
        if( $category =='node')
        {
            //
            // traitement de l'ajout ou de la modification d'un noeud
            //
	        $err_treat=0;
	        if($action=="treat_create")
	        {
                try
                {
                    //
                    //Paramètre généraux
                    //
                    $node = new Device();
                    //Si le nom est vide on lève une exception
                    if(isset($_POST['name'])&&!empty($_POST['name']))
                    {
			            $node->setName($_POST['name']);
                    }
                    else
                    {
                        throw new DeviceException('NODENAME_ISEMPTY');
                    }
                    // on vérie qu'il y a bien une IP sinon on met la 0.0.0.0
                    $tip="0.0.0.0";
		            if(!empty($_POST['ip']))
                    {
                        $tip = $_POST['ip'];
                        $tip = preg_replace('#\s+#','',$tip);
                    }
		            $node->setIPAddress($tip);
                    // Groupe de noeuds
				    $devgroup=array();
				    if(isset($_POST['nodegroup'])&&!empty($_POST['nodegroup']))
                    {
					    $devgroup = $_POST['nodegroup'];
                    }
				    $node->setGroupList($devgroup);
                    //type et derscrtiption
				    $node->setType($_POST['type']);
				    $node->setDescription($_POST['description']);

                    //
                    //Paramètre SNMP
                    //
				    $node->setSNMPVersion($_POST['snmpversion']);
				    $node->getSNMPObject()->setRemotePort($_POST['adm_snmp_port']);
				    $node->getSNMPObject()->setTimeout($_POST['adm_snmp_timer']*1000);
				    if($_POST['snmpversion']==1||$_POST['snmpversion']==2)
				    {
					    $node->setSNMPCommunity($_POST['snmpcommunity']);
				    }
				    elseif($_POST['snmpversion']==3)
				    {
					    if(isset($_POST['snmp3_user'])&&!empty($_POST['snmp3_user'])&&isset($_POST['snmp3_key'])&&!empty($_POST['snmp3_key']))
						    $node->setSNMP3Parameter($_POST['snmp3_user'],$_POST['snmp3_seclvl'],$_POST['snmp3_authprot'],$_POST['snmp3_key'],$_POST['snmp3_privprot'],$_POST['snmp3_keypriv']);
				    }
                    //
                    // Mise à jour de la DB
                    //
				    if(isset($_POST['modif'])&&is_numeric($_POST['modif']))
				    {
					    $node->setId($_POST['modif']);
                        //
                        //Vérifie s'il y a des changement pour l'update automatique des services
                        //
                        $nodeUpdate = Model_esia::InstanceNode($dbconnection,$_POST['modif']);
                        $reload = false;
                        if($node->getSNMPCommunity() !=$nodeUpdate->getSNMPCommunity() || $node->getIPAddress() != $nodeUpdate->getIPAddress())
                        {
                            //changement détecté on va rechargé les services
                            $reload=true;
                        }
					    //mise à jour du noeud
					    Model_adm::updateDevice($dbconnection,$node);
                        //lie à la GESA
					    $gesa = Model_adm::getGesaLink($dbconnection,$node->getId());
					    if($gesa!=null)
					    {
					    	Model_adm::unlinkGesaNode($dbconnection,$gesa->getId(),$node->getId());
					    }
					    if($_POST['gesa']!=-1 &&  $node->getType() !="gesa")
                        {
                            Model_adm::linkGesaNode($dbconnection,$_POST['gesa'],$node->getId());
                        }
                        $action='modif';
					    $_GET['id'] = $node->getId();
                        $SUCCESS[]=$lang['ADM_UPDATE_SUCCESS'];
                        if($reload==true)
                        {
                            try
                            {
                                Model_adm::reloadService($dbconnection,$_GET['id']);
                            }
                            catch(Exception $e)
                            {

                            }
                            $SUCCESS[]=$lang['ADM_RELOAD_NODE_SUCCESS'];
                        }
                    }
                    else
                    {
                        //Ajout du noeud
					    $node->setId(Model_adm::addNode($dbconnection,$node));
					    $esialog->write('ESIA NODE', 'add node '.$node->getName().' success');
					    //Mise à jour des droits d'accès (groupe root)
					    Model_adm::addDeviceInDefaultGroup($dbconnection,$node);
					    //lie à la GESA
					    if(isset($_POST['gesa']) && $_POST['gesa']!=-1)
					    {
					    	Model_adm::linkGesaNode($dbconnection,$_POST['gesa'],$node->getId());
					    }
                        $SUCCESS[]=$lang['ADM_INSERT_SUCCESS'];
                        $smarty->assign('l_adm_insert_success', $lang['ADM_INSERT_SUCCESS']);
				        $smarty->assign('adm_success_nodeid',$node->getId());
                        //
                        //on regarde s'il n'y a pas une configuration avancé à faire
                        //
                        $configs=array();
                        $webid = Model_esia::getWebPluginByNodeType($dbconnection,$node->getType());
                        if(!empty($webid))
                        {
                            $configs = Model_adm::getAdvanceNodeConfigType($dbconnection,null,$webid['id']);
                        }
                        //il y a une configuration avancée à faire
                        if(!empty($configs))
                        {
                            $config=$configs[0];
                            $idconfig = Model_adm::addAdvanceNodeConfig($dbconnection,$node->getId(),$config['id'],$config['parameter']);
                            $url= $config['web_plugin_path'].$config['controller'].'?node='.$node->getId().'&id='.$idconfig.'&action=add';
                            header('Location: '.$url);
                            exit(0);
                        }
                        //
                        //Ajout classique
                        //
					    try
					    {
					    	if(!empty($node->getSNMPVersion()))
					    	{
							    $sysdescr = $node->getSysDescr();
							    $objectid = $node->getSysObjectId();
							    if(@get_class($node)=='RemoteDevice')
							    {
								    $is_gesa = true;
							    }
							    $smarty->assign('adm_device_id',$node->getId());
							    $settings = IANA::getSettingsName($objectid, $sysdescr);
							    $pattern  = IANA::getPatternAdvised($is_gesa,$settings);
								if( !empty($pattern))
								{
									$patternfound = Model_adm::getPatternService($dbconnection,$pattern);
									if( count($patternfound) == 1)
									{
										$patternfound = array_pop($patternfound);
										$smarty->assign('adm_proposed_pattern_id',$patternfound['id']);
										$smarty->assign('adm_proposed_pattern',$patternfound['name']);
									}
								}
					    	}
					    }
					    catch(Exception $e)
					    {

					    }
                    }
                }
                catch(DeviceException $e)
                {
                    if($e->getMessage() == 'NODENAME_ISEMPTY')
                    {
                        $ERROR[]=array('name'=>'NAME IS EMPTY','message'=>$lang['ADM_ERR_NAME_FAILED']);
                    }
			        $err_treat=1;
                }
			    catch(EsiaDbException $e)
			    {
				    $err_treat=1;
				    $esialog->write('ESIA NODE', 'INSERT_FAILED '.$e->getMessage());

				    if(preg_match("/device_name_unique/",$e->getMessage()))
				    {
					    $ERROR[]=array('name'=>'INSERT_NODE_FAILED','message'=>$lang['ADM_INSERT_DEVICE_FAILED_DUPLICATE_NAME']);
				    }
				    else
				    {
					    $ERROR[]=array('name'=>'INSERT_NODE_FAILED','message'=>$e->getMessage().'<br />');
				    }
			    }
            }
			elseif($action == 'duplicate')
			{
				if( !isset($_REQUEST['name']) ) //On charge le formulaire de duplication
				{
					$smarty->assign('src_adm_node_name',$node->getName());
					$smarty->assign('new_adm_node_name','COPY_'.$node->getName());
					$smarty->assign('adm_ip',$node->getIPAddress());
					$smarty->display('adm_device/duplicatenode.html');
					exit(0);
				}
				else  //On charge la page d'administration
				{
					$new_name = $_REQUEST['name'];
					$new_addr = $_REQUEST['ip'];

					$alsoAdvConf = isset($_REQUEST['alsoAdvConf']);
					$alsoGroupAccess = isset($_REQUEST['alsoGroupAccess']);
					$alsoSrv = isset($_REQUEST['alsoSrv']);
					$alsoAlert = ( isset($_REQUEST['alsoSrv']) && isset($_REQUEST['alsoAlert']));

					try
					{
						$src_node_id = $node->getID();
						$new_node_id = Model_adm::copyDeviceNode($dbconnection,$node,$new_name,$new_addr,FALSE,FALSE,FALSE,FALSE);
					}
					catch(Exception $ex)
					{
						if( FALSE !== strpos($ex->getMessage(),'device_name_unique' ) )
						{
							$smarty->assign('ERRORS',array(array('name'=>'Error','message'=>$lang['DUPLICATE_ERROR_DEVICE_NAME_UNIQ'])));
						}
						else
						{
							$smarty->assign('ERRORS',array(array('name'=>'Error','message'=>$ex->getMessage())));
						}

						$smarty->assign('src_adm_node_name',$new_name);
						$smarty->assign('new_adm_node_name',$new_name);
						$smarty->assign('adm_ip',$new_addr);

						$smarty->assign('alsoAdvConf',$alsoAdvConf);
						$smarty->assign('alsoGroupAccess',$alsoGroupAccess);
						$smarty->assign('alsoSrv',$alsoSrv);
						$smarty->assign('alsoAlert',$alsoAlert);

						$smarty->display('adm_device/duplicatenode.html');
						exit(0);
					}

					//Le noeud est dupliquer si on arrive ici, donc les exceptions sont threatés par l'admin de noeud habituel
					$node = Model_esia::InstanceNode($dbconnection,$new_node_id);
					$smarty->assign('adm_node_id',$node->getId());
					$smarty->assign('adm_dev_id',$node->getId());
					$smarty->assign('adm_device_id',$node->getId());
					$smarty->assign('adm_device_id',$node->getId());
					$smarty->assign('adm_node_name',$node->getName());

					try
					{
						if( $alsoAdvConf )
						{
							Model_adm::copyNodeAdvanceConfig($dbconnection,$src_node_id,$new_node_id);
						}
					}
					catch(Exception $e)
					{
						$ERROR[]=array('name'=>'Unable to copy conf','message'=>$e->getMessage());
					}
					try
					{
						if( $alsoGroupAccess )
						{
							Model_adm::copyNodeUserGroupAccess($dbconnection,$src_node_id,$new_node_id,TRUE);
						}
					}
					catch(Exception $e)
					{
						$ERROR[]=array('name'=>'Unable to copy access','message'=>$e->getMessage());
					}
					try
					{
						if( $alsoSrv )
						{
							Model_adm::copyNodeServicesAndPatterns($dbconnection,$src_node_id,$new_node_id,$alsoAlert);
						}
					}
					catch(Exception $e)
					{
						$ERROR[]=array('name'=>'Unable to copy services/patterns','message'=>$e->getMessage());
					}
					$_GET['id'] = $node->getId();
					$action = 'modif';
				}
			}
            //
            // DEMANDE CLASSIQUE (hors traitemement).
            //
            if($action=="listNode")
            {
                $smarty->assign('adm_node_action', 'listNode');
                $smarty->assign('adm_list_node', array());
            }
            //Si on veut ajouter un noeud, le modifier ou qu'il y a eu une erreur de traitement
            elseif($action=="create"||$action=="modif"||$err_treat!=0)
            {
                $smarty->assign('adm_node_action', $action);

                //partie propre au GESA
                $gesas = Model_esia::getNodebyType($dbconnection,$user->getId(),'gesa');
                $list_gesa=array();
                foreach($gesas as $gesa)
                {
                	$list_gesa[]=array('id'=>$gesa->getid(),'name'=>$gesa->getName());
                }
                $smarty->assign('adm_gesas', $list_gesa);

                //
                // Ajout, Modification et erreur de traitement on vérifie
                //
			    if($action=="modif" || $err_treat==1)
			    {

                    //GESA
				    $selectgesa=-1;
                    $node = new Device();
				    if(is_numeric($_GET['id']) && $err_treat==0)
				    {
                        $node = Model_esia::InstanceNode($dbconnection,$_GET['id']);
				        $gesa = Model_adm::getGesaLink($dbconnection,$node->getId());
				        if($gesa!=null)
				        {
					        $selectgesa = $gesa->getId();
				        }
                        $smarty->assign('adm_node_action', 'modif');
                    }
                    else
                    {
                        //si c'est une erreur de traitement on recharge les données.
			            $node->setName($_POST['name']);
		                $node->setIPAddress($tip);
				        $node->setGroupList($_POST['nodegroup']);
				        $node->setType($_POST['type']);
				        $node->setDescription($_POST['description']);
				        $node->setSNMPVersion($_POST['snmpversion']);
				        //$node->getSNMPObject()->setRemotePort($_POST['adm_snmp_port']);
				        $node->setSNMPPort($_POST['adm_snmp_port']);
				        $node->setSNMPTimeout($_POST['adm_snmp_timer']*1000);
				        $node->setSNMPCommunity($_POST['snmpcommunity']);
					    $node->setSNMP3Parameter($_POST['snmp3_user'],$_POST['snmp3_seclvl'],$_POST['snmp3_authprot'],$_POST['snmp3_key'],$_POST['snmp3_privprot'],$_POST['snmp3_keypriv']);
                        $selectgesa = $_POST['gesa'];
                        $smarty->assign('adm_node_action', 'create');
                    }
                    $smarty->assign('adm_select_gesa',$selectgesa);
				    $smarty->assign('adm_device', $node);
				    $smarty->assign('adm_node_id',$node->getId());
				    $smarty->assign('adm_dev_id',$node->getId());
				    $smarty->assign('adm_device_id',$node->getId());
				    $smarty->assign('adm_ip',$node->getIPAddress());
				    $smarty->assign('adm_node_name',$node->getName());
				    $smarty->assign('adm_snmp_version',$node->getSNMPVersion());
				    $smarty->assign('adm_snmp_port',$node->getSNMPPort() );
				    $smarty->assign('adm_snmp_timer',$node->getSNMPTimeout()/1000);
				    $smarty->assign('adm_community',$node->getSNMPCommunity());
				    $smarty->assign('adm_snmp3_user',$node->getSNMPObject()->getSNMP3User());
				    $smarty->assign('adm_snmp3_key',$node->getSNMPObject()->getSNMP3AuthKey());
				    $smarty->assign('adm_snmp3_authprot',$node->getSNMPObject()->getSNMP3AuthProtocol());
				    $smarty->assign('adm_snmp3_seclvl',$node->getSNMPObject()->getSNMP3SecLevel());
				    $smarty->assign('adm_node_type',$node->getType());
				    $smarty->assign('adm_grp',$node->getGroup());
				    $smarty->assign('adm_description',htmlentities($node->getDescription(),ENT_QUOTES));
				    $smarty->assign('adm_snmp3_keypriv',$node->getSNMPObject()->getPrivacyKey());
				    $smarty->assign('adm_snmp3_privprot',$node->getSNMPObject()->getPrivacyProtocol());
				    $smarty->assign('adm_dev_list_group',$node->getGroupList());
				    $smarty->assign('adm_select_gesa',$selectgesa);
                }
			    else
			    {
				    //on veut ajouter un noeud
			    	$smarty->assign('adm_snmp_port','161');
				    $smarty->assign('adm_snmp_timer','1000');
				    $smarty->assign('adm_select_gesa',-1);
				    $smarty->assign('adm_dev_list_group',array());
			    }

                //
                // Récupération des informations classique
                //
               	//on va rechercher les différents type de noeud enregistré
                $rows = Model_esia::getDeviceType($dbconnection);
			    $list_type=array();
			    foreach($rows as $row)
			    {
			        if(!($action=="create" && $row['name']=='gesa'))
			        {
			            $list_type[]=array('id'=>$row['name'],'name'=>ucfirst($row['name']));
			        }
			    }
                $smarty->assign('adm_type_list', $list_type);
                //partie propre au GESA
                $gesas = Model_esia::getNodebyType($dbconnection,$user->getId(),'gesa');
                $list_gesa=array();
                foreach($gesas as $gesa)
                {
                	$list_gesa[]=array('id'=>$gesa->getid(),'name'=>$gesa->getName());
                }
                $smarty->assign('adm_gesas', $list_gesa);
                //on liste les différents groupes de noeud
                $arr = Model_esia::getGroupDevice($dbconnection);
			    $select =array();
			    foreach($arr as $top)
			    {
			    	$select[]=array('id'=>$top['id'],'name'=>$top['fullpath']);
			    }
			    $smarty->assign('adm_nodegroup', $select);
                //version SNMP accepté
		        $arr_snmp[1]="SNMP v1";
		        $arr_snmp[2]="SNMP v2c";
		        $arr_snmp[3]="SNMP v3";
		        $smarty->assign('snmp_version',$arr_snmp);
            }
            elseif($action=="delete")
            {
		        //on a confirmer la suppression
		        if(is_numeric($_POST['deviceid']))
		        {
			        try
			        {
				        //si il y a un web plugin on va traiter la suppression du noeud
				        $dev = Model_esia::InstanceNode($dbconnection, $_POST['deviceid']);
				        $type = Model_esia::getDeviceType($dbconnection,null,$dev->getId());
				        $r = Model_esia::getServices($dbconnection,$dev->getId());
				        foreach($r as $service)
				        {
					        Model_adm::deleteService($dbconnection,$service['id']);
				        }
				        Model_adm::deleteNode($dbconnection,$dev->getId());
				        $esialog->write('ESIA NODE', 'DELETE NODE '.$dev->getName().'('.$dev->getIPAddress().')');
				        $SUCCESS[]=$lang['ADM_DELETE_SUCCESS'];
				        //redirection si il y a un plugin web pour ce type de noeud
				        $type = Model_esia::getWebPluginByNodeType($dbconnection, $dev->getType() );
				        if($type!=null)
				        {
					        if(isset($type['admin_page']))
					        {
						        $redirection=$type['apache_path'].$type['admin_page'];
						        $redirection = preg_replace('#:action#','delete',$redirection);
						        $redirection = preg_replace('#:dev_id#',$dev->getId(),$redirection);
						        $redirection = preg_replace('#&amp;#','&',$redirection);
						        header('Location: '.$redirection);
						        exit();
					        }
				        }
			        }
			        catch(EsiaDbException $e)
			        {
				        $esialog->write('ESIA NODE', 'DELETE FAILED '.$e->getMessage());
				        $ERROR[]=array('name'=>'DELETE NODE FAILED','message'=>$e->getMessage());
			        }
                    $smarty->assign('adm_node_action', 'end');
		        }
		        else
		        {
			        //message de confirmation avant suppression
			        $smarty->assign('adm_node_action', 'delete');
			        $node = Model_esia::InstanceNode($dbconnection,$_GET['id']);
			        $list=array('id'=>$node->getId(),
					        'name'=>$node->getName(),
					        'type'=>$node->getType(),
					        'group'=>$node->getGroup(),
					        'ip'=>$node->getIPAddress(),
					        'prot_connect'=>$node->getTypeConnection());
			        $smarty->assign('device', $list);
			        $smarty->assign('adm_device', $list);
                    $smarty->assign('adm_node_id',$node->getId());
                    $smarty->assign('adm_dev_id',$node->getId());
                    $smarty->assign('adm_device_id',$node->getId());
			        $smarty->assign('adm_node_name',$node->getName());
		        }
            }
        }
        //
        // GESTION DES CONFIGURATION AVANCEE
        //
        elseif($category=="advancenode")
        {
            if($action=="add")
            {
                if(!empty($_POST['config_type']) && !empty($_GET['id']))
                {
                    try
                    {
                        $configs = Model_adm::getAdvanceNodeConfigType($dbconnection,$_POST['config_type']);
                        $configs = $configs[0];
                        Model_adm::addAdvanceNodeConfig($dbconnection,$_GET['id'],$_POST['config_type'],$configs['parameter']);
                        $SUCCESS[] = $lang['ADM_ADVANCE_NODE_ADD_SUCCESS'];
                    }
                    catch(Exception $e)
                    {
	                    $ERROR[]=array('name'=>'Database Error','message'=>$lang['ADM_ADVANCE_NODE_ADD_FAILED'].' '.$e->getMessage());
                    }
                }
                else
                {
                    $ERROR[]=array('name'=>'HTML Error','message'=>'Bad parameter');
                }
                $action = "list";
            }
            elseif($action=="delete")
            {
                //Model_adm::deleteAdvanceNodeConfig($dbconnection,$_POST['config_type']);
                if(!empty($_POST['configid']))
                {
                    try
                    {
                        $configs = Model_adm::deleteAdvanceNodeConfig($dbconnection,$_POST['configid']);
                        $SUCCESS[] = $lang['ADM_ADVANCE_NODE_DELETE_SUCCESS'];
                        $action='list';
                    }
                    catch(Exception $e)
                    {
	                    $ERROR[]=array('name'=>'Database Error','message'=>$lang['ADM_ADVANCE_NODE_DELETE_FAILED'].' '.$e->getMessage());
                    }
                }
                elseif(!empty($_GET['configid']))
                {
                    $configs = Model_adm::getAdvanceNodeConfig($dbconnection,null,$_GET['configid']);
                    $configs = $configs[0];
                    $smarty->assign('adm_node_advance_config', $configs);
                    $smarty->assign('adm_node_action', 'delete');
                }
            }
            $smarty->assign('adm_node_action', $action);
            if($action=="list")
            {
                $id=$_GET['id'];
                //récupération des données du select
                $node = Model_esia::InstanceNode($dbconnection,$_GET['id']);
                $webid = Model_esia::getWebPluginByNodeType($dbconnection,$node->getType());
                $configs = Model_adm::getAdvanceNodeConfigType($dbconnection);
                $list=array();
                foreach($configs as $config)
		        {
                    if($config['web_plugin_activate'] != 0 || empty($config['web_plugin_activate']))
                    {
                        if(array_key_exists('ADV_NODE_'.$config['name'],$lang))
                        {
                            $config['name'] = $lang['ADV_NODE_'.$config['name']];
                        }
                        if(empty($config['web_plugin_id']))
                        {
                            $list[]=$config;
                        }
                        elseif($config['web_plugin_id'] == $webid['id'])
                        {
                            $list[]=$config;
                        }

                    }
                }
                $smarty->assign('adv_config_type', $list);
                //on récupère les config déjà créée

                $configs = Model_adm::getAdvanceNodeConfig($dbconnection,$node->getId());
                foreach($configs as $key => $config)
		        {
                    $url= $config['web_plugin_path'].$config['controller'].'?id='.$config['id'].'&action=update&node='.$node->getId();
                    $configs[$key] = array_merge($config,array('url'=>$url));
                }
                $smarty->assign('adv_node_config', $configs);
            }
        }
        //
        // GESTION DES SERVICES AJOUT, SUPPRESSION, MODIFICATION
        //
        elseif($category=="services")
        {

            if($action=="addtreat")
            {
                $json = json_decode($_POST['formServiceTable'],true);
                if(!empty($json))
                {
                    if($_POST['formAddFast']==1)
                    {
                        foreach($json as $service)
                        {
                            try
                            {
                                Model_adm::addService($dbconnection,$service['name'],$service['plugin'],$node->getId(),$service['interval'],$service['parameter'],$service['priority'],0,'');
					            $esialog->write('ESIA SERVICE', 'ADD '.$service['name'].' on node id '.$node->getId().' interval: '.$service['interval']);
                            }
                            catch(Exception $e)
                            {
                    			$esialog->write('ESIA ALERT', 'ADD SERVICE FAILED '.$e->getMessage());
                    			$ERROR[]=array('name'=>$lang['ADM_NODE_ADD_SERVICE_FAILED'],'message'=>$service['name'].' '.$e->getMessage());
                            }
                        }
                        if(empty($ERROR))
                        {
                            $SUCCESS[] = $lang['ADM_PLUGIN_ADD_SUCCESS'];
                        }
                        $action="add";
                    }
                    else
                    {
                        //on va configurer
                        $action="configure";
                        $list=array();
                        foreach($json as $service)
                        {
                             $plugin = Model_esia::getPlugin($dbconnection,$service['plugin']);
                             $plugin=$plugin[0];
                             $list[]=array('id'=>$plugin['id'],
                                'name'=>$service['name'],
                             	'plugin_name'=>$plugin['name'],
                                'default_parameter'=>$plugin['parameter'],
                                'default_interval'=>$service['interval']/1000,
                                'priority'=>$plugin['priority'],
                                'html_template'=>preg_replace('#'.$_SERVER['DOCUMENT_ROOT'].'#','/',$plugin['html_template'])
                            );
                        }
                        $smarty->assign('list_service', $list);

                    }
                }
                else
                {
                    echo 'aucune service selectionné';
                    $action="add";
                }

            }
            if($action=="modiftreat")
            {
                if(!empty($_POST['plugin_id']))
                {
                    $_GET['serviceid'] = $_POST['service_id'];
                    $id=$_POST['plugin_id'];
                    if(!empty($_POST['plug-'.$id.'-configuration-name']))
                    {
                        try
                        {
                            $name = $_POST['plug-'.$id.'-configuration-name'];
                            $interval = $_POST['plug-'.$id.'-configuration-interval'];
                            $priority = $_POST['plug-'.$id.'-configuration-priority'];
                            $paramater = $_POST['plug-'.$id.'-configuration-parameter'];
                            //$dbconnection,$id,$name,$plugin,$node,$interval,$parameter,$priority,$alert,$alert_param,$unknown=null,$warning=null,$critical=null,$ok=null)
                            Model_adm::UpdateService($dbconnection,$_POST['service_id'],$name,$id,$node->getId(),$interval*1000,$paramater,$priority,-1);
				            $esialog->write('ESIA SERVICE','UPDATE SUCCESS '.$_POST['serviceid']);
				            $SUCCESS[] = $lang['ADM_PLUGIN_UPDATE_SUCCESS'];
                        }
			            catch(EsiaDbException $e)
			            {
                            if(preg_match('#duplicate\s+key#',$e->getMessage()))
                            {
				                $esialog->write('ESIA SERVICE','UPDATE SUCCESS '.$_POST['serviceid']);
				                $SUCCESS[] = $lang['ADM_PLUGIN_UPDATE_SUCCESS'];
                            }
                            else
                            {
				                $esialog->write('ESIA SERVICE','INSERT/UPDATE FAILED '.$e->getMessage());
				                $ERROR[]=array('name'=>'INSERT/UPDATE SERVICE ERROR','message'=>$e->getMessage());
                            }
			            }
                    }
                }
                $action='modif';
            }
            elseif($action=="execute")
            {
                $json = array();
                $pluginid=$_GET['pluginid'];
                try
                {
                    $service = Model_esia::getPlugin($dbconnection,$pluginid);
					$path = $service[0]['path'];

					$service[0]['parameter'] = $_GET['parameter'];
 					$params = Model_esia::getServiceExecutableParameters($dbconnection,$service[0],$node);

					exec($path." ".$params." 2>&1",$output,$result);
					$output=implode("\n",$output);
					$output=utf8_encode($output);

                    $json['output']=explode("|",$output)[0];;
                    $json['return']=$result;

					$STR_STATUS=array("LGD_OK","LGD_WARN","LGD_CRI","LGD_UNKNOWN");
					if( isset($STR_STATUS[$result]))
					{
						$json['state']=$lang[$STR_STATUS[$result]];
					}
					else
					{
						$json['return']=2;
						$json['state']= $lang['ERROR'];
					}
                }
                catch(Exception $e)
                {
                    echo $e->getMessage()."<br>";
                    $smarty->assign('executeService', $e->getMessage());
                }
                echo json_encode($json);
                exit(0);
            }
            elseif($action=="delete")
            {
                //traitement de la suppression du service
		        if(!empty($_POST['serviceid'])&&is_numeric($_POST['serviceid']))
		        {
			        try
			        {
				        Model_adm::deleteService($dbconnection , $_POST['serviceid']);
				        $esialog->write('ESIA SERVICE','DELETE SUCCESS '.$_POST['serviceid']);
				        $SUCCESS[] = $lang['ADM_PLUGIN_DEL_SUCCESS'];
			        }
			        catch(EsiaDbException $e)
			        {
				        $esialog->write('ESIA SERVICE','DELETE FAILED '.$e->getMessage());
				        $ERROR[]=array('name'=>'DELETE SERVICE ERROR','message'=>$e->getMessage());
			        }
			        $action='list';
			        $_GET['id'] = $_POST['nodeid'];
		        }
		        else
		        {
			        //message de confirmation de la suppression
			        $smarty->assign('adm_dev', 'delservice');

			        $service = Model_esia::getServices($dbconnection,null,$_GET['service']);
			        $service=$service[0];
			        $serv=array('id'=>$service['id'],
					        'name'=>$service['name'],
					        'description'=>$service['description'],
					        'node'=>$service['device_name'],
					        'nodeid'=>$service['device_id'],
			        );
			        $dev=array('id'=>$service['device_id'],
					        'name'=>$service['device_name'] );
			        $smarty->assign('adm_device', $dev);
			        $smarty->assign('service', $serv);
		        }
            }
            elseif($action=="reload")
            {
                try
                {
                    Model_adm::reloadService($dbconnection,$_GET['id']);
                }
                catch(Exception $e)
                {

                }
                ob_clean();
                echo $lang['ADM_RELOAD_NODE_SUCCESS']; exit(0);
            }
            $smarty->assign('adm_node_action', $action);
            if($action=="add")
            {
                //$node = Model_esia::InstanceNode($dbconnection,$_GET['id']);
                //on récupère tout les plugins de check
			    $plugins = Model_esia::getPlugin($dbconnection);
			    $list=array();
                $manufacturer=array();
                //$manufacturer[]='HP';
                //$manufacturer[]='CISCO';
                //$manufacturer[]='ZYXEL';
			    foreach($plugins as $plugin)
			    {
                    $common_name = Model_esia::getCommonName($lang,$plugin['name'],$plugin['name']);
                    $type = explode('_',$plugin['name']);
				    $list[]=array('id'=>$plugin['id'],
						    'name'=>$plugin['name'],
						    'default_parameter'=>$plugin['parameter'],
						    'default_interval'=>$plugin['interval_time'],
						    'priority'=>$plugin['priority'],
						    'description'=>$plugin['description'],
                            'type'=>$type[0],
                            'tag'=>$plugin['tag'],
                            'manufacturer'=>$plugin['manufacturer'],
                            'common'=>$common_name
				    );
                    if(!in_array($plugin['manufacturer'],$manufacturer))
                    {
                        $manufacturer[]=$plugin['manufacturer'];
                    }
			    }
			    //on récupère les programmes d'alertes
			    $alerting = Model_esia::getAlertingSoftware($dbconnection);
			    foreach ($alerting as $k=>$programAlert)
			    {
				    $alerting[$programAlert['id']]['default_parameter'] = preg_replace('#\$USERMAIL#',$user->getEmail() ,$alerting[$programAlert['id']]['default_parameter']);
			    }
			    $smarty->assign('list_alerting', $alerting);
			    $smarty->assign('list_plugins', $list);
                $smarty->assign('list_manufacturer', $manufacturer);
			    //GESA
			    $selectgesa=-1;
			    $gesa = Model_adm::getGesaLink($dbconnection,$node->getId());
			    if($gesa!=null)
			    {
				    $selectgesa = $gesa->getId();
			    }
			    $smarty->assign('adm_select_gesa',$selectgesa);
            }
            elseif($action=="modif")
            {
                $service = Model_esia::getServices($dbconnection,null,$_GET['serviceid']);
                $service=$service[0];
                $plugin = Model_esia::getPlugin($dbconnection,$service['plugin_id']);
                $plugin=$plugin[0];
                $list=array('id'=>$service['id'],
                                'name'=>$service['name'],
                                'pluginid'=>$service['plugin_id'],
                				'plugin_name'=>$plugin['name'],
                                'default_parameter'=>$service['parameter'],
                                'default_interval'=>$service['interval_time']/1000,
                                'priority'=>$service['priority'],
                                'html_template'=>preg_replace('#'.$_SERVER['DOCUMENT_ROOT'].'#','/',$plugin['html_template'])
                            );
                $smarty->assign('service',$list);
			    //on récupère les programmes d'alertes
			    $alerting = Model_esia::getAlertingSoftware($dbconnection);
			    foreach ($alerting as $key => $program)
			    {
				    $alerting[$program['id']]['default_parameter'] = preg_replace('#\$USERMAIL#',$user->getEmail() ,$alerting[$program['id']]['default_parameter']);
			    }
			    $smarty->assign('list_alerting', $alerting);
            }
            elseif($action=="list")
            {

                $id=$_GET['id'];

		        $plugins = Model_esia::getServices($dbconnection,$id,NULL,NULL,TRUE);
		        $list=array();
		        foreach($plugins as $service)
		        {
                    $common_name = Model_esia::getCommonName($lang,$service['name'],$service['check_plugin_name']);
			        $list[]=array('id'=>$service['id'],
                            'common'=>$common_name,
					        'name'=>$service['name'],
			        		'plugin_name' => $service['check_plugin_name'],
					        'interval'=>$service['interval_time'],
					        'description'=>$service['description'],
							'pattern_name'=>$service['pattern_name'],
			        );
		        }
		        $smarty->assign('list_service', $list);
            }
        }
        //
        // GESTION DES ALERTS
        //
        elseif($category=="alerts")
        {
            if($action=='update')
            {
            	try
            	{
	            	if(!empty($_POST['formAlertingTable']))
	            	{
	            		$arr = json_decode($_POST['formAlertingTable'],true);
	            		Model_adm::updateServiceProgramAlert($dbconnection, $arr);
	            		$esialog->write('ESIA ALERT', 'UPDATE SUCCESS ');
	            		$SUCCESS[] = $lang['ADM_USER_UPDATE_SUCCESS'];
	            	}
            	}
            	catch(Exception $e)
            	{
            		//suprime le message d'erreur duplicate key
            		if(preg_match('#.*pending_primary_key.*#', $e->getMessage()))
            		{
            			$esialog->write('ESIA ALERT', 'UPDATE SUCCESS ');
            			$SUCCESS[] = $lang['ADM_USER_UPDATE_SUCCESS'];
            		}
            		else
            		{
            			$esialog->write('ESIA ALERT', 'UPDATE FAILED '.$e->getMessage());
            			$ERROR[]=array('name'=>$lang['ADM_PLUGIN_SOFTWARE_ALERTING_UPDATE_FAILED'],'message'=>$e->getMessage());
            		}
            	}
            	$action='list';
            }
            $smarty->assign('adm_node_action', $action);
            if($action=="list")
            {

                $id=$_GET['id'];
		        $plugins = Model_esia::getServices($dbconnection,$id);
               // print_r($plugins);
		        $list=array();
		        foreach($plugins as $service)
		        {
                    $common_name = Model_esia::getCommonName($lang,$service['name'],$service['check_plugin_name']);
			        $list[]=array('id'=>$service['id'],
                            'common'=>$common_name,
					        'name'=>$service['name'],
					        'alert_prog_id'=>$service['alerting_program_id'],
					        'alert_prog_name'=>$service['alerting_program_name'],
                            'alert_prog_param'=>$service['alerting_program_parameter'],
                            'alert_prog_ok'=>$service['alerting_program_ok'],
                            'alert_prog_warning'=>$service['alerting_program_warning'],
                            'alert_prog_critical'=>$service['alerting_program_critical'],
                            'alert_prog_unknown'=>$service['alerting_program_unknown']
			        );
		        }
		        $smarty->assign('list_service', $list);
			    //on récupère les programmes d'alertes
			    $alerting = Model_esia::getAlertingSoftware($dbconnection);
			    foreach ($alerting as $key => $program)
			    {
				    $alerting[$program['id']]['default_parameter'] = preg_replace('#\$USERMAIL#',$user->getEmail() ,$alerting[$program['id']]['default_parameter']);
			    }
			    $smarty->assign('list_alerting', $alerting);
            }
        }
        //
        // GESTION DES PATTERNS
        //
        elseif($category=="pattern")
        {
            $smarty->assign('adm_node_action', $action);
            //On lie un pattern à un noeud et on ajoute les service correpondant
            if($action=="assign")
            {
		        if(isset($_POST['id'])&&is_numeric($_POST['id'])&&isset($_POST['pattern'])&&is_numeric($_POST['pattern']) )
		        {
			        try
			        {
				        Model_adm::assignPatternServiceNode($dbconnection, $_POST['pattern'], $_POST['id']);
				        $SUCCESS[] = $lang['ADM_PATTERN_NODE_ASSIGN_SUCCESS'];
				        $_GET['id']= $_POST['id'];
				        $action='list';

			        }
			        catch(EsiaDbException $e)
			        {
				        $esialog->write('ESIA NODE', 'ASSIGN PATTERN '.$e->getMessage());
				        $ERROR[]=array('name'=>'ASSIGN_PATTERN_FAILED','message'=>$e->getMessage());
			        }
		        }
            }
	        //On délie un pattern à un noeud et on supprime les service correpondant
	        elseif($action=='unassign')
	        {
		        if(isset($_POST['id'])&&is_numeric($_POST['id'])&&isset($_POST['pattern'])&&is_numeric($_POST['pattern']) )
		        {
			        Model_adm::unassignPatternServiceNode($dbconnection, $_POST['pattern'], $_POST['id']);
			         $SUCCESS[] = $lang['ADM_PATTERN_NODE_UNASSIGN_SUCCESS'];
			        $_GET['id']= $_POST['id'];
			        $action='list';
		        }
		        else
		        {
			        //message de confirmation
			        $pattern = Model_adm::getPatternService($dbconnection,$_GET['patternid']);
			        $pattern = $pattern[$_GET['patternid']];
			        $smarty->assign('pattern',$pattern);
		        }
	        }
	        elseif($action=='unlink')
	        {
		        if(isset($_POST['id'])&&is_numeric($_POST['id'])&&isset($_POST['pattern'])&&is_numeric($_POST['pattern']) )
		        {
			        Model_adm::unlinkPatternServiceNode($dbconnection, $_POST['pattern'], $_POST['id']);
			         $SUCCESS[] = $lang['ADM_PATTERN_UNLINK_SUCCESS'];
			        $_GET['id']= $_POST['id'];
			        $action='list';
		        }
		        else
		        {
			        //message de confirmation
			        $pattern = Model_adm::getPatternService($dbconnection,$_GET['patternid']);
			        $pattern = $pattern[$_GET['patternid']];
			        $smarty->assign('pattern',$pattern);
		        }
            }
            if($action=="list")
            {
                $node = Model_esia::InstanceNode($dbconnection,$_GET['id']);
                $smarty->assign('adm_node_id',$node->getId());
                $smarty->assign('adm_dev_id',$node->getId());
                $smarty->assign('adm_device_id',$node->getId());
			    $smarty->assign('adm_node_name',$node->getName());
                $smarty->assign('adm_node_action', "list");
		        $listpattern = Model_adm::getPatternService($dbconnection);
		        $listpatternAss =  Model_adm::getPatternService($dbconnection,null,$_GET['id']);
		        $list = array();
		        foreach($listpatternAss as $pattern)
		        {
			        $list[$pattern['id']]=array('id'=>$pattern['id'],'name'=>$pattern['name']);
		        }
		        $listpatternAss = $list;
		        $list = array();
		        foreach($listpattern as $pattern)
		        {
			        if(array_key_exists($pattern['id'],$listpatternAss)==false)
				        $list[$pattern['id']]=array('id'=>$pattern['id'],'name'=>$pattern['name']);
		        }
		        $listpattern = $list;

		        $smarty->assign('list_patternAssign',$listpatternAss);
		        $smarty->assign('list_pattern',$listpattern);
            }
        }
    }
    catch(Exception $e)
    {
	    $ERROR[]=array('name'=>'Unknown Error','message'=>$e->getMessage());
    }
    $smarty->assign('SUCCESS',$SUCCESS);
}
else
{
    $ERROR[]=array('name'=>'Access Error','message'=>$lang['NO_ACCESS']);
}

?>
