<?php
/**
 * @name adm_pattern_service.inc.php
 * @description Page gérant les patterns de service (ajout/suppression et modification).
 * @author Nicolas Biersart <n.biersart@esia-network.com>
 * @contributor
 * @copyright Nicolas Biersart 2013
 * @license
 * @esia 1.00
 * @version 1.0.0
 * @date 15/05/2013
 */
$smarty->assign('adm_tpl', 'adm_tpl');
if(isset($_GET['action']))
{
	$action = $_GET['action'];
}
else
{
	//action par défaut on liste les patterns présent
	$action="list";
}
$check_propagate = FALSE;

if(isset($_GET['id']))
{
	$pattern = Model_adm::getPatternService($dbconnection,$_GET['id']);
	$pattern = $pattern[$_GET['id']];
	$smarty->assign('pattern_id',$pattern['id']);
}

//Si category est vide, alors on est dans la boite de dialogue supprimer ou alors dans la page admin > plugins > patterns
//Voir les categories pour les autres boites de dialogues
if(empty($_GET['category']))
{
	//Boutton delete de la liste de pattern de la page admin > plugins > patterns
	//2 étapes :
	// - On affiche une dialog de confirmation (si $_POST['id'] est absent)
	// - On delete le pattern  si $_POST['id'] est present
	if($action=='deletepattern')
	{
		$_GET['category'] = 'plugins';
		try
		{
			//on supprimer le pattern
			if(isset($_POST['id'])&&is_numeric($_POST['id']))
			{
				Model_adm::deletePatternService($dbconnection,$_POST['id']);
				$smarty->assign('l_action_success',$lang['ADM_PATTERN_DELETE_SUCCESS']);
				$esialog->write('ESIA PATTERN','pattern delete success ');
				$smarty->assign('adm_tpl', 'deletedpattern');
			}
			//on affiche la page de confirmation
			else
			{
				$pattern = Model_adm::getPatternService($dbconnection,$_GET['id']);
				$pattern = $pattern[$_GET['id']];
				$smarty->assign('pattern', $pattern);
				$smarty->assign('pattern_id', $pattern['id']);
				$smarty->assign('adm_tpl', 'deletepattern');
				$smarty->assign('l_cancel',$lang['CANCEL']);
				$smarty->assign('l_yes',$lang['YES']);
				$smarty->assign('l_message1',$lang['ADM_PATTERN_DELETE_MESSAGE1']);
				$smarty->assign('l_message2',$lang['ADM_PATTERN_DELETE_MESSAGE2']);
			}
		}
		catch(EsiaDbException $e)
		{
			$esialog->write('ESIA PATTERN','DELETE SERVICE FAILED'.$e->getMessage());
			$ERROR[]=array('name'=>'DELETE SERVICE PATTERN','message'=>$e->getMessage());
		}
	}
	//Liste de pattern de la page admin > plugins > patterns
	if($action=='list')
	{
		$smarty->assign('adm_tpl', 'listTpl');
		try
		{
			$list = Model_adm::getPatternService($dbconnection);
			$smarty->assign('list_pattern', $list);
			$smarty->assign('adm_tpl', 'list');
		}
		catch(EsiaDbException $e)
		{
			echo  $e->getMessage();
		}
	}
}

//Le code qui suit concerne les boites de dialogue ajouter/dupliquer/modifier un pattern
//Voir ci-dessous pour boite de dialogue supprimer et page admin > plugins > patterns
if(isset( $_GET['category']))
{
	$category = $_GET['category'];

	$name = '';
	$description = '';

	//Les 2 actions 'add' et 'duplicate' (ci-dessous) ajoutent ou dupliquent un pattern
	//La category passe ensuite à 'plugin' afin de permettre directement l'ajout/modification des included
	if( $category == 'pattern' && !empty($_POST['pattern_name']) && $action != 'update' )
	{
		$name = $_POST['pattern_name'];
		$description = $_POST['pattern_description'];

		try
		{
			if( $action == 'add')
			{
				//Recherche tous les services ids via checkbox-$id
				$services_list = array();
				foreach($_REQUEST as $value)
				{
					$exp = explode('-',$value);
					if($exp[0] == 'checkbox')
					{
						$services_list[] = $exp[1];
					}
				}
				if( !empty($services_list))
				{
					$_GET['id'] = Model_adm::makeIncludedFromServices($dbconnection,$name,$description,$services_list);
					if( isset($_REQUEST['link_node'] ) && $_REQUEST['link_node'] == 'on')
					{
						Model_adm::moveServicesNodeToPatternServices($dbconnection,$services_list,$_GET['id']);
					}
				}
				else
				{
					$_GET['id'] = Model_adm::addPatternService($dbconnection,$name,$description);
				}
			}
			elseif( $action == 'duplicate')
			{
				$pattern = Model_adm::getPatternService($dbconnection,$_GET['id']);
				$pattern = $pattern[$_GET['id']];
				$plugins = $pattern['plugins'];

				$nodes_id_list = $_POST;
				unset($nodes_id_list['pattern_name']);
				unset($nodes_id_list['pattern_description']);

				//On traduit les keys pour le add
				foreach($plugins as $key => $row)
				{
					$row['plugin'] = $row['plugin_id'];
					$row['alerting_software'] = $row['alerting'];
					$plugins[$key] = $row;
				}

				$_GET['id'] = Model_adm::addPatternService($dbconnection,$name,$description,$plugins);
				if( !empty($nodes_id_list))
				{
					Model_adm::moveNodesToPatternServices($dbconnection,$pattern['id'],$_GET['id'],$nodes_id_list);
				}
			}
			$smarty->assign('l_action_success',$lang['ADM_PATTERN_ADD_SUCCESS']);
			$esialog->write('ESIA PATTERN','pattern add success '.$name);
		}
		catch(Exception $e)
		{
			$esialog->write('ESIA PATTERN','ADD PATTERN FAILED'.$e->getMessage());
			$ERROR[]=array('name'=>'ADD PATTERN FAILED','message'=>$e->getMessage());
		}

		$category ='plugins';
		$action='list';
	}

	$smarty->assign('category',$category);

	//Ci-dessous les différents onglets la boite de dialogue ajouter/dupliquer/modifier
	if( $category == 'pattern' )
	{
		//Concerne la page de duplication et la modification de pattern
		//L'action ajouter en base de donnée ce fait plus haut car on change ensuite pour la categorie plugin.
		if( $action != 'add' )
		{
			$pattern = Model_adm::getPatternService($dbconnection,$_GET['id']);
			$pattern = $pattern[$_GET['id']];
			$plugins = $pattern['plugins'];

			$name = $pattern['name'];
			$description = $pattern['description'];
		}
		//Concerne uniquement la page de duplication
		//L'action ajouter en base de donnée ce fait plus haut car on change ensuite pour la categorie plugin.
		if( $action == 'duplicate' )
		{
			$name = "COPY_$name";
			$nodes = generateNodeList($dbconnection,$pattern);
			$smarty->assign('nodes',$nodes['nodes']);
		}
		elseif( $action == 'export')
		{
			$node_id = $_REQUEST['nodeid'];
			$plugins = Model_esia::getServices($dbconnection,$node_id,NULL,NULL,TRUE);
			$list=array();
			foreach($plugins as $service)
			{
				$common_name = Model_esia::getCommonName($lang,$service['name'],$service['check_plugin_name']);
				$list[]=array('id'=>$service['id'],
						'common'=>$common_name,
						'name'=>$service['name'],
						'plugin_name' => $service['check_plugin_name'],
						'interval'=>$service['interval_time'],
						'description'=>$service['description'],
						'pattern_name'=>$service['pattern_name'],
				);
			}
			$smarty->assign('list_service', $list);
			$smarty->assign('current_nodes',$node_id);
		}
		//Concerne uniquement la page modification de pattern.
		//Ici on modifie en base de donnée
		elseif( $action == 'update' )
		{
			$name = $_POST['pattern_name'];
			$description = $_POST['pattern_description'];

			try
			{
				Model_adm::updatePatternService($dbconnection,$pattern['id'],$name,$description,$plugins,FALSE);
				$smarty->assign('l_action_success',$lang['ADM_PATTERN_UPDATE_SUCCESS']);
				$esialog->write('ESIA PATTERN','pattern update success '.$name);
			}
			catch(Exception $ex)
			{
				$esialog->write('ESIA PATTERN','UPDATE PATTERN FAILED '.$e->getMessage());
				$ERROR[]=array('name'=>'UPDATE PATTERN FAILED','message'=>$e->getMessage());
			}
		}

		$smarty->assign('pattern_name',$name);
		$smarty->assign('pattern_description',$description);
	}
	elseif( $category =='plugins')
	{
		//
		 // GESTION DES SERVICES AJOUT, SUPPRESSION, MODIFICATION
		 //

		 //addtreat est le traitement qui ajoute les includeds en base de donnée ou affiche la page de configuration de ceux-ci
		 if($action=="addtreat")
		 {
			$pattern = Model_adm::getPatternService($dbconnection,$_GET['id']);
 		 	$pattern = $pattern[$_GET['id']];

			 $json = json_decode($_POST['formServiceTable'],true);
			 if(!empty($json))
			 {
				 //On ajoute le plugin en base de donnée
				 if($_POST['formAddFast']==1)
				 {
					 foreach($json as $service)
					 {
						 try
						 {
							 $plugins[] = array(
								 'id' =>  NULL,
								 'name' => $service['name'],
								 'plugin' => $service['plugin'],
								 'interval' => $service['interval'],
								 'priority' => $service['priority'],
								 'parameter' => $service['parameter'],
							 );

							 Model_adm::updatePatternService($dbconnection,$pattern['id'],$pattern['name'],$pattern['description'],$plugins,FALSE);
							 $esialog->write('ESIA PATTERN','pattern update success '.$name);
 						 	 $smarty->assign('l_action_success',$lang['ADM_PATTERN_UPDATE_SUCCESS']);
						 }
						 catch(Exception $e)
						 {
							 $esialog->write('ESIA PATTERN','ADD/UPDATE SERVICE PATTERN FAILED'.$e->getMessage());
				 			 $ERROR[]=array('name'=>'ADD/UPDATE SERVICE PATTERN FAILED','message'=>$e->getMessage());
						 }
					 }
					 if(empty($ERROR))
					 {
						 $SUCCESS[] = $lang['ADM_PLUGIN_ADD_SUCCESS'];
					 }
					 $action="list";
				 }
				 else
				 {
					 //on va permettre de configurer le(s) included avant appel a addtreat
					 $action="configure";
					 $list=array();
					 foreach($json as $row)
					 {
						  $plugin = Model_esia::getPlugin($dbconnection,$row['plugin']);
						  $plugin=$plugin[0];
						  $list[]=array('id'=>$plugin['id'],
							 'name'=>$row['name'],
							 'plugin_name'=>$plugin['name'],
							 'default_parameter'=>$plugin['parameter'],
							 'default_interval'=>$row['interval']/1000,
							 'priority'=>$plugin['priority'],
							 'html_template'=>preg_replace('#'.$_SERVER['DOCUMENT_ROOT'].'#','/',$plugin['html_template'])
						 );
					 }
					 $smarty->assign('list_service', $list);

				 }
			 }
			 else
			 {
				 echo 'aucune service selectionné';
				 $action="add";
			 }

		 }
		 //Action de modification du plugin dans la base de donnée
		 if($action=="modiftreat")
		 {
			 if(!empty($_POST['plugin_id']))
			 {
				 $pattern = Model_adm::getPatternService($dbconnection,$_GET['id']);
				 $pattern = $pattern[$_GET['id']];

				 $_GET['serviceid'] = $_POST['service_id'];
				 $id=$_POST['plugin_id'];
				 if(!empty($_POST['plug-'.$id.'-configuration-name']))
				 {
					 try
					 {
						 $plugins[] = array(
							 'id' =>  $_GET['serviceid'],
							 'name' => $_POST['plug-'.$id.'-configuration-name'],
							 'plugin' => $id,
							 'interval' => $_POST['plug-'.$id.'-configuration-interval']*1000,
							 'priority' => $_POST['plug-'.$id.'-configuration-priority'],
							 'parameter' => $_POST['plug-'.$id.'-configuration-parameter'],
						 );
						 //$dbconnection,$id,$name,$plugin,$node,$interval,$parameter,$priority,$alert,$alert_param,$unknown=null,$warning=null,$critical=null,$ok=null)
					//	 Model_adm::UpdateService($dbconnection,$_POST['service_id'],$name,$id,$node->getId(),$interval*1000,$paramater,$priority,-1);
						 Model_adm::updatePatternService($dbconnection,$pattern['id'],$pattern['name'],$pattern['description'],$plugins,FALSE);
						 $esialog->write('ESIA PATTERN','pattern update success '.$name);
						 $smarty->assign('l_action_success',$lang['ADM_PATTERN_UPDATE_SUCCESS']);
					 }
					 catch(EsiaDbException $e)
					 {
						 if(preg_match('#duplicate\s+key#',$e->getMessage()))
						 {
							 $esialog->write('ESIA SERVICE','UPDATE SUCCESS '.$_POST['serviceid']);
							 $SUCCESS[] = $lang['ADM_PLUGIN_UPDATE_SUCCESS'];
						 }
						 else
						 {
							 $esialog->write('ESIA SERVICE','INSERT/UPDATE FAILED '.$e->getMessage());
							 $ERROR[]=array('name'=>'INSERT/UPDATE SERVICE ERROR','message'=>$e->getMessage());
						 }
					 }
				 }
			 }
			 $action='modif';
		 }
		 //Action de suppresion de l'included en base de donnée
		 elseif($action=="delete")
		 {
			 //traitement de la suppression du service
			 if(!empty($_REQUEST['serviceid']))
			 {

				 $pattern = Model_adm::getPatternService($dbconnection,$_GET['id']);
				 $pattern = $pattern[$_GET['id']];
				 $smarty->assign('pattern_id', $pattern['id']);

				 try
				 {
					 Model_adm::deleteServiceOfPattern($dbconnection, $_REQUEST['serviceid']);
					 $smarty->assign('l_action_success',$lang['ADM_PLUGIN_DEL_SUCCESS']);
					 $esialog->write('ESIA PATTERN','pattern delete service success ');
				 }
				 catch(EsiaDbException $e)
				 {
					$esialog->write('ESIA PATTERN','DELETE SERVICE PATTERN FAILED'.$e->getMessage());
		 			$ERROR[]=array('name'=>'DELETE SERVICE PATTERN','message'=>$e->getMessage());
				 }
				 $action='list';
				 $category=null;
			 }
			 else
			 {

				 //message de confirmation de la suppression
				 $smarty->assign('adm_dev', 'delservice');

				 $service = Model_esia::getServices($dbconnection,null,$_GET['service']);
				 $service=$service[0];
				 $serv=array('id'=>$service['id'],
						 'name'=>$service['name'],
						 'description'=>$service['description'],
						 'node'=>$service['device_name'],
						 'nodeid'=>$service['device_id'],
				 );
				 $dev=array('id'=>$service['device_id'],
						 'name'=>$service['device_name'] );
				 $smarty->assign('adm_device', $dev);
				 $smarty->assign('service', $serv);
			 }
		 }
		 $smarty->assign('adm_node_action', $action);
		 //Affiche la dialog permettant de choisir les included à ajouter
		 if($action=="add")
		 {
			 //on récupère tout les plugins de check
			 $plugins = Model_esia::getPlugin($dbconnection);
			 $list=array();
			 $manufacturer=array();

			 foreach($plugins as $plugin)
			 {
				 $common_name = Model_esia::getCommonName($lang,$plugin['name'],$plugin['name']);
				 $type = explode('_',$plugin['name']);
				 $included_list[]=array('id'=>$plugin['id'],
						 'name'=>$plugin['name'],
						 'default_parameter'=>$plugin['parameter'],
						 'default_interval'=>$plugin['interval_time'],
						 'priority'=>$plugin['priority'],
						 'description'=>$plugin['description'],
						 'type'=>$type[0],
						 'tag'=>$plugin['tag'],
						 'manufacturer'=>$plugin['manufacturer'],
						 'common'=>$common_name
				 );
				 if(!in_array($plugin['manufacturer'],$manufacturer))
				 {
					 $manufacturer[]=$plugin['manufacturer'];
				 }
			 }
			 $smarty->assign('list_alerting', $alerting);
			 $smarty->assign('list_plugins', $included_list);
			 $smarty->assign('list_manufacturer', $manufacturer);
		 }
		 //Affiche la dialog permettant de modifier un included
		 if($action=="modif" )
		 {
			 $selected_plugin = $_GET['serviceid'];
			 $pattern = Model_adm::getPatternService($dbconnection,$_GET['id']);
			 $pattern = $pattern[$_GET['id']];
			 $smarty->assign('pattern_id', $pattern['id']);
			 $included_plugin = NULL;
			 foreach($pattern['plugins'] as $row){
				 	if( $row['id'] == $selected_plugin )
					{
						$included_plugin = $row;
						break;
					}
			 }

			 $plugin = Model_esia::getPlugin($dbconnection,$included_plugin['plugin_id']);
			 $plugin=$plugin[0];

			 $list=array('id'=>$included_plugin['id'],
							 'name'=>$included_plugin['name'],
							 'pluginid'=>$included_plugin['plugin_id'],
							 'plugin_name'=>$included_plugin['plugin_name'],
							 'default_parameter'=>$included_plugin['parameter'],
							 'default_interval'=>$included_plugin['interval']/1000,
							 'priority'=>$included_plugin['priority'],
							 'html_template'=>preg_replace('#'.$_SERVER['DOCUMENT_ROOT'].'#','/',$plugin['html_template'])
						 );

			 $smarty->assign('service',$list);
		 }
		 //Affiche dans la dialog la liste des included du pattern
		 if($action=="list")
		 {
			 $pattern = Model_adm::getPatternService($dbconnection,$_GET['id']);
			 $pattern = $pattern[$_GET['id']];
			 $smarty->assign('pattern_id', $pattern['id']);

			 $list=array();
			 foreach($pattern['plugins'] as $service)
			 {
				 $plugin = Model_esia::getPlugin($dbconnection,$service['plugin_id']);
				 $plugin=$plugin[0];

				 $common_name = Model_esia::getCommonName($lang,$service['name'],$service['check_plugin_name']);
				 $list[]=array('id'=>$service['id'],
						 'common'=>$common_name,
						 'name'=>$service['name'],
						 'plugin_name' => $service['plugin_name'],
						 'interval'=>$service['interval'],
						 'description'=>$plugin['description'],
						 'parameters'=>$service['parameter'],
				 );
			 }

			 $smarty->assign('category', 'plugins');
			 $smarty->assign('list_service', $list);
		 }
		 $check_propagate = TRUE;
	}
	//Onglet alerts de la dialog. Met a jour en base de donnée si nécessaire et affiche toujours la liste.
	else if( $category =='alerts')
	{
		$pattern = Model_adm::getPatternService($dbconnection,$_GET['id']);
		$pattern = $pattern[$_GET['id']];
		$plugins = $pattern['plugins'];

		//Partie ou on met à jour en base de donnée.
		if( $action == 'update')
		{
			$arr = json_decode($_POST['formAlertingTable'],true);
			foreach($plugins as $key => $plugin)
			{
				foreach($arr as $row)
				{
					if( $plugin['id'] == $row['serviceid'])
					{
						$plugin['alerting_software'] = $row['progid'];
						$plugin['alerting_parameter'] = $row['parameter'];
						$plugin['ok'] = $row['ok'];
						$plugin['warning'] = $row['warning'];
						$plugin['critical'] = $row['critical'];
						$plugin['unknown'] = $row['unknown'];
						$plugins[$key] = $plugin;
						break;
					}
				}
			}
			try
			{
				Model_adm::updatePatternService($dbconnection,$pattern['id'],$pattern['name'],$pattern['description'],$plugins,FALSE);

				$esialog->write('ESIA PATTERN ALERT', 'UPDATE SUCCESS ');
				$smarty->assign('l_action_success',$lang['ADM_PATTERN_UPDATE_SUCCESS']);
			}
			catch(Exception $e)
			{
				$esialog->write('ESIA PATTERN ALERT','UPDATE ALERT FAILED '.$e->getMessage());
				$ERROR[]=array('name'=>'UPDATE ALERT FAILED','message'=>$e->getMessage());
			}

			$pattern = Model_adm::getPatternService($dbconnection,$_GET['id']);
			$pattern = $pattern[$_GET['id']];
			$plugins = $pattern['plugins'];
		}

		//Préparation des données à afficher.
		$smarty->assign('pattern_id', $pattern['id']);
		$alerting = Model_esia::getAlertingSoftware($dbconnection);
		foreach ($alerting as $k=>$programAlert)
		{
			$alerting[$programAlert['id']]['default_parameter'] = preg_replace('#\$USERMAIL#',$user->getEmail() ,$alerting[$programAlert['id']]['default_parameter']);
		}

		foreach($plugins as $plugin)
		{
			$common_name = Model_esia::getCommonName($lang,$plugin['name'],$plugin['name']);
			$type = explode('_',$plugin['name']);
			$list[]=array('id'=>$plugin['id'],
					'name'=>$plugin['name'],
					'alert_prog_id'=>$plugin['alerting'],
					'alert_prog_param'=>$plugin['alerting_parameter'],
					'alert_prog_ok'=>$plugin['ok'],
					'alert_prog_warning'=>$plugin['warning'],
					'alert_prog_critical'=>$plugin['critical'],
					'alert_prog_unknown'=>$plugin['unknown'],
					'common'=>$common_name
			);
		}

		$check_propagate = TRUE;
		$smarty->assign('category','alerts');
		$smarty->assign('adm_node_action','list');
		$smarty->assign('list_alerting', $alerting);
		$smarty->assign('list_services', $list);
	}
	else if( $category =='nodes')
	{
		//Concerne le bouton permettant d'ajouter des noeuds aux pattern.
		//Ceci affiche la liste des noeuds dans le dialog
		if($action == 'list_nodes')
		{
			$pattern_id = $_GET['id'];
			$assigned_nodes = Model_adm::getPatternServiceNodeAssign($dbconnection,$pattern_id);
			$another_nodes = Model_esia::getNodeList($dbconnection,$user->getId());

			$to_remove = array();
			foreach($assigned_nodes as $row)
			{
				$to_remove[$row['id']] = TRUE;
			}
			$nodes = array();
			foreach($another_nodes as $row)
			{
				if( !isset($to_remove[$row['id']]))
				{
					$nodes[] = $row;
				}
			}

			$smarty->assign('nodes',$nodes);
			$smarty->assign('category','nodes_add');
		}
		//Affichage de la dialogue pour confirmer qu'on souhaite délié le noeud
		elseif($action == 'unlink')
		{
			$node_id = $_GET['node'];
			$node = Model_esia::InstanceNode($dbconnection,$node_id);
			$pattern = Model_adm::getPatternService($dbconnection,$_GET['id']);
			$pattern = $pattern[$_GET['id']];

			$message = sprintf($lang['ADM_PATTERN_UNLINK_MSG_CONFIRM'],$pattern['name'],$node->getName());
			$smarty->assign('confirm_message',$message);

			$smarty->assign('pattern',$pattern);
			$smarty->assign('action','show_dialog_confirm');
			$smarty->assign('category','nodes');
			$smarty->assign('node_id',$node_id);
		}
		//On affiche ici dans le dialog la liste des noeuds liés au pattern après exécution d'actions
		else
		{
			$pattern = Model_adm::getPatternService($dbconnection,$_GET['id']);
			$pattern = $pattern[$_GET['id']];
			$smarty->assign('pattern_id', $pattern['id']);

			//Action de mise à jour des noeuds avec les données du pattern
			if( $action == 'update' )
			{
				$nodes_id_list = $_POST;
				try
				{
					Model_adm::updateNodesPatternServices($dbconnection,$pattern['id'],$nodes_id_list);
					$esialog->write('ESIA PATTERN', 'UPDATE NODES SUCCESS ');
					$smarty->assign('l_action_success',$lang['ADM_PATTERN_UPDATE_SUCCESS']);
				}
				catch(Exception $e)
				{
					$esialog->write('ESIA PATTERN','UPDATE NODES FAILED '.$e->getMessage());
					$ERROR[]=array('name'=>'UPDATE NODES PATTERN','message'=>$e->getMessage());
				}
			}
			//Action de mise à jour de tous les noeuds avec les modifications
			elseif( $action == 'update_all' )
			{
				$list_id = json_decode($_POST['included_list'],TRUE);
				$included_list = array();
				foreach($list_id as $id)
				{
					foreach($pattern['plugins'] as $included)
					{
						if( $included['id'] == $id)
						{
							$included_list[] = $included;
						}
					}
				}
				try
				{
					Model_adm::updateNodesPatternServices($dbconnection,$pattern['id'],NULL,$included_list);
					$esialog->write('ESIA PATTERN', 'UPDATE NODES SUCCESS ');
					$smarty->assign('l_action_success',$lang['ADM_PATTERN_UPDATE_SUCCESS']);
				}
				catch(Exception $e)
				{
					$esialog->write('ESIA PATTERN','UPDATE NODES FAILED '.$e->getMessage());
					$ERROR[]=array('name'=>'UPDATE NODES PATTERN','message'=>$e->getMessage());
				}
			}
			//Action d'ajout de noeud dans le pattern
			elseif( $action == 'nodes_add')
			{
				$nodes_id_list = $_POST;
				$success = FALSE;
				foreach($nodes_id_list as $node_id)
				{
					try
					{
						Model_adm::assignPatternServiceNode($dbconnection,$pattern['id'],$node_id);
						$success = TRUE;
					}
					catch(Exception $e)
					{
						$esialog->write('ESIA PATTERN','ADD NODES FAILED '.$e->getMessage());
						$ERROR[]=array('name'=>'ADD NODES PATTERN','message'=>$e->getMessage());
					}
				}
				if( $success)
				{
					$esialog->write('ESIA PATTERN', 'ADD NODES SUCCESS ');
					$smarty->assign('l_action_success',$lang['ADM_PATTERN_NODE_ASSIGN_SUCCESS']);
				}
			}
			//Action de suppression de noeud dans le pattern
			elseif( $action == 'unlink_confirmed')
			{
				$node_id = $_POST['node_id'];
				if( isset($_POST['services']) )
				{
					//Services et pattern
					try
					{
						Model_adm::assignPatternServiceNode($dbconnection,$pattern['id'],$node_id);
						Model_adm::unassignPatternServiceNode($dbconnection,$pattern['id'],$node_id);
						Model_adm::unlinkPatternServiceNode($dbconnection,$pattern['id'],$node_id);
						$smarty->assign('l_action_success',$lang['ADM_PATTERN_UNLINK_WITHSERVICES_SUCCESS']);
						$esialog->write('ESIA PATTERN','pattern unassigned and services deleted');
					}
					catch(Exception $e)
					{
						$esialog->write('ESIA PATTERN', 'UNASSIGN NODE OR DELETE SERVICES FAILED');
						$ERROR[]=array('name'=>'ESIA PATTERN UNASSIGN','message'=>$e->getMessage());
					}
				}
				else
				{
					//Pattern Only
					try
					{
						Model_adm::unlinkPatternServiceNode($dbconnection,$pattern['id'],$node_id);
						$smarty->assign('l_action_success',$lang['ADM_PATTERN_UNLINK_SUCCESS']);
						$esialog->write('ESIA PATTERN','pattern unlinked');
					}
					catch(Exception $e)
					{
						$esialog->write('ESIA PATTERN', 'UNASSIGN NODE FAILED');
						$ERROR[]=array('name'=>'ESIA PATTERN UNASSIGN','message'=>$e->getMessage());
					}
				}
			}

			//Affichage des noeuds du pattern
			$nodes = generateNodeList($dbconnection,$pattern);

			$smarty->assign('pattern_updated',$nodes['pattern_updated']);
			$smarty->assign('category','nodes');
			$smarty->assign('nodes',$nodes['nodes']);
		}
	}
	else
	{
		$smarty->display('no_access.html');
	}
}

$smarty->assign('adm_pattern_action', $action);

//variable de langue
$smarty->assign('l_adm_change', $lang['MODIF']);
$smarty->assign('l_adm_delete', $lang['DELETE']);
$smarty->assign('l_pattern_name', $lang['ADM_PATTERN_NAME']);
$smarty->assign('l_pattern_description', $lang['ADM_PATTERN_DESCRIPTION']);
$smarty->assign('l_adm_action', $lang['ACTION']);
$smarty->assign('l_adm_plugin_list', $lang['ADM_PLUGIN_LIST']);
$smarty->assign('l_adm_plugin_add', $lang['ADM_PLUGIN_ADD']);
$smarty->assign('l_adm_pattern_list', $lang['ADM_PATTERN_SERVICE_LIST']);
$smarty->assign('l_adm_pattern_add', $lang['ADM_PATTERN_SERVICE_ADD']);

if( $check_propagate )
{
	$smarty->assign('propage_included',getPropageIncluded($dbconnection,$pattern));
}

function generateNodeList($dbconnection,$pattern)
{
	global$lang;

	$nodes=Model_adm::getPatternServiceNodeAssign($dbconnection,$pattern['id']);
	$nodes_services = Model_adm::getPatternServiceNodeStats($dbconnection,$nodes,$pattern['id']);

	$total_pattern = count($pattern['plugins']);

	$ret = array();
	$pattern_updated = FALSE;
	foreach($nodes as $node)
	{
		$stats = $nodes_services[$node['id']];

		$tmp['included']			= count($stats['SERVICES']['INCLUDED']);
		$tmp['modified'] 			= count($stats['SERVICES']['MODIFIED']);
		$tmp['duplicated'] 			= count($stats['SERVICES']['DUPLICATED']);
		$tmp['not_included'] 		= count($stats['NOT_INCLUDED']);

		$need_update = FALSE;
		$is_warnings = FALSE;
		$status_message = array();
		if( $tmp['not_included'] > 0 )
		{
			$need_update = TRUE;
			$pattern_updated = TRUE;
			$status_message[] = $tmp['not_included'] . ' ' . $lang['ADM_PATTERN_MSG_NOTINCLUDED_SERVICES'];
		}
		if( $tmp['modified'] > 0 )
		{
			$need_update = TRUE;
			$pattern_updated = TRUE;
			$status_message[] = $tmp['modified'] . ' ' . $lang['ADM_PATTERN_MSG_DIFFERENT_SERVICES'];
		}
		if( $tmp['duplicated'] > 0 )
		{
			$is_warnings = TRUE;
			$status_message[] = $tmp['duplicated'] . ' ' . $lang['ADM_PATTERN_MSG_DUPLICATED_SERVICES'];
		}

		if( $is_warnings )
		{
			$status = $lang['ADM_PATTERN_STATE_WARNING'];
		}
		else if( $need_update )
		{
			$status = $lang['ADM_PATTERN_STATE_UPDATE_POSSIBLE'];
		}
		else
		{
			$status = $lang['ADM_PATTERN_STATE_NOTHING'];
			$status_message[] = $tmp['included'] . "/$total_pattern " . $lang['ADM_PATTERN_MSG_INCLUDED_SERVICES'];
		}

		$node['status'] = $status;
		$node['message'] = implode("\n",$status_message);
		$node['updatable'] = $need_update;
		$ret[] = $node;
	}
	return array('pattern_updated'=>$pattern_updated,'nodes'=>$ret);
}

function getPropageIncluded($dbconnection,$pattern)
{
	//On vérifier is on a des includes qu'on souhaiterait propoger
	$nodes_assigned = count(Model_Adm::getPatternServiceNodeAssign($dbconnection,$pattern['id']));
	if( $nodes_assigned > 0 )
	{
		$included_diff_params = Model_Adm::getPatternIncludedNotSameThanService($dbconnection,$pattern['id']);
		$included_new = Model_adm::getPatternNewIncluded($dbconnection,$pattern['id']);

		//On dessus de cette valeur, on considére qu'on souhaiterais événtuellement propoger la conf du pattern
		$ratio_nodes = $nodes_assigned/2;

		$includes_to_propage = array();
		foreach($included_diff_params as $params)
		{
			if( $params['count'] > $ratio_nodes)
			{
				$includes_to_propage[] = $params['id'];
			}
		}
		foreach($included_new as $params)
		{
			$includes_to_propage[] = $params['id'];
		}
	}

	if( $nodes_assigned == 0 || empty($includes_to_propage))
	{
		return NULL;
	}
	else
	{
	   return json_encode($includes_to_propage);
	}
}
?>
