<?php
include_once MVCMODEL;
if(isset($_GET['action']))
{
	$action = $_GET['action'];
}
else
{
	$action = '';
}

if(isset($_GET['category']))
{
	$category = $_GET['category'];
}
else
{
	$category = '';
}

try
{
	if($category == '')
	{
		if($action == 'list')
		{
			$list = array();
			$rows = Model_esia::getPlugin($dbconnection);
			foreach($rows as $row)
			{
				$list[] = array(
					'id' => $row['id'],
					'name' => $row['name'],
					'type' => $row['type'],
					'description' => $row['description'],
				);
			}
			$smarty->assign('adm_list_plugin', $list);
		}
		elseif($action == 'delete')
		{
			if(isset($_POST['confirmId']) && $_POST['confirmId'] == $_GET['id'])
			{
				/*
				** Validation form sended
				*/
				try
				{
					Model_adm::deletePlugin($dbconnection, $_GET['id']);
					Model_adm::mustRestartDaemon($dbconnection);
					$esialog->write('ESIA PLUGIN', 'DELETE SUCCESS ' . $_GET['id']);
					$ADM_MESSAGE[] = array('message' => $lang['ADM_PLUGIN_DELETE_SUCCESS']);
				}
				catch(EsiaDbException $e)
				{
					$esialog->write('ESIA PLUGIN', 'DELETE FAILED - ' . $e->getMessage());
					throw new Exception('PLUGIN DELETE - ' . $e->getMessage());
				}
			}
			else
			{
				/*
				** Display html content
				*/
				$row = Model_esia::getPlugin($dbconnection, $_GET['id']);
				$row = $row[0];
				$nbr = Model_adm::countServiceByPlugin($dbconnection, $_GET['id']);
				$smarty->assign('adm_plugin_name', $row['name']);
				$smarty->assign('adm_plugin_path', $row['path']);
				$smarty->assign('adm_plugin_service_nbr', $nbr);
			}
		}
	}
	elseif($category == 'plugin')
	{
		if($action == 'add' || $action == 'update' || $action == 'duplicate')
		{
			if(isset($_POST['confirmId']) && $_POST['confirmId'] == $_GET['id'])
			{
				/*
				** Validation form sended
				*/
				// Save inputs to reuse in form if add/update fails
				$pluginFields = array(
					'id' => $_POST['confirmId'],
					'name' => $_POST['name'],
					'type' => $_POST['type'],
					'path' => $_POST['path'],
					'oid' => $_POST['oid'],
					'param' => $_POST['parameter'],
					'interval' => $_POST['interval'],
					'description' => $_POST['description'],
					'priority' => $_POST['priority'],
					'manufacturer' => $_POST['manufacturer'],
					'tag' => $_POST['tag'],
				);
				// Set the name in the right format & remove unexpected chars
				$_POST['name'] = trim($_POST['name']); // Remove empty spaces
				$_POST['name'] = preg_replace('/[^a-zA-Z0-9_]/', '_', $_POST['name']); // Replace every unexpected chars by _
				$_POST['name'] = trim($_POST['name'], '_'); // Remove first & last _
				$_POST['name'] = preg_replace('/_{2,}/', '_', $_POST['name']); // Remove _ duplications
				if(empty($_POST['name']))
				{
					// Name cannot be empty at this point
					throw new Exception('ADD/UPDATE FAILED - name is empty');
				}
				$_POST['name'] = strtoupper($_POST['type'] . '_' . $_POST['name']); // Add type before & set everything to uppercase

				// Check that plugin file can be executed
				$exec = '/usr/local/esia/plugins/' . $_POST['path'];
				if(is_executable($exec))
				{
					// Check that interval is set and is an integer > 0
					if(empty($_POST['interval']) || !ctype_digit($_POST['interval']))
					{
						// If not set it to the default plugin interval
						$_POST['interval'] = 300;
					}
					// Transform interval from seconds to milliseconds for DB
					$_POST['interval'] = intval($_POST['interval']) * 1000;
					// Format tag
					$_POST['tag'] = strtoupper(str_replace(' ', '', $_POST['tag']));
					
					// From here DB exception must be catch to log it into esialog
					try
					{
						$pluginId = 0;
						if(!empty($_GET['id']) && is_numeric($_GET['id']))
						{
							$pluginId = intval($_GET['id']);
						}
						$newPluginId = 0;
						if($_POST['type'] == 'check')
						{
							if($action == 'update' && !empty($pluginId))
							{
								// Update existing plugin
								Model_adm::UpdateCheckPlugin($dbconnection, $pluginId, $_POST['name'], $exec, $_POST['parameter'], $_POST['interval'], $_POST['description'], $_POST['priority'], $_POST['manufacturer'], $_POST['tag']);

								$esialog->write('ESIA PLUGIN', 'UPDATE check plugin success ' . $_POST['name']);
								$ADM_MESSAGE[] = array('message' => $lang['ADM_PLUGIN_UPDATE_SUCCESSD']);
							}
							else
							{
								// Add new plugin
								$newPluginId = Model_adm::addCheckPlugin($dbconnection, $_POST['name'], $exec, $_POST['parameter'], $_POST['interval'], $_POST['description'], $_POST['priority'], $_POST['manufacturer'], $_POST['tag']);
								
								$esialog->write('ESIA PLUGIN', 'ADD check plugin success ' . $_POST['name']);
								$ADM_MESSAGE[] = array('message' => $lang['ADM_PLUGIN_ADD_SUCCESS']);
							}
						}
						elseif($_POST['type'] == 'trap')
						{
							if($action == 'update' && !empty($pluginId))
							{
								// Update existing plugin
								Model_adm::UpdateTrapPlugin($dbconnection, $pluginId, $_POST['name'], $exec, $_POST['parameter'], $_POST['oid'], $_POST['description'], $_POST['priority'], $_POST['manufacturer'], $_POST['tag']);

								$esialog->write('ESIA PLUGIN', 'UPDATE trap plugin success ' . $_POST['name']);
								$ADM_MESSAGE[] = array('message' => $lang['ADM_PLUGIN_UPDATE_SUCCESSD']);
							}
							else
							{
								// Add new plugin
								$newPluginId = Model_adm::addTrapPlugin($dbconnection, $_POST['name'], $exec, $_POST['parameter'], $_POST['oid'], $_POST['description'], $_POST['priority'], $_POST['manufacturer'], $_POST['tag']);

								$esialog->write('ESIA PLUGIN', 'ADD trap plugin success ' . $_POST['name']);
								$ADM_MESSAGE[] = array('message' => $lang['ADM_PLUGIN_ADD_SUCCESS']);
							}
						}
						elseif($_POST['type'] == 'cron')
						{
							// TODO
						}
						else
						{
							throw new Exception('ADD/UPDATE FAILED - type no supported: ' . strtoupper($_POST['type']));
						}

						if($action == 'duplicate' && !empty($pluginId) && !empty($newPluginId))
						{
							// Duplicate RRDs & alerts
							// RRDs
							$rrdList = Model_adm::getRRDByPlugin($dbconnection, $pluginId);
							foreach($rrdList[$pluginId] as $rrd)
							{
								Model_adm::addRRDPlugin($dbconnection, $newPluginId, $rrd);
							}
							// Alerts
							$plugin = Model_esia::getPlugin($dbconnection, $pluginId)[0];
							if(!empty($plugin['alerting']))
							{
								$alertData = array(
									'alerting_software' => $plugin['alerting'],
									'alerting_parameter' => $plugin['alerting_parameter'],
									'ok' => $plugin['ok'],
									'warning' => $plugin['warning'],
									'critical' => $plugin['critical'],
									'unknown' => $plugin['unknown'],
								);
								Model_adm::updatePluginAlertProgram($dbconnection, $newPluginId, $alertData);
							}
						}

						// When action is over set it to update to display update page
						$action = 'update';
						if(!empty($newPluginId))
						{
							$_GET['id'] = $newPluginId;
						}
					}
					catch(EsiaDbException $e)
					{
						$esialog->write('ESIA PLUGIN', 'ADD/UPDATE FAILED - ' . $e->getMessage());
						$ERROR[] = array('name' => $lang['ADM_PLUGIN_ERR'], 'message' => 'ADD/UPDATE FAILED - ' . $e->getMessage());
					}
				}
				else
				{
					$ERROR[] = array('name' => $lang['ADM_PLUGIN_ERR'], 'message' => 'ADD/UPDATE FAILED - file no found or file is not a executable: <br/>' . $exec);
				}
			}
			/*
			** Display html content
			*/

			// Init array default values for add action
			$plugin = array(
				'id' => 0,
				'name' => '',
				'type' => 'check',
				'path' => '',
				'oid' => '',
				'param' => '',
				'interval' => '300',
				'description' => '',
				'priority' => 7,
				'manufacturer' => '',
				'tag' => '',
			);
			if($action == 'update' || $action == 'duplicate')
			{
				if(empty($_GET['id']) || !is_numeric($_GET['id']))
				{
					throw new Exception("Missing plugin id");
				}
				$plug = Model_esia::getPlugin($dbconnection, intval($_GET['id']))[0];
				$plugin['id'] = $plug['id'];
				$plugin['oid'] = $plug['trap_oid'];
				$plugin['param'] = $plug['parameter'];
				$plugin['interval'] = intval($plug['interval_time']) / 1000;
				$plugin['description'] = $plug['description'];
				$plugin['priority'] = $plug['priority'];
				$plugin['manufacturer'] = $plug['manufacturer'];
				$plugin['tag'] = $plug['tag'];
				if(preg_match('#/usr/local/esia/plugins/(.*)#', $plug['path'], $match))
				{
					$plugin['path'] = $match[1];
				}
				if($plug['type'] == 'default')
				{
					$plugin['type'] = 'check';
				}
				else
				{
					$plugin['type'] = $plug['type'];
				}
				// Remove type from name to display into input name without it
				$plugin['name'] = preg_replace('/' . $plugin['type'] . '_/i', '', $plug['name']);

				if($action == 'duplicate')
				{
					$plugin['name'] .= '_COPY';
				}
			}
			elseif(!empty($ERROR) && !empty($pluginFields))
			{
				// Add action failed repopulate form
				$plugin = $pluginFields;
			}
			$smarty->assign('plugin', $plugin);
			$smarty->assign('admPluginTypes', array(
				'check',
				'trap',
				// 'cron',
			));
		}
	}
	elseif($category == 'rrd')
	{
		if($action == 'update')
		{
			$pluginId = intval($_GET['id']);
			// Get the rrd ids to update
			$rrdList = array_unique(json_decode($_POST['updateList']));
			foreach($rrdList as $rrdId)
			{
				try
				{
					if(isset($_POST['rrd'][$rrdId]))
					{
						Model_adm::updateRRDPlugin($dbconnection, $pluginId, $rrdId, $_POST['rrd'][$rrdId]);
					}
					else
					{
						throw new Exception($lang['ADM_RRD_FAIL_UPD_DATA']);
					}
				}
				catch(EsiaDbException $e)
				{
					$ERROR[] = array('name' => 'RRD ID&nbsp;: ' . $rrdId, 'message' => $e->getMessage());
				}
			}
			
			// If success go to main page
			$action = 'list';
		}
		// Main action wich can be set after other action (delete, ...) are complete to return to main page
		if($action == 'list')
		{
			if(empty($_GET['id']) || !is_numeric($_GET['id']))
			{
				throw new Exception("Missing plugin id");
			}
			$pluginId = intval($_GET['id']);
			$plugin = Model_esia::getPlugin($dbconnection, $pluginId)[0];
			$smarty->assign('pluginName', $plugin['name']);

			// Graphs types
			$graphTypesList = Model_esia::RRD_GRAPH_TYPES_TO_C3;
			$smarty->assign('rrdGraphTypesToC3', $graphTypesList);
			foreach($graphTypesList as $key => $value)
			{
				$langKey = 'RRD_GRAPH_TYPE_' . strtoupper($key);
				if(isset($lang[$langKey]))
				{
					$graphTypesList[$key] = $lang[$langKey];
				}
				else
				{
					$graphTypesList[$key] = $key;
				}
			}
			$smarty->assign('graphTypesList', $graphTypesList);

			$rrdList = Model_adm::getRRDByPlugin($dbconnection, $pluginId);
			if(empty($rrdList[$pluginId]))
			{
				$rrdList = array();
			}
			else
			{
				$rrdList = $rrdList[$pluginId];
			}
			$smarty->assign('rrdList', $rrdList);

			// Format exemple graph data
			$graphData = generateGraphRandomData($rrdList, 5, 0.5);
			$smarty->assign('graphData', $graphData);
		}
	}
	elseif($category == 'services')
	{
		if($action == 'add')
		{
			if(!empty($_POST['service_id']) && $_POST['service_id'] == $_GET['serviceId'])
			{
				/*
				** Validation form sended
				*/
				$pluginId = intval($_GET['id']);
				$serviceId = intval($_POST['service_id']);
				if(!empty($_POST['devicesList']))
				{
					// Get nodes list of ids & be sure there is no duplication (nodes are listed by group and a node can be in several groups)
					$nodesIdList = array_unique(explode(',', $_POST['devicesList']));
					if(!empty($_POST['plug-' . $pluginId . '-configuration-name']))
					{
						foreach($nodesIdList as $nodeId)
						{
							try
							{
								$name = $_POST['plug-' . $pluginId . '-configuration-name'];
								$interval = $_POST['plug-' . $pluginId . '-configuration-interval'] * 1000;
								$priority = $_POST['plug-' . $pluginId . '-configuration-priority'];
								$paramater = $_POST['plug-' . $pluginId . '-configuration-parameter'];
								
								Model_adm::addService($dbconnection, $name, $pluginId, $nodeId, $interval, $paramater, $priority, 0, '');

								$esialog->write('ESIA SERVICE', 'ADD ' . $name . ' on node id ' . $nodeId . ' interval: ' . $interval);
								$ADM_MESSAGE[] = array('message' => $name . ' ' . $lang['ADM_PLUGIN_ADD_SUCCESS'] . ' on node id ' . $nodeId);
							}
							catch(EsiaDbException $e)
							{
								$esialog->write('ESIA ALERT', 'ADD SERVICE FAILED ' . $e->getMessage());
								$ERROR[] = array('name' => $lang['ADM_NODE_ADD_SERVICE_FAILED'], 'message' => $name . ' ' . $e->getMessage());
							}
						}
					}
					else
					{
						$ERROR[] = array('name' => $lang['ADM_PLUGIN_ERR'], 'message' => 'Missing service required informations');
					}
				}
				else
				{
					$ERROR[] = array('name' => $lang['ADM_PLUGIN_ERR'], 'message' => 'Missing device id');
				}
			}
			/*
			** Display html content
			*/

			// Get all esia nodes
			$nodes = Model_esia::getNodeList($dbconnection, $user->getId(), NULL, Model_esia::NODE_ASSOC);
			$nodesGroupsList = array();
			$nodesList = array();
			foreach($nodes as $node)
			{
				$item = array(
					'id' => $node['id'],
					'name' => $node['name'],
					'title' => $nodesList[$node['name']]['title'],
				);
				// If group empty it's root group
				if(empty($node['group']))
				{
					$node['group'] = $lang['GROUPNODE_ROOT'];
				}
				// Prepare node group list
				if(!empty($item['title']))
				{
					// If previous groups add backline
					$item['title'] .= "\n";
				}
				// Add group and node name to list
				$item['title'] .= $node['group'] . ' -> ' . $node['name'];

				$nodesList[$node['name']] = $item;
				$nodesGroupsList[$node['group']][] = $node['name'];
			}
			ksort($nodesGroupsList, SORT_NATURAL | SORT_FLAG_CASE);
			if(array_key_exists($lang['GROUPNODE_ROOT'], $nodesGroupsList))
			{
				$rootList = $nodesGroupsList[$lang['GROUPNODE_ROOT']];
				unset($nodesGroupsList[$lang['GROUPNODE_ROOT']]);
				$nodesGroupsList = array_merge(array($lang['GROUPNODE_ROOT'] => $rootList), $nodesGroupsList);
			}
			$smarty->assign('nodesGroupsList', $nodesGroupsList);
			$smarty->assign('nodesList', $nodesList);

			// Parameter the service from plugin params to set its default
			$plugin = Model_esia::getPlugin($dbconnection, $_GET['id'])[0];
			
			$service = array(
				'id' => $plugin['id'],
				'name' => $plugin['name'],
				'pluginid' => $plugin['id'],
				'plugin_name' => $plugin['name'],
				'default_parameter' => $plugin['parameter'],
				'default_interval' => $plugin['interval_time'] / 1000,
				'priority' => $plugin['priority'],
				'html_template' => preg_replace('#' . $_SERVER['DOCUMENT_ROOT'] . '#', '/', $plugin['html_template']),
			);
			
			$smarty->assign('service', $service);
		}
		elseif($action == 'update')
		{
			if(!empty($_POST['service_id']) && $_POST['service_id'] == $_GET['serviceId'])
			{
				/*
				** Validation form sended
				*/
				$pluginId = intval($_GET['id']);
				$serviceId = intval($_POST['service_id']);
				if(!empty($_GET['deviceId']) && !empty($_POST['plug-' . $pluginId . '-configuration-name']))
				{
					try
					{
						$name = $_POST['plug-' . $pluginId . '-configuration-name'];
						$interval = $_POST['plug-' . $pluginId . '-configuration-interval'] * 1000;
						$priority = $_POST['plug-' . $pluginId . '-configuration-priority'];
						$paramater = $_POST['plug-' . $pluginId . '-configuration-parameter'];
						//$dbconnection, $pluginId, $name, $plugin, $node, $interval, $parameter, $priority, $alert, $alert_param, $unknown=null, $warning=null, $critical=null, $ok=null)
						Model_adm::UpdateService($dbconnection, $serviceId, $name, $pluginId, $_GET['deviceId'], $interval, $paramater, $priority, -1);

						$esialog->write('ESIA SERVICE', 'UPDATE SUCCESS ' . $serviceId);
						$ADM_MESSAGE[] = array('message' => $lang['ADM_PLUGIN_UPDATE_SUCCESS']);
					}
					catch(EsiaDbException $e)
					{
						if(preg_match('#duplicate\s+key#', $e->getMessage()))
						{
							$esialog->write('ESIA SERVICE', 'UPDATE SUCCESS ' . $serviceId);
							$ADM_MESSAGE[] = array('message' => $lang['ADM_PLUGIN_UPDATE_SUCCESS']);
						}
						else
						{
							$esialog->write('ESIA SERVICE', 'INSERT/UPDATE FAILED ' . $e->getMessage());
							throw new Exception('INSERT/UPDATE SERVICE ERROR - ' . $e->getMessage());
						}
					}
				}
				else
				{
					throw new Exception('Missing service required informations');
				}
			}
			/*
			** Display html content
			*/
			$plugin = Model_esia::getPlugin($dbconnection, $_GET['id'])[0];
			$serv = Model_esia::getServices($dbconnection, NULL, $_GET['serviceId'])[0];
			
			$service = array(
				'id' => $serv['id'],
				'name' => $serv['name'],
				'device_id' => $serv['device_id'],
				'device_name' => $serv['device_name'],
				'pluginid' => $serv['plugin_id'],
				'plugin_name' => $serv['check_plugin_name'],
				'default_parameter' => $serv['parameter'],
				'default_interval' => $serv['interval_time'] / 1000,
				'priority' => $serv['priority'],
				'html_template' => preg_replace('#' . $_SERVER['DOCUMENT_ROOT'] . '#', '/', $plugin['html_template']),
			);
			$smarty->assign('service', $service);
		}
		elseif($action == 'delete')
		{
			if(!empty($_POST['confirmId']) && $_POST['confirmId'] == $_GET['serviceId'])
			{
				/*
				** Validation form sended
				*/
				$serviceId = intval($_POST['confirmId']);
				try
				{
					Model_adm::deleteService($dbconnection, $serviceId);

					$esialog->write('ESIA SERVICE', 'DELETE SUCCESS ' . $serviceId);
					$ADM_MESSAGE[] = array('message' => $lang['ADM_PLUGIN_DEL_SUCCESS']);

					// If success go to main page
					$action = 'list';
				}
				catch(EsiaDbException $e)
				{
					$esialog->write('ESIA SERVICE', 'DELETE FAILED ' . $e->getMessage());
					throw new Exception('DELETE SERVICE ERROR - ' . $e->getMessage());
				}
			}
			else
			{
				/*
				** Display html content
				*/
				$service = Model_esia::getServices($dbconnection, NULL, $_GET['serviceId'])[0];

				$smarty->assign('service', array(
					'id' => $service['id'],
					'name' => $service['name'],
					'description' => $service['description'],
					'plugin_name' => $service['check_plugin_name'],
					'device_id' => $service['device_id'],
					'device_name' => $service['device_name'],
				));
			}
		}
		// Main action wich can be set after other action (delete, ...) are complete to return to main page
		if($action == 'list')
		{
			if(empty($_GET['id']) || !is_numeric($_GET['id']))
			{
				throw new Exception("Missing plugin id");
			}
			$plugin = Model_esia::getPlugin($dbconnection, intval($_GET['id']))[0];
			$smarty->assign('pluginName', $plugin['name']);
		}
	}
	elseif($category == 'alerts')
	{
		if($action == 'update')
		{
			try
			{
				$pluginId = 'None';
				if(empty($_GET['id']) || !is_numeric($_GET['id']))
				{
					throw new Exception("Missing plugin id");
				}
				$pluginId = intval($_GET['id']);
				$data = array();
				if(isset($_POST['formAlertingTable']))
				{
					$data = json_decode($_POST['formAlertingTable'], TRUE);
				}
				if(empty($data[0]) || $data[0]['serviceid'] != $pluginId)
				{
					throw new Exception("Missing plugin alerting data");
				}
				$data = $data[0];
				$alertData = array(
					'alerting_software' => $data['progid'],
					'alerting_parameter' => $data['parameter'],
					'ok' => $data['ok'],
					'warning' => $data['warning'],
					'critical' => $data['critical'],
					'unknown' => $data['unknown'],
				);

				Model_adm::updatePluginAlertProgram($dbconnection, $pluginId, $alertData);
				
				$esialog->write('ESIA PLUGIN ALERT', 'UPDATE ALERT SUCCESS - Plugin ID ' . $pluginId);
				$ADM_MESSAGE[] = array('message' => $lang['ADM_USER_UPDATE_SUCCESS'] . ' - Plugin ID ' . $pluginId);
			}
			catch(EsiaDbException | Exception $e)
			{
				$esialog->write('ESIA PLUGIN ALERT', 'UPDATE ALERT FAILED - Plugin ID ' . $pluginId . ' -> ' . $e->getMessage());
				$ERROR[] = array('name' => $lang['ADM_PLUGIN_SOFTWARE_ALERTING_UPDATE_FAILED'], 'message' => 'Plugin ID ' . $pluginId . ' -> ' . $e->getMessage());
			}
			$action = 'list';
		}
		// Main action wich can be set after other action (delete, ...) are complete to return to main page
		if($action == 'list')
		{
			if(empty($_GET['id']) || !is_numeric($_GET['id']))
			{
				throw new Exception("Missing plugin id");
			}
			
			// Get plugin alerts infos
			$plugin = Model_esia::getPlugin($dbconnection, intval($_GET['id']))[0];
			$pluginsList = array();
			$common_name = Model_esia::getCommonName($lang, $plugin['name'], $plugin['name']);
			$pluginsList[] = array(
				'id' => $plugin['id'],
				'name' => $plugin['name'],
				'alert_prog_id' => $plugin['alerting'],
				'alert_prog_param' => $plugin['alerting_parameter'],
				'alert_prog_ok' => $plugin['ok'],
				'alert_prog_warning' => $plugin['warning'],
				'alert_prog_critical' => $plugin['critical'],
				'alert_prog_unknown' => $plugin['unknown'],
				'common' => $common_name,
			);

			// Get alert programs
			$alerting = Model_esia::getAlertingSoftware($dbconnection);
			foreach($alerting as $k => $programAlert)
			{
				$alerting[$programAlert['id']]['default_parameter'] = preg_replace('#\$USERMAIL#', $user->getEmail(), $alerting[$programAlert['id']]['default_parameter']);
			}

			$smarty->assign('alertingList', $alerting);
			$smarty->assign('pluginsList', $pluginsList);
		}
	}
	else
	{
		$smarty->display('no_access.html');
	}
}
catch(EsiaDbException | Exception $e)
{
	$ERROR[] = array('name' => $lang['ADM_PLUGIN_ERR'], 'message' => $e->getMessage());
}

$smarty->assign('adm_plugin', $action);
$smarty->assign('category', $category);

if(isset($_GET['id']) && is_numeric($_GET['id']))
{
	$smarty->assign('adm_plugin_id', intval($_GET['id']));
}
else
{
	$smarty->assign('adm_plugin_id', 0);
}

/**
 * @brief Generate c3 random data formated for service graph
 * @param array $rrdList list of RRDs to graph
 * @param integer $minutesGap number of minutes to take point on the timeline. If 5 means there will be a point generated every 5 minutes for the last 1 day.
 * @param float decimal $valGap min & max value change between two points on the timeline for the RRDs data
 * @return json $graphData random data formatted for c3
 */
function generateGraphRandomData($rrdList, $minutesGap=5, $valGap=0.5)
{
	$graphData = array();
	$nbrPoints = (24 * 60) / $minutesGap;
	// Get date now rounded down to latest $minutesGap minutes
	$nowTs = time();
	$roundMinutes = floor(date("i", $nowTs) / $minutesGap) * $minutesGap;
	if($roundMinutes < $minutesGap)
	{
		$roundMinutes = '00';
	}
	elseif(strlen($roundMinutes) == 1)
	{
		$roundMinutes = '0' . $roundMinutes;
	}
	$roundDate = date("Y-m-d H:{$roundMinutes}:00", $nowTs);
	$date = date_create_from_format("Y-m-d H:i:s", $roundDate);
	// Create timeline array
	$dataX = array();
	$i = $nbrPoints;
	while($i > 0)
	{
		$dataX[$i - 1] = $date->format('Y-m-d H:i:s');
		$date->modify('-' . $minutesGap . ' min');
		$i--;
	}
	ksort($dataX);
	// Generate data parameters & values for each rrd
	foreach($rrdList as $rrd)
	{
		$parameter = array(
			'name' => $rrd['name'],
			'unity' => $rrd['unit'],
			'min' => $rrd['min'],
			'type' => $rrd['c3_type'],
			'color' => $rrd['color'],
		);

		// Generate random points values
		$data = array();
		$limits = array(
			'min' => ($rrd['min'] == -1) ? 0 : $rrd['min'],
			'max' => ($rrd['max'] == -1) ? 100 : $rrd['max'],
		);
		$smooth = $limits;
		$i = $nbrPoints;
		while($i > 0)
		{
			$val = rand($smooth['min'] * 10, $smooth['max'] * 10) / 10; // Rand to decimal floating point
			$smooth['min'] = $val - $valGap;
			$smooth['max'] = $val + $valGap;
			if($smooth['min'] < $limits['min'])
			{
				$smooth['min'] = $limits['min'];
			}
			if($smooth['max'] > $limits['max'])
			{
				$smooth['max'] = $limits['max'];
			}

			$data[] = $val;
			$i--;
		}
		
		$graphData[$rrd['num']]['parameter'][] = $parameter;
		$graphData[$rrd['num']]['data'][$rrd['name']] = $data;
	}
	// For each graph set data for x axis
	foreach($graphData as $num => $value)
	{
		$graphData[$num]['data']['x'] = $dataX;
	}

	return json_encode($graphData);
}

?>
