<?php
/**
 * @name adm_users.inc.php
 * @description page gérant les utilisateurs de l'application
 * 				elle est incluse par la page administration.php
 * @author Nicolas Biersart <n.biersart@esia-network.com>
 * @contributor
 * @copyright Nicolas Biersart 2013
 * @license
 * @esia 1.00
 * @version 1.0.0
 * @date 11/04/2013
 */
$path = rtrim($_SERVER['DOCUMENT_ROOT'],'/');
$path_data_logo='/data/rss/image/';
$smarty->assign('adm_rss', 'adm_rss');
array_push($_SESSION['navbar'],array('name'=> $lang['RSS_FEED'],'link'=>'/administration.php?admin=rss&amp;action=list'));
$smarty->assign('category', '');
$action='';
$category = '';
if(!empty($_GET['action']))
{
	$action=$_GET['action'];
}
if(!empty($_GET['category']))
{
	$category = $_GET['category'];
}
$smarty->assign('category', $category);
$smarty->assign('action', $action);


if($action=='list' && $category=='')
{
	$rssChan = Model_esia::getRSSChannel($dbconnection);
	$smarty->assign('channel_list', $rssChan);
}
elseif($category=='channel')
{
	try 
	{
		if(!empty($_POST['name']))
		{
			
			$name = $_POST['name'];
			$description = $_POST['description'];
			$type = $_POST['type'];
			$enable = 0;
			if(!empty($_POST['enable']))
			{
				$enable = 1;
			}
			$url="";
			$chanlang = "";
			$usergroup =$_POST['usergroup'];
			if($usergroup[0] == 'RSS_GROUP_NO')
			{
				$usergroup=null;
			}
			$rss_category=array();
			if($type=='REMOTE')
			{
				if(!empty($_POST['url']))
				{
					$url = $_POST['url'];
				}
			}
			else 
			{
				$chanlang = $_POST['lang'];
				$rss_category = $_POST['category'];
			}
			$path = '';
			if(isset($_FILES['rssimage']))
			{
				//ttest si le répertoire RSS existe
				if(!is_dir($path_data_logo))
				{
					//il n'existe pas tentative de création
					mkdir($path_data_logo, 0755,true);
				}
				// Image Logo
				if($_FILES['rssimage']['name']!=null) // Si une nouvelle image
				{
					//test si il n'y a pas d'erreur
					if ($_FILES['rssimage']['error'])
					{
						switch ($_FILES['rssimage']['error'])
						{
							case 1: // UPLOAD_ERR_INI_SIZE
								throw new Exception('file exceeds the maximum size by server (php.ini)'); break;
							case 2: // UPLOAD_ERR_FORM_SIZE
								throw new Exception('file exceeds the maximum size by HTML form'); break;
							case 3: // UPLOAD_ERR_PARTIAL
								throw new Exception('File transfer was interrupted'); break;
							case 4: // UPLOAD_ERR_NO_FILE
								throw new Exception('the size of file was null'); break;
							default:  throw new Exception('Unknown error');
						}
					}
					$tmppath = $name.'_'.$_FILES['rssimage']['name'];
					$tmppath = preg_replace('#\s+#','_',$tmppath);
					$tmppath = preg_replace('#\/#','_',$tmppath);
					$tmppath = urlencode($tmppath);
					$tmppath = preg_replace('/%/', '', $tmppath);
					$tmppath= $path_data_logo.$tmppath;
					if(!file_exists($_SERVER['DOCUMENT_ROOT']."/$tmppath")) // Si elle n'existe pas déjà
					{
						if(move_uploaded_file($_FILES['rssimage']['tmp_name'],$_SERVER['DOCUMENT_ROOT']."/$tmppath")==true) // Si le dwl s'est bien passé
						{
							$path = $tmppath;
						}
						else 
						{
							throw new Exception('Unknown error: can\'t move file');
						}
					}
					else 
					{
						throw new Exception('Filename exist');
					}
				}
			}
			if(empty($_POST['id']))
			{
				$chanid = Model_adm::addRSSChannel($dbconnection, $name, $description, $type, $url, $chanlang, $path,$enable,$rss_category,$usergroup);	
				$ADM_MESSAGE[]=array('message'=>$lang['RSS_ADD_SUCCESS']);
				$action='update';
				$_GET['id']= $chanid;
			}
			else 
			{
				$action='update';
				$_GET['id']= $_POST['id'];
				Model_adm::updateRSSChannel($dbconnection, $_POST['id'],$name, $description, $type, $url, $chanlang, $path,$enable,$rss_category,$usergroup);
				$ADM_MESSAGE[]=array('message'=>$lang['RSS_UPDATE_SUCCESS']);
			}
		}
		elseif($action=='delete')
		{
			if(!empty($_GET['id']))
			{
				$rssChan = Model_esia::getRSSChannel($dbconnection,$_GET['id']);
				$smarty->assign('channel', $rssChan[0]);
			}
			if(!empty($_POST['confirmId']) && $_POST['confirmId'] == $_GET['id'])
			{
				Model_adm::deleteRSSChannel($dbconnection,  $_GET['id']);
				$ADM_MESSAGE[]=array('message'=>$lang['RSS_DELETE_SUCCESS']);
			}
		}
	}
	catch (Exception $e)
	{
		$ERROR[]=array('name'=>'RSS','message'=>$e->getMessage());
	}
	try 
	{
		if($action=='update'|| $action=='add')
		{
			$rssCategory = Model_esia::getRSSCategory($dbconnection);
			$smarty->assign('rsscategory', $rssCategory);
			$usergroup = Model_adm::getGroup($dbconnection);
			$smarty->assign('usergroup', $usergroup);
			if(!empty($_GET['id']))
			{
				$rssChan = Model_esia::getRSSChannel($dbconnection,$_GET['id'])[0];
				$smarty->assign('channel', $rssChan);
				$arr = array();
				foreach($rssChan['list_category'] as $cate)
				{
					$arr[]=$cate['id'];
				}
				$smarty->assign('category_selected', $arr);
				$serverFQDN = Model_esia::getConfiguration($dbconnection, 'ESIA_URL');
				$serverFQDN = $serverFQDN['ESIA_URL']['value'];
				$url = $_SERVER['REQUEST_SCHEME'] . '://' . trim($serverFQDN, '/') . '/rss.php?flow=' . $rssChan['id'];
				
				$smarty->assign('url_access', $url);
				if(!empty($rssChan['image']))
				{
					$image = str_replace($_SERVER['DOCUMENT_ROOT'],'', $rssChan['image']);
					$smarty->assign('chanImage', $image);
				}
			}
		}
	}
	catch (Exception $e)
	{
		$ERROR[]=array('name'=>'RSS','message'=>$e->getMessage());
	}
}
elseif($category=='rsscategory')
{
	if($action=='add' || $action=='update')
	{
		try
		{
			
			if(!empty($_POST['name']))
			{
				if(empty($_POST['id']))
				{
					$chanid = Model_adm::addRSSCategory($dbconnection, $_POST['name'], $_POST['description']);
					$ADM_MESSAGE[]=array('message'=>$lang['RSS_ADD_SUCCESS']);
					$action='update';
					$_GET['id']= $chanid;
					$_SESSION["RSSCATEGORY"] = array('id'=>$chanid,'time'=>time());
				}
				else
				{
					$action='update';
					$_GET['id']= $_POST['id'];
					Model_adm::updateRSSCategory($dbconnection, $_POST['id'],$_POST['name'], $_POST['description']);
	
					$ADM_MESSAGE[]=array('message'=>$lang['RSS_UPDATE_SUCCESS']);
				}
			}
			if(!empty($_GET['id']))
			{
				$action='update';
				$rssCategory = Model_esia::getRSSCategory($dbconnection,$_GET['id']);
				$smarty->assign('cate', $rssCategory[0]);
			}
		}
		catch (Exception $e)
		{
			$ERROR[]=array('name'=>'RSS','message'=>$e->getMessage());
		}
	}
	elseif($action=='delete')
	{
		if(!empty($_GET['id']))
		{
			$rssChan = Model_esia::getRSSCategory($dbconnection,$_GET['id']);
			$smarty->assign('cate', $rssChan[0]);
		}
		if(!empty($_POST['confirmId']) && $_POST['confirmId'] == $_GET['id'])
		{
			Model_adm::deleteRSSCategory($dbconnection,  $_GET['id']);
			$ADM_MESSAGE[]=array('message'=>$lang['RSS_DELETE_SUCCESS']);
		}
	}
	else
	{
		if($_GET['type'] == 'json')
		{
			$newid = -1;
			if(!empty($_SESSION["RSSCATEGORY"]))
			{
				$time = time();
				if( ($time -$_SESSION["RSSCATEGORY"]['time']) <30 )
				{
					$newid = $_SESSION["RSSCATEGORY"]['id'];
				}
			}
			$rssCategory = Model_esia::getRSSCategory($dbconnection);
			$arr=array();
			foreach($rssCategory as $cate)
			{
				$selected='none';
				if($cate['id'] == $newid)
				{
					$selected='yes';
				}
				$arr[]=array('id'=>$cate['id'], 'name'=>$cate['name'],'selected'=>$selected);
			}
			echo json_encode($arr);
			exit(0);
		}
		else 
		{
			$rssCategory = Model_esia::getRSSCategory($dbconnection);
			$smarty->assign('category_list', $rssCategory);
		}
	}
}
elseif($category=='message')
{
	$channels = Model_esia::getRSSChannel($dbconnection,null,'LOCAL');
	if($action=='add')
	{
		// Construct base URL
		$serverFQDN = Model_esia::getConfiguration($dbconnection, 'ESIA_URL');
		$serverFQDN = $serverFQDN['ESIA_URL']['value'];
		$baseUrl = $_SERVER['REQUEST_SCHEME'] . '://' . trim($serverFQDN, '/');
		$smarty->assign('baseUrl', $baseUrl);

		if(!empty($_POST['title']))
		{
			$cates = Model_esia::getRSSCategory($dbconnection,$_POST['msgcategory']);
			$str_cat="";
			foreach($cates as $cat)
			{
				$str_cat.=$cat['name'].',';
			}
			$str_cat = rtrim($str_cat,',');
			Model_adm::addMessage($dbconnection, $_POST['channel'], $_POST['title'], $_POST['message'], $_POST['url'], $_POST['author'], $_POST['image'], $str_cat);
			$smarty->assign('disable', 'yes');	
			$ADM_MESSAGE[]=array('message'=>$lang['RSS_MESSAGE_POST_SUCCESS']);
		}
		foreach($channels as &$chan)
		{
			if(!empty($chan['image']))
			{
				$image = str_replace($baseUrl, '', $chan['image']);
				$image = str_replace($_SERVER['DOCUMENT_ROOT'], '', $chan['image']);
				$chan['image'] = $image;
			}
		}
		$smarty->assign('username', $user->getName());
		$smarty->assign('channels', $channels);
	}
	elseif($action=='delete')
	{
		if(!empty($_POST['id']))
		{
			Model_adm::deleteRSSMessage($dbconnection, $_POST['id']);
			$ADM_MESSAGE[]=array('message'=>$lang['ADM_ADM_RSS_DELETE_MSG_SUCCESS']);
		}
		$messages = Model_esia::getRSSMessages($dbconnection,null,$_GET['id']);
		if(!empty($messages))
		{
			$smarty->assign('message', $messages[0]);
		}
		
	}
	else 
	{
		$smarty->assign('channels', $channels);
		$messages = array();
		if(!empty($channels))
		{
			$arr = array();
			foreach($channels as $chan)
			{
				$arr[] = $chan['id'];
			}
			$messages = Model_esia::getRSSMessages($dbconnection, $arr);
		}
		$smarty->assign('messages', $messages);
	}
}
?>
