<?php
/**
 * @name adm_users.inc.php
 * @description page gérant les utilisateurs de l'application
 * 				elle est incluse par la page administration.php
 * @author Nicolas Biersart <n.biersart@esia-network.com>
 * @contributor
 * @copyright Nicolas Biersart 2013
 * @license
 * @esia 1.00
 * @version 1.0.0
 * @date 11/04/2013
 */
$smarty->assign('adm_user', 'adm_user');
$smarty->assign('l_username',$lang['ADM_USERNAME']);
$smarty->assign('l_create_user',$lang['ADM_CREATE_USER']);
$smarty->assign('l_list_user',$lang['ADM_LIST_USER']);
$smarty->assign('l_groups', $lang['GROUPS']);
array_push($_SESSION['navbar'],array('name'=> $lang['USERS'],'link'=>'/administration.php?admin=users&amp;action=list'));
if(isset($_GET['action']))
{
    $smarty->assign('adm_username',null);
    $smarty->assign('adm_email', null);
    $smarty->assign('adm_group', null);
	$action = $_GET['action'];
	//création d'un nouvel utilisateur
	if($action=="create"||$action=="update")
	{
		$error='none';
		if(!empty($_POST))
        {
			//Ajout de l'utilisateur à la base de donnée
			if(isset($_POST['username']) && !empty($_POST['username']))
			{
				$groupid = $_POST['group'];
				//on vérifie que les mots de passe corresponde
				if(isset($_POST['password'])&&!empty($_POST['password']) && $_POST['password'] == $_POST['confipassword'])
				{
					//on vérifie le format de l'email
					if($user->checkEmail($_POST['email']))
					{
						try
						{
							//récupération de l'heure de l'inscription
							$q = $dbconnection->query("SELECT LOCALTIMESTAMP as time;");
							$r = $q->fetch(PDO::FETCH_OBJ);
							//création de l'objet utilisateur
							$usermod = new User($dbconnection);
							$usermod->setName($_POST['username']);
							$usermod->setInscriptionTime($r->time);
							$password = $usermod->generateHashPassword($_POST['username'],$_POST['password'],$r->time);
							$usermod->setHashPassword($password);
							$usermod->setEmail($_POST['email']);
							$usermod->setLang($_POST['lang']);
							$usermod->setHomePage("/index.php");
							//insertion dans la BD
							$usermod->setId(Model_adm::addUser($dbconnection, $usermod));
							$esialog->write('ESIA USERS', 'ADD SUCCESS '.$usermod->getName());
							$smarty->assign('l_create_user_success',$lang['ADM_CREATE_USER_SUCCESS']);
							//Si on lui a défini un grp on l'ajoute dans celui-ci
							if($groupid != 0 && is_numeric($groupid))
							{
								//on ajoute l'utilisateur dans le groupe
								Model_adm::addUserInGroup($dbconnection, $usermod->getId(),$groupid);
								$esialog->write('ESIA USERS', 'ADD user '.$usermod->getName() .' in groupid '.$groupid.' success ');
								$smarty->assign('l_user_add_grp_success',$lang['ADM_USER_ADD_GRP_SUCCESS']);
							}
							//$action="list";
							$action="view";
							$_GET['user']= $usermod->getId();
						}
						catch(EsiaDbException $e)
						{
							$esialog->write('ESIA USERS', 'ADD FAILED '.$e->getMessage());
							//$smarty->assign('l_adm_user_insert_failed', $lang['ADM_USER_INSERT_FAILED']);
							$ERROR[]=array('name'=>'USER ADD/UPDATE','message'=>$lang['ADM_USER_INSERT_FAILED'].'<br />'.$e->getMessage());
							$error='database';
						}
					}
					else
					{
						$error='bad_email';
					}
				}
				else
				{
					$error='bad_password';
				}
			}else{
				$error='empty_user';
			}

		}
		if(isset($_GET['id'])&&!empty($_GET['id']))
		{
			try
			{
				
				$usermod = Model_esia::InstanceUser($dbconnection, $_GET['id']);
				//on vérifie que les mots de passe corresponde
				if(isset($_POST['userpassword'])&&!empty($_POST['userpassword']))
				{
					if($_POST['userpassword'] == $_POST['confipassword'])
					{
						Model_adm::UpdateUserPassword($dbconnection,$usermod,$_POST['userpassword']);
						$smarty->assign('l_create_user_success',$lang['ADM_USER_UPDATE_SUCCESS']);
					}
					else
					{
						$ERROR[]=array('name'=>'UPDATE PASSWORD FAILED','message'=>"password is not same");
					}
				}
				
				//on vérifie la page d'accueil
				switch ($_POST["select_home_page"])
				{
					case 'dashboard':
						$homepage=$_POST['select_home_page_dashboard'];
						break;
							
					case 'url':
						$homepage=$_POST['home_page'];
						break;
							
					default:
						$homepage="/index.php";
						break;
				}
				$usermod->setHomePage($homepage);
				
				
				//on vérifie le format de l'email
				if($usermod->checkEmail($_POST['email']))
				{	
						$usermod->setEmail($_POST['email']);
						$usermod->setLang($_POST['lang']);
						Model_adm::UpdateUser($dbconnection, $usermod);
						$smarty->assign('l_create_user_success',$lang['ADM_USER_UPDATE_SUCCESS']);
						$action="view";
						$_GET['user']= $usermod->getId();
				}	
				else
				{
					$ERROR[]=array('name'=>'BAD MAIL FORMAT','message'=>'email is invalid');
				}	
			}
			catch(EsiaDbException $e)//si une erreur c'est produite
			{
				$ERROR[]=array('name'=>'UPDATE FAILED','message'=>$e->getMessage());
			}
		}
		//si il y a eu une erreur dans le traitement
		if($error !='none')
		{
			//on indique qu'elle message d'erreur
			switch($error)
			{
				case'bad_email': $smarty->assign('l_bad_email', $lang['ADM_BAD_EMAIL']); break;
				case'bad_password': $smarty->assign('l_bad_password', $lang['ADM_BAD_PASSWORD']); break;
				case'empty_user': $smarty->assign('l_empty_user', $lang['ADM_EMPTY_USER']); break;
				default:;
			}
			$smarty->assign('adm_username', $_POST['username']);
			$smarty->assign('adm_email', $_POST['email']);
			$smarty->assign('adm_group', $_POST['group']);
		}
		if($action=="create")
		{
			$array['clé1']='selection1';
			$array['clé2']='selection2';
			$array['clé3']='selection3';
			$smarty->assign('listgrp',$array);
			//Affichage de la page d'ajout des utilisateur
			//on liste les groupes pour la combo box
			$list_grp = Model_adm::getGroup($dbconnection);
			//Envoit des variables au template
			$smarty->assign('list_grp', $list_grp);
			$smarty->assign('adm_user_create', 'create');
			$smarty->assign('l_no_default_group', $lang['ADM_USER_NO_GROUP']);
			$smarty->assign('l_default_group', $lang['ADM_DEFAULT_GROUP']);
			$smarty->assign('l_email', $lang['ADM_EMAIL']);
			$smarty->assign('l_password', $lang['ADM_PASSWORD']);
			$smarty->assign('l_confirmed_password', $lang['ADM_CONFIRMED_PASSWORD']);
			$smarty->assign('l_lang', $lang['ADM_LANG']);
			$smarty->assign('l_add', $lang['ADD']);;
		}
	}
	//Suppression d'un utilisateur
	elseif($action=="supprimer")
	{
		$user_id =$_POST['userid'];
		if(is_numeric($user_id))
		{
			try
			{
				//supression de l'utilisateur
				Model_adm::deleteUser($dbconnection, $user_id);
				$esialog->write('ESIA USERS', 'DELETE success '.$user_id);
				$smarty->assign('l_del_user_success',$lang['ADM_DEL_USER_SUCCESS']);
				$action="";
			}
			catch(EsiaDbException $e)
			{
				$esialog->write('ESIA USERS', 'DELETE FAILED '.$e->getMessage());
				$ERROR[]=array('name'=>'USER DELETE','message'=>$e->getMessage());
			}
		}
		else
		{
			//affichage de la page de confirmation
			$user = $_GET['user'];
			$userid = $_GET['userid'];
			$smarty->assign('adm_user_del', 'list');
			$smarty->assign('l_cancel',$lang['CANCEL']);
			$smarty->assign('l_yes',$lang['YES']);
			$smarty->assign('l_del_user',$lang['ADM_DEL_USER']);
			$smarty->assign('adm_username', $user);
			if(is_numeric($userid))
				$smarty->assign('adm_userid', $userid);
		}
	}
	//AJOUT D'UN UTILISATEUR DANS UN GROUPE
	elseif($action=="addgroup")
	{
		$userid=$_GET['userid'];
		$username = $_GET['user'];
		//Ajout à la base de donnée
		if(isset($_POST['group'])&&!empty($_POST['group']))
		{
			$groupid = $_POST['group'];
			$userid = $_POST['userid'];
			// si l'userid et le groupid sont numérique alors on ajoute à la base de donnée
			if(is_numeric($userid)&&is_numeric($groupid))
			{
				try
				{
					//on ajout l'utilisateur dans le groupe
					Model_adm::addUserInGroup($dbconnection, $userid, $groupid);
					$esialog->write('ESIA USERS', 'ADD user '.$userid.' in group '.$groupid);
					$smarty->assign('l_user_add_grp_success',$lang['ADM_USER_ADD_GRP_SUCCESS']);
					$action="view";
					$_GET['user']= $_POST['userid'];
				}
				catch(EsiaDbException $e)
				{
					$esialog->write('ESIA USERS', 'ADD GROUP FAILED '.$e->getMessage());
					$ERROR[]=array('name'=>'USER ADD GROUP','message'=>$e->getMessage());
				}
			}
		}
		elseif(is_numeric($userid))
		{
			//Affichage de la page d'ajout a un groupe
			//liste tous les groupes auquel n'appartient pas l'utilisateur
			$list_grp=Model_adm::getUserNotInGroup($dbconnection, $userid);
			//Envoit des variables au template
			$smarty->assign('adm_user_add_grp', 'view');
			$smarty->assign('adm_username', $username);
			$smarty->assign('adm_userid', $userid);
			$smarty->assign('l_cancel',$lang['CANCEL']);
			$smarty->assign('l_add', $lang['ADD']);
			$smarty->assign('l_adm_user_add_grp',$lang['ADM_USER_ADD_GRP']);
			$smarty->assign('list_grp', $list_grp);
		}
	}
	//Enlève l'utilisateur d'un groupe
	elseif($action=="supprimergrp")
	{
		//Si les variables post sont "settée" on supprime l'utilisateur du groupe
		if(isset($_POST['group'])&&!empty($_POST['group'])&&isset($_POST['user'])&&!empty($_POST['user']))
		{
			try
			{
				//supprime l'utilisateur membre du groupe
				Model_adm::deleteUserFromGroup($dbconnection, $_POST['user'], $_POST['group']);
				$esialog->write('ESIA USERS', 'delete user '.$_POST['user'].' in group '.$_POST['group']);
				$smarty->assign('l_user_del_grp_success',$lang['ADM_USER_DEL_GRP_SUCESS']);
				$action="view";
				$_GET['user']= $_POST['user'];
			}
			catch(EsiaDbException $e)
			{
				$esialog->write('ESIA USERS', 'DELETE USER\'S GROUP FAILED '.$e->getMessage());
				$ERROR[]=array('name'=>'USER DELETE FROM GROUP','message'=>$e->getMessage());
			}
		}
		else
		{
			//affichage de la page de confirmation
			$username = $_GET['user'];
			$group = $_GET['group'];
			$smarty->assign('adm_user_del_grp', 'view');
			$smarty->assign('l_cancel',$lang['CANCEL']);
			$smarty->assign('l_yes',$lang['YES']);
			$smarty->assign('l_adm_user_del_grp',$lang['ADM_USER_DEL_GRP_1'].' '.$username.' '.$lang['ADM_USER_DEL_GRP_2'].' '.$group);
			$smarty->assign('adm_username', $username);
			$smarty->assign('adm_groupname', $group);
		}
	}
	//AFFICHE TOUTES LES INFORMATIONS D'UN UTILISATEUR
	if($action=="view")
	{
		try
		{
			$usermod = Model_esia::InstanceUser($dbconnection, $_GET['user']);
			$smarty->assign('adm_email', $usermod->getEmail());
			$smarty->assign('adm_time_inscription',$usermod->getInscriptionTime());
			$smarty->assign('adm_user_lang', $usermod->getLang());
		    $smarty->assign('adm_user_source', $usermod->getAuthSource());
		    $smarty->assign('adm_username', $usermod->getName());
		    $smarty->assign('adm_userid', $usermod->getId());

			$list_user=Model_adm::searchUser($dbconnection,$usermod->getId());
			$list_grp = $list_user[$usermod->getId()]['group'];
			//corige un bug d'affiche dans le cas ou l'utilisateur n'est pas lié à un groupe
			if(empty($list_grp[0]))
			{
				$list_grp=null;
			}
		}
		catch(EsiaDbException $e)
		{
			$esialog->write('ESIA USERS', 'VIEW FAILED '.$e->getMessage());
			$ERROR[]=array('name'=>'USER ADD GROUP','message'=>$e->getMessage());
		}
		//Envoit des variables au template
		$smarty->assign('adm_user_view', 'view');
		$smarty->assign('l_adm_delete',$lang['ADM_DELETE_USER']);
		$smarty->assign('l_delete',$lang['DELETE']);
		$smarty->assign('l_adm_user_add_grp',$lang['ADM_USER_ADD_GRP']);
		$smarty->assign('list_grp', $list_grp);
		$smarty->assign('l_email', $lang['ADM_EMAIL']);
		$smarty->assign('l_inscription_time', $lang['ADM_INSCRIPTION_TIME']);
		$smarty->assign('l_lang', $lang['ADM_LANG']);
		$smarty->assign('l_user_reset_password',$lang['ADM_USER_RESET_PASSWORD']);
		$smarty->assign('adm_current_userid', $user->getId());


		$smarty->assign('home_page', $usermod->getHomePage());
		
		if($usermod->getHomePage() == '/index.php')
		{
			$smarty->assign('home_page_type', 'empty');
		}
		else
		{
			if(is_numeric($usermod->getHomePage()))
			{
				$smarty->assign('home_page_type', 'dashboard');
			}
			else
			{
				$smarty->assign('home_page_type', 'url');
			}
		}
		
		//info pour la page d'accueil
		$dashboards = Model_esia::getDashboards($dbconnection,null,$usermod->getId());
		foreach($dashboards['default'] as &$dash)
		{
			if(strpos($dash['name'],'LANG_')!==false)
			{
				$key = preg_replace('#LANG_#','',$dash['name']);
				$dash['name'] = $lang[$key];
			}
		}
		$smarty->assign('user_dashboard', $dashboards);
		
	}
	//affiche la list de tous les utilisateurs ou de l'utilisateur recherché
	elseif($action=="list")
	{
		if(!isset($_POST['username']))
		{
			$_POST['username']=null;
		}
		$smarty->assign('adm_user_list', 'list');
		$list_user=Model_adm::searchUser($dbconnection,$_POST['username']);
		$smarty->assign('list_user', $list_user);
		$smarty->assign('l_mail', $lang['ADM_EMAIL']);
		$smarty->assign('adm_current_userid', $user->getId());
	}
}
else
{
	$smarty->assign('l_invalid_action',$lang['ADM_INVALID_ACTION']);
}
?>
