<?php
//common.php
$ESIA_WIDGET_NOTREE=true;
include_once '../common.php';

//Autre.
include_once '../Model_adm.php';
include_once DEVICE_CLASS;
include_once MVCMODEL;

header('Content-Type: application/json');

/**
 * @name adm_device.inc.php
 * @description Page gérant les noeuds (ajout,suppression,modification de noeud ou des services associé)
 * 				elle est incluse par la page administration.php
 * @author Nicolas Biersart <n.biersart@esia-network.com>
 * @contributor
 * @copyright Nicolas Biersart 2013
 * @license
 * @esia 1.00
 * @version 1.0.0
 * @date 10/04/2013
 */

function filterNodes($node){
	$keys = array('name','group','type','ip','description','services');

	if(empty($_REQUEST['filters'])) return true;

	foreach($_REQUEST['filters'] as $num => $filter){
		$key = $keys[$num];

		switch($key){
			case 'id' :
			case 'services' :
			case 'name' :
			case 'type' :
			case 'group' :
			case 'ip' :
			case 'description' :
				if( !fnmatch("*$filter*",$node[$key],FNM_CASEFOLD) ) return false;
				break;
		}
	}
	return true;
}

function cmpNodes($a,$b){
	$keys = array('name','group','type','ip','description','services');

	if(empty($_REQUEST['cols'])) $cols = array();
	else $cols=$_REQUEST['cols'];

	foreach($cols as $num => $flag){
		$key = $keys[$num];

		if($flag == 0){ //Sort ASC
			$lt = -1;
			$gt = 1;
		}
		else{ //Sort DESC
			$lt = 1;
			$gt = -1;
		}

		switch($key){
			case 'id' :
			case 'services' :
			case 'ip' :
				if ( $a[$key] == $b[$key] ) break;
				return ($a[$key] < $b[$key]) ? $lt : $gt;
			case 'name' :
			case 'type' :
			case 'group' :
			case 'description' :
				$ret = strcasecmp($a[$key],$b[$key]);
				if( $ret != 0) return ($ret * $gt); // -1 * -1 = 1
				break;
		}
	}
	return 0;
}

try
{
	$nodes = Model_esia::getNodeListWithServicesStats($dbconnection,$user->getId()); //A Optimiser

	//Filter
	$nodes = array_filter($nodes,'filterNodes');

	//Sort
	usort($nodes,"cmpNodes"); //A optimiser

	//Count
	$json_array['total_rows']=count($nodes);

	//Pagination
	if( isset($_REQUEST['page']) && isset($_REQUEST['size']) && is_numeric($_REQUEST['size'])){
		$page=$_REQUEST['page'];
		$size=$_REQUEST['size'];
		$offset = $page*$size;

		$nodes = array_slice($nodes,$offset,$size);
	}

	//Last modifs + traductions
	$list = array();
	//$nodes[]=array('name'=>implode(',',array_keys($_GET)),'type'=>'test','group'=>'julien','description'=>json_encode($_GET),'services'=>0);
	foreach($nodes as $idx => $node)
	{
		$page = model_esia::getPageControl($dbconnection,$node['type']);
		//Rempalcer :id par l'id correspondant pour la page de contrôle
		$pattern = "/:id/";
		$urlnode = preg_replace($pattern,$node['id'],$page);

		//Action column
		$id = $node['id'];
		$l_adm_view=$lang['ADM_NODE_GOTO'];
		$l_adm_duplicate=$lang['ADM_NODE_DUPLICATE'];
		$l_adm_change=$lang['ADM_NODE_MODIF'];
		$l_adm_delete=$lang['DELETE'];
		$action_td=	"<a href='$urlnode' title='$l_adm_view'>";
		$action_td.=	"<img class='button' src='/theme/default-image/esia_search_button.png' alt='$l_adm_change'/>\n";
		$action_td.="</a>";
		$action_td.=	"<a class='adminTabs nodeClone' href='./administration.php?admin=device&amp;action=duplicate&amp;id=$id' title='$l_adm_duplicate'>";
		$action_td.=	"<img class='button' src='/theme/default/images/clone.svg' alt='$l_adm_duplicate'/>\n";
		$action_td.="</a>";
		$action_td.=	"<a class='adminTabs' href='./administration.php?admin=device&amp;action=modif&amp;id=$id' title='$l_adm_change'>";
		$action_td.=	"<img class='button' src='/theme/default-image/esia_update_button2.png' alt='$l_adm_change'/>\n";
		$action_td.="</a>";
		$action_td.="<a class='adminTabs' href='./administration.php?admin=device&amp;action=delete&amp;id=$id' title='$l_adm_delete'>";
		$action_td.=	"<img class='button' src='/theme/default-image/esia_delete_button.png' alt='$l_adm_delete'/>";
		$action_td.='</a>';

		$nodes[$idx]['action'] = $action_td;
		$nodes[$idx]['name'] = "<a class='adminTabs' href='./administration.php?admin=device&amp;action=modif&amp;id=$id' title='$l_adm_change'>".$node['name']."</a>";



		//Configuration de certains champs
		$nodes[$idx]['ip'] = $node['ip'];
		if( $node['group'] == null ) @$nodes[$idx][group]="";
		if( $node['description'] == null ) @$nodes[$idx][description]="";

		//Traductions
		$list[$idx][$lang['ADM_NAME']] = $nodes[$idx]['name'];
		$list[$idx][$lang['ADM_GRP']] = $nodes[$idx]['group'];
		$list[$idx][$lang['ADM_NODE_TYPE']] = $nodes[$idx]['type'];
		$list[$idx][$lang['ADM_ADDR_IP']] = $nodes[$idx]['ip'];
		$list[$idx][$lang['ADM_DESCRIPTION']] = $nodes[$idx]['description'];
		$list[$idx][$lang['ADM_NODE_SERVICE']] = $nodes[$idx]['services'];
		$list[$idx][$lang['ACTION']] = $nodes[$idx]['action'];
	}

	$json_array['headers'] = array_keys($list[0]);
	$json_array['rows']=$list;

	echo json_encode($json_array,JSON_PRETTY_PRINT);
}
catch(EsiaDbException $e)
{
	$ERROR[]=array('name'=>'DB ERROR','message'=>$e->getMessage());
}
?>
