<?php
//common.php
$ESIA_WIDGET_NOTREE=true;
include_once '../common.php';

//Autre.
include_once '../Model_adm.php';
include_once DEVICE_CLASS;
include_once MVCMODEL;

header('Content-Type: application/json');

/**
 * @name adm_device.inc.php
 * @description Page gérant les noeuds (ajout,suppression,modification de noeud ou des services associé)
 * 				elle est incluse par la page administration.php
 * @author Nicolas Biersart <n.biersart@esia-network.com>
 * @contributor
 * @copyright Nicolas Biersart 2013
 * @license
 * @esia 1.00
 * @version 1.0.0
 * @date 10/04/2013
 */

function filterNodes($node){
	$keys = array('name','description','fullpath');

	if(empty($_REQUEST['filters'])) return true;

	foreach($_REQUEST['filters'] as $num => $filter){
		$key = $keys[$num];

		switch($key){
			case 'name' :
			case 'description' :
			case 'fullpath' :
				if( !fnmatch("*$filter*",$node[$key],FNM_CASEFOLD) ) return false;
				break;
		}
	}
	return true;
}

function cmpNodes($a,$b){
	$keys = array('name');

	if(empty($_REQUEST['cols'])) $cols = array();
	else $cols=$_REQUEST['cols'];

	foreach($cols as $num => $flag){
		$key = $keys[$num];

		if($flag == 0){ //Sort ASC
			$lt = -1;
			$gt = 1;
		}
		else{ //Sort DESC
			$lt = 1;
			$gt = -1;
		}
		switch($key){
			case 'name' :
				$ret = strcasecmp($a[$key],$b[$key]);
				if( $ret != 0) return ($ret * $gt); // -1 * -1 = 1
				break;
		}
	}
	return 0;
}

function convert_tree_to_select($top,$itt,$parentid=null,$parentname=null)
{
	$pname=null;
	if(isset($parentname))
	{
		$pname = $parentname.' > '.$top['name'];
	}
	else
	{
		$pname = $top['name'];
	}
	$arr=array();
	$arr[]=array('id'=>$top['id'],'name'=>$top['name'],'description'=>$top['description'],'level'=>$itt,'parent'=>$parentid,'parent_name'=>$pname);
	$itt++;
	if(isset($top['child']))
	{
		$tmp=array();
		foreach($top['child'] as $child)
		{
			$tmp = convert_tree_to_select($child,$itt,$top['id'],$pname);
			$arr = array_merge($arr, $tmp);
		}
	}

	return $arr;
}


try
{
	$groups = Model_esia::getGroupDevice($dbconnection); //A Optimiser

	/*$select =array();
	foreach($groups as $top)
	{
		$tmp = convert_tree_to_select($top,0);
		$select = array_merge($select, $tmp);
	}

	$groups = array();

	foreach($select as $idx=>$group){
		$groups[$idx]['id'] = $group['id'];
		if( $group['level'] != 0 )	$groups[$idx]['name']=$group['parent_name'];
		else						$groups[$idx]['name']=$group['name'];
		if($groups[$idx]['name'] == null ) $groups[$idx]['name']='';
		$groups[$idx]['description']=$group['description'];
		if($groups[$idx]['description'] == null ) $groups[$idx]['description']='';
	}*/

	//Filter
	$groups = array_filter($groups,'filterNodes');

	//Sort
	usort($groups,"cmpNodes"); //A optimiser

	//Count
	$json_array['total_rows']=count($groups);

	//Pagination
	if( isset($_REQUEST['page']) && isset($_REQUEST['size']) && is_numeric($_REQUEST['size'])){
		$page=$_REQUEST['page'];
		$size=$_REQUEST['size'];
		$offset = $page*$size;

		$groups = array_slice($groups,$offset,$size);
	}

	//Last modifs + traductions
	$list = array();
	foreach($groups as $idx => $group)
	{
		//Action column
		$id = $group['id'];
		$l_adm_change=$lang['ADM_NODE_GROUP_UPDATE'];
		$l_adm_delete=$lang['DELETE'];
		$action_td=	"<a class='adminTabs' href='./administration.php?admin=nodegroups&amp;action=modif&amp;id=$id' title='$l_adm_change'>";
		$action_td.=	"<img class='button' src='/theme/default-image/esia_update_button2.png' alt='$l_adm_change'/>\n";
		$action_td.="</a>";
		$action_td.="<a class='adminTabs' href='./administration.php?admin=nodegroups&amp;action=delete&amp;id=$id' title='$l_adm_delete'>";
		$action_td.=	"<img class='button' src='/theme/default-image/esia_delete_button.png' alt='$l_adm_delete'/>";
		$action_td.='</a>';
		$groups[$idx]['action'] = $action_td;

		$list[$idx][$lang['ADM_NAME']]=$group['name'];
		$list[$idx][$lang['ADM_DESCRIPTION']]=$group['description'];
		$list[$idx][$lang['GROUP_DEVICE_PATH']]=$group['fullpath'];
		$list[$idx][$lang['ACTION']] = $groups[$idx]['action'];
	}

	$json_array['headers'] = array_keys($list[0]);
	$json_array['rows']=$list;

	echo json_encode($json_array,JSON_PRETTY_PRINT);
}
catch(EsiaDbException $e)
{
	$ERROR[]=array('name'=>'DB ERROR','message'=>$e->getMessage());
}
?>
