<?php
$temps = microtime();
$temps = explode(' ', $temps);
$debut = $temps[1] + $temps[0];
//on récupère le nom du serveur
if(!isset($_GET['nodeid']) && empty($_GET['nodeid']))
{
	$smarty->display('no_access.html');
	exit(0);
}
$nodeid=$_GET['nodeid'];
if(isset($webp_name) && !empty($webp_name))
{
    try
    {
        //chemin d'accès au repertoire du plugin contenant les templates
        $arr = Model_esia::getWebPlugin($dbconnection,false,$webp_name);
        $apache_plugin_path = $arr[0]['apache_path'];
        $template_path= $path.$apache_plugin_path.'templates/';
        if(isset($webp_model))
        {
            include_once $path.$apache_plugin_path.$webp_model;
        }
    }
    catch (Exception $e)
    {
        echo "la variable webp_name n'est pas configurée $webp_name";
        exit(1);
    }
}

//instanciation d'un objet noeud
$node=null;
try
{
    $node=Model_esia::InstanceNode($dbconnection,$nodeid);
    //on test si on a les autorisation d'accès
    if($user->getDroits($dbconnection,"device_view",$node->getName()) !=1)
    {
	    $smarty->display('no_access.html');
	    exit(0);
    }
}
catch(Exception $e)
{
	$smarty->display('no_access.html');
	exit(0);
}
$descr = htmlentities($node->getDescription() , ENT_QUOTES);
$node_info = array(
	'id' => $node->getId(),
	'name' => $node->getName(),
	'ip' => $node->getIPAddress(),
	'id' => $node->getId(),
	'description' => nl2br($descr),
	'group' => $node->getGroup(),
	'gesa_info' => array(
		'gesaId' => NULL,
		'isGesaRemote' => FALSE, // Node monitored by GESA
		'isGesa' => FALSE, // GESA
		'isConnected' => FALSE,
	),
);
if(@get_class($node) == 'RemoteDevice')
{
	$node_info['gesa_info']['isGesaRemote'] = TRUE;
	$node_info['gesa_info']['gesaId'] = $node->getGESA()->getId();
	$node_info['gesa_info']['gesaSN'] = $node->getGESA()->getSerialNumber();
}
elseif(@get_class($node) == 'GESA')
{
	$node_info['gesa_info']['isGesa'] = TRUE;
	$node_info['gesa_info']['gesaId'] = $node->getId();
	$node_info['gesa_info']['gesaSN'] = $node->getSerialNumber();
}

if(!isset($_GET['tab']) || empty($_GET['tab']))
{
    //On a reussi a instancier un objet server donc on complète la navbar
    $navbar->addNode($node, $ICONS[$node->getType()]);
    //Etats des services
    $listState = Model_esia::countNodeState($dbconnection, $node->getId());
    $nbr_error=0;
    //on additionne les erreurs et les services OK (on a ainsi le total des services check et des services passifs)
    $nbr_error=$nbr_error+$listState['critical']+$listState['warning']+$listState['unknown'];
    $smt_status = array('nbr_error'=>$nbr_error,
				            'nbr_service'=>$nbr_error + $listState['OK']);
    $smt_status = array_merge ($smt_status,$listState);
    $smarty->assign('node_status',$smt_status);
    $treeview_opengroups= $navbar->getNavbarGroupNodeOpen();
    $smarty->assign('treeview_opengroups', $treeview_opengroups);
    
    $advs = Model_esia::getAdvanceNodeConfig($dbconnection,$node->getId());
    $additionnalsTab=array();
    foreach($advs as $adv)
    {
    	if(!empty($adv['nodetab']))
    	{
    		//print_r($adv);
    		$filecss=null;
    		if(preg_match('#(/plugin/[0-9a-zA-Z]*)/adv_tab_([0-9a-zA-Z]*)\.php#',$adv['nodetab'],$regs))
    		{
    			$file= $_SERVER['DOCUMENT_ROOT'].$regs[1].'/'.$regs[2].'.css';
    			if(is_file($file))
    			{
    				$filecss = $regs[1].'/'.$regs[2].'.css';
    			}
    		}
    		$url = preg_replace('#\:id#', $node->getId(), $adv['nodetab']);
    		$translate = $adv['name'];
    		if(array_key_exists('TAB_NODE_'.$adv['name'], $lang))
    		{
    			$translate = $lang['TAB_NODE_'.$adv['name']];
    		}
    		$additionnalsTab[]=array('name'=>$adv['name'],'translate'=> $translate,'url' =>$url,'css'=>$filecss );
    	}
    }
    $tabs = Model_esia::getNodeTabs($dbconnection,$node->getId());
    foreach($tabs as $tab)
    {
    	$filecss=null;
    	$url = $tab['url'];
    	if(preg_match('#(/plugin/[0-9a-zA-Z]*)/adv_tab_([0-9a-zA-Z]*)\.php#',$url,$regs))
    	{
    		$file= $_SERVER['DOCUMENT_ROOT'].$regs[1].'/'.$regs[2].'.css';
    		if(is_file($file))
    		{
    			$filecss = $regs[1].'/'.$regs[2].'.css';
    		}
    	}
    	$url = preg_replace('#\:id#', $node->getId(), $url);
    	$translate = $tab['name'];
    	if(array_key_exists('TAB_NODE_'.$tab['name'], $lang))
    	{
    		$translate = $lang['TAB_NODE_'.$tab['name']];
    	}
    	$additionnalsTab[]=array('name'=>$tab['name'],'translate'=> $translate,'url' =>$url,'css'=>$filecss );
    }
    
    $smarty->assign('additionnal_tab',$additionnalsTab);
}
$smarty->assign('webp_name_css',$webp_name);
$smarty->assign('node',$node_info);
$smarty->assign('apache_path', $apache_plugin_path);
?>
