<?php
/**
 * @name node_AvailabilityCalculation
 * @description Calcul le pourcentage de disponnibilité d'un noeud. Se script est appellé par une requête AJAX (node_control)
 * @author Nicolas Biersart <n.biersart@esia-network.com>
 * @contributor
 * @copyright Nicolas Biersart 2012
 * @license
 * @esia 1.00
 * @version 1.0.0
 * @date 19/11/2012
 */
$path = $_SERVER['DOCUMENT_ROOT'];
include_once $path.'common.php';

//fonction qui dessine et affiche une image "No data"
function img_no_data()
{
	//pas de donnée à afficher service trop réçent
	$image = imagecreate(200,50);
	$blanc = imagecolorallocate($image, 255, 255, 255);
	$noir = imagecolorallocate($image, 0, 0, 0);
	imagestring($image, 4, 55, 5, "No data ", imagecolorallocate($image, 0, 0, 0));
	imagestring($image, 4, 35, 15,"for this month", imagecolorallocate($image, 0, 0, 0));
	imagecolortransparent($image, $blanc);
	imagepng($image);
}
//fonction qui force le navigateur à afficher la fenetre de téléchargement
//par défaut fichier de type image
function force_download($type='png')
{
	//on force le navigateur à afficher la fenêtre de téléchargement
	header('Content-Type: application/octet-stream');
	header('Content-disposition: attachment; filename=export.'.$type);
	header('Pragma: no-cache');
	header('Cache-Control: no-store, no-cache, must-revalidate, post-check=0, pre-check=0');
  	header('Expires: 0');	
}
try
{
	//instanciation du noeud
	$node =  Model_esia::InstanceNode($dbconnection, $_GET['id']);
	//vérification des droits
	if($user->getDroits($dbconnection,"device_view",$node->getName() ) ==1)
	{
		//type demandé (csv ou img)
		if(isset($_GET['type'])&&$_GET['type']=='csv')//format csv
		{
			force_download('csv');
			//test si c'est  pour le noeud global ou pour un service
			if(isset($_GET['service']))
			{
				//récupération du service
				$service = Model_esia::getServices($dbconnection,$node->getId(),$_GET['service']);
				$service = $service[0];
				$arr = Model_esia::countPourcentAvailabilityServiceByMonth($dbconnection,$node->getId(),$service['id']);
				echo "month;Availability\n";
				for($i=count($arr)-1;$i>=0;$i--)
				{
					$m = $arr[$i]['month']."/".$arr[$i]['year'];
					if($_GET['ftime']=='timestamp')
					{
						$m =strtotime($arr[$i]['month'].'/01/'.$arr[$i]['year']);
					}
					//$m =strftime('%B',strtotime($arr[$i]['month'].'/01/'.$arr[$i]['year']));
					//$m =strftime('%Y-%m-%d %l:%M%p',strtotime($arr[$i]['month'].'/01/'.$arr[$i]['year']));
					
					//echo $arr[$i]['month']."/".$arr[$i]['year'].";".preg_replace('#\.#',',',$arr[$i]['pourcent']).";".$m."\n";
					echo $m.";".preg_replace('#\.#',',',$arr[$i]['pourcent'])."\n";
				}
			}
			else
			{
				$services = Model_esia::getServices($dbconnection,$node->getId());	
				$csv=array('title'=>array());
				array_push($csv['title'],'month');
				foreach($services as $service)
				{
					$csv['title'] = array_merge($csv['title'],array($service['name']));
					$arr = Model_esia::countPourcentAvailabilityServiceByMonth($dbconnection,$node->getId(),$service['id']);
					for($i=count($arr)-1;$i>=0;$i--)
					{
						$m =strftime('%B',strtotime($arr[$i]['month'].'/01/'.$arr[$i]['year']));
						$key=$m.$arr[$i]['year'];
						if(array_key_exists($key,$csv))
						{
							$tmp = preg_replace('#\.#',',',$arr[$i]['pourcent']);
							$csv[$key] = array_merge($csv[$key],array($tmp));
						}
						else
						{
							$tmp = $arr[$i]['month']."/".$arr[$i]['year'];
							if($_GET['ftime']=='timestamp')
							{
								$tmp =strtotime($arr[$i]['month'].'/01/'.$arr[$i]['year']);
							}
							$csv[$key]=array($tmp,preg_replace('#\.#',',',$arr[$i]['pourcent']));
						}
					}
	
				}
				if(isset($_GET['form'])&& $_GET['form']=='global' )
				{
					$csvglobal = array();
					$csvglobal[]=array('month','percent');
					foreach($csv as $key=>  $line)
					{
						if( $key !='title')
						{
							$value = 0;
							$nbr=0;
							for($i=1;$i<count($line);$i++)
							{
								if($line[$i]!=0 )
								{
									$value = $value + $line[$i];
									$nbr++;
								}	
									
							}
							$value = $value/$nbr;
							$csvglobal[]=array($line[0],$value);
						}
					}
					
					foreach($csvglobal as $ligne)
					{
						$stringcsv = implode(";", $ligne);
						echo "$stringcsv\n";
					}
				}
				else
				{
					foreach($csv as $ligne)
					{
						$stringcsv = implode(";", $ligne);
						echo "$stringcsv\n";
					}
				}
			}
		}
		elseif(isset($_GET['type'])&&$_GET['type']=='jsonC3')//format JSONC3
		{
			$day = 15;
			$allservice = false;
			if(isset($_GET['day']) && is_numeric($_GET['day']))
			{
				$day = $_GET['day'];
			}
			if(isset($_GET['allservice']) && !empty($_GET['allservice']))
			{
				$allservice = true;
			}
			header('Content-Type: application/json');
			$services = Model_esia::getServices($dbconnection,$_GET['id']);
			$priomax = 8;
			$ser=null;
			$json = array();
			$jsontable=array();
			if($allservice === true)
			{	
				foreach($services as $service)
				{
					$avai = Model_esia::getAvailability($dbconnection,$_GET['id'],$service['id'],null,$day);
					foreach ($avai as $time => $value) {
						$jsontable['x'][] = $time." 00:00:00";
					}
					break;
				}
				foreach($services as $service)
				{
					$avai = Model_esia::getAvailability($dbconnection,$_GET['id'],$service['id'],null,$day);
					foreach ($avai as $time => $value)
					{
						if(is_nan($value))
						{
							$value=0;
						}else{
							$value=intval($value);
						}
						$jsontable[$service['name']][] = $value;
					}
					$json[] =array('name'=>$service['name'],'data'=>$avai);
				}
				echo json_encode($jsontable);

			}
			else 
			{
				foreach($services as $service)
				{
					if($service['priority'] < $priomax)
					{
						$ser = $service;
						$priomax = $service['priority'];
					}
				}
				$avai = Model_esia::getAvailability($dbconnection,$_GET['id'],$ser['id'],null,$day);
				$json =array('name'=>$ser['name'],'data'=>$avai);
				
				echo json_encode($json);
			}
			//OK avec le service 1 
		}
		else
		{
			//récupération du service
			$service = Model_esia::getServices($dbconnection,$node->getId(),$_GET['service']);
			$service = $service[0];
			//format XML pour l'affichage des stat "brut"
			if($_GET['action']=='pourcentPerErrorType')
			{
				if(isset($_GET['month'])&&!empty($_GET['month'])&&isset($_GET['year'])&&!empty($_GET['year']))
				{
					$pourcent = Model_esia::countPourcentAvailabilityServiceByErrorType($dbconnection,$node->getId(),$service['id'],$_GET['month'],$_GET['year']);
					header('Content-Type: text/xml; charset=utf-8');
					$xml = new DOMDocument('1.0', 'utf-8');
					$nog = $xml->createElement('service');
					$ok = $xml->createElement('ok',$pourcent['ok']);
					$nog->appendChild($ok);
					$warning = $xml->createElement('warning',$pourcent['warning']);
					$nog->appendChild($warning);
					$critical = $xml->createElement('critical',$pourcent['critical']);
					$nog->appendChild($critical);
					$unknown = $xml->createElement('unknown',$pourcent['unknown']);
					$nog->appendChild($unknown);
					$xml->appendChild($nog);
					echo $xml->saveXML();
				}
				//print_r($pourcent);
			}
			else
			{
				//affichage
				header('Content-Type: text/xml; charset=utf-8');
				$xml = new DOMDocument('1.0', 'utf-8');
				//calcul des pourcentages
				$pourcent = Model_esia::countPourcentAvailabilityService($dbconnection,$node->getId(),$service['id']);

				$nog = $xml->createElement('service');
				$nog->setAttribute('name',$service['name']);
				$nog->appendChild($xml->createElement('total_availability',round($pourcent,2)));
				$arr = Model_esia::countPourcentAvailabilityServiceByMonth($dbconnection,$node->getId(),$service['id']);
				$monthavailable = $xml->createElement('months_availability');
				foreach($arr as $row)
				{
					$month = $xml->createElement('month',$row['pourcent']);
					$m =strftime('%B',strtotime($row['month'].'/01/'.$row['year']));
					$month->setAttribute('name',$m);
					$month->setAttribute('month',$row['month']);
					$month->setAttribute('year',$row['year']);
					//ajout à l'arbre XML
					$monthavailable->appendChild($month);
				}
				$nog->appendChild($monthavailable);
				$xml->appendChild($nog);
				echo $xml->saveXML();
			}
		}
	}
	else
	{
		echo $lang['NO_ACCES'];
	}
}
catch(EsiaDbException $e)
{
	//au niveux de la requête de la base de donnée cela arrive si on demande les infos d'un noeud qui n'existe pas
	echo $e->getMessage();
}



?>
