<?php
/**
 * @name index_errorTable.
 * @description page générant les principaux tableaux d'erreur
 * @author Nicolas Biersart <n.biersart@esia-network.com>
 * @contributor
 * @copyright Nicolas Biersart 2012
 * @license
 * @esia 1.00
 * @version 1.0.0
 * @date 19/11/2012
 */
$path = $_SERVER['DOCUMENT_ROOT'];
include_once $path.'common.php';
if(isset($_GET['table'])&& $_GET['table']=='group')
{
	//XML retourné pour le dashboard notamment contient le nom du groupe ainsi que son nombre d'erreur,warning, etc
	if(isset($_GET['type']) && $_GET['type']=='xml')
	{
		header('Content-Type: text/xml; charset=utf-8');
		$xml = new DOMDocument('1.0', 'utf-8');
		$root = $xml->createElement('list');
		//récupération des noms de groupes et de leur état
		$arr = Model_esia::countStateByGroupname($dbconnection,$user->getId());
		foreach($arr as $group => $error)
		{
			$nog = $xml->createElement('group');
			if(!empty($group))
				$nog->setAttribute('name', $group);
			else
				$nog->setAttribute('name','nogroup');
			//ajout à l'arbre XML
			$nog->appendChild($xml->createElement('ok',$error['ok']));
			$nog->appendChild($xml->createElement('warning',$error['warning']));
			$nog->appendChild($xml->createElement('critical',$error['critical']));
			$nog->appendChild($xml->createElement('unknown',$error['unknown']));
			$root->appendChild($nog);
		}

		$xml->appendChild($root);
		echo $xml->saveXML();
	}
}
elseif(isset($_GET['noauth']))
{
	//Calcul du nombre de service "actifs" (tableau en haut à droite)
	$arr_error = array();
	$arr_error['OK']=array('nbr'=>0,'pourcent'=>0);
	$arr_error["warning"]= array('nbr'=>0,'pourcent'=>0);
	$arr_error["critical"]= array('nbr'=>0,'pourcent'=>0);
	$arr_error["unknown"]= array('nbr'=>0,'pourcent'=>0);
	$li=Model_esia::countServiceAllState($dbconnection,$user->getId());
	$totser = 0;
	foreach($li as $k => $v)
	{
		$totser= $totser + $v;
	}
	//si il n'y a aucun service qui tourne évite une erreur 'division par 0'
	if($totser!=0)
	{
		foreach($li as $k => $v)
		{
			$pourcent = round((($v/$totser)*100));
			$arr_error[$k]=array('nbr'=>$v,'pourcent'=>$pourcent);
		}
	}
	header('Content-Type: text/xml; charset=utf-8');
	$xml = new DOMDocument('1.0', 'utf-8');
	$root = $xml->createElement('service');
	foreach($arr_error as $key => $val)
	{
		$nog = $xml->createElement('error');
		$nog->setAttribute('name', $key);
		$nog->appendChild($xml->createElement('nbr',$val['nbr']));
		$root->appendChild($nog);
	}
	$xml->appendChild($root);
	echo $xml->saveXML();
}
else
{
	header('Content-Type: text/xml; charset=utf-8');
	$xml = new DOMDocument('1.0', 'utf-8');
	$root = $xml->createElement('list');
	//récupération de l'état des noeuds selon leur type
	$arr = Model_esia::countNodeType($dbconnection,$user->getId(), Model_esia::NODE_COUNT_SERVICE_STATE);
	$total_node=0;
	$total_service=0;
	foreach($arr as $key => $val)
	{
		$nog = $xml->createElement('type');
		$nog->setAttribute('name', $key);
		$nog->appendChild($xml->createElement('device',$val['nbr_device']));
		$nog->appendChild($xml->createElement('ok',$val['ok']));
		$nog->appendChild($xml->createElement('warning',$val['warning']));
		$nog->appendChild($xml->createElement('critical',$val['critical']));
		$nog->appendChild($xml->createElement('unknown',$val['unknown']));
		$total_node = $total_node+$val['nbr_device'];
		//compte le nombre de service
		$tmp = $val['ok']+$val['warning']+$val['critical']+$val['unknown'];
		$nog->appendChild($xml->createElement('service',$tmp));
		$total_service= $total_service+$tmp;
		$root->appendChild($nog);
	}
	$root->appendChild($xml->createElement('total_node',$total_node));
	$root->appendChild($xml->createElement('total_service',$total_service));
	$xml->appendChild($root);
	echo $xml->saveXML();
}
?>
