<?php
/**
 * @name snmp.lib.php
 * @description Librairie proposant des fonctions de formatage pour les requêtes SNMP
 * @author Nicolas Biersart <n.biersart@esia-network.com>
 * @contributor
 * @copyright Nicolas Biersart 2012
 * @license
 * @esia 1.00
 * @version 1.0.0
 * @date 07/11/2012
 */
//////////////////////////////////////////////////////////////////////
//        CONVERSION DE RESPONSE   SNMP          //
/////////////////////////////////////////////////////////////////////
/*@DEPRECATED
 *@NAME: formatPhysicalChassis
*@IN: $request le retour de la requête SNMP
*@OUT:
*@TREAT:
*@EXCEPTION: 	/
*/
function formatIdVlan ($request)
{
	preg_match("#[0-9]{1,4}$#",$request,$regs);
	return $regs[0];
}
/*@DEPRECATED
 *@NAME: formatPhysicalChassis
*@IN: $request le retour de la requête SNMP
*@OUT:
*@TREAT:
*@EXCEPTION: 	/
*/
function formatAccessMode ($request)
{

	if(preg_match("#dynamic|static|multiVlan#",$request,$regs))
		return $regs[0];
	$request = formatInteger($request);
	if($request=="1")
		return "static";
	elseif($request=="2")
	return "dynamic";
	elseif($request=="3")
	return "multiVlan";
	else
		return false;
}
/*@DEPRECATED
 *@NAME: formatPhysicalChassis
*@IN: $request le retour de la requête SNMP
*@OUT:
*@TREAT:
*@EXCEPTION: 	/
*/
function formatTrunk($request)
{
	if (preg_match("#on|off#",$request,$regs))
		return $regs[0];
	$request = formatInteger($request);
	if($request=="1")
		return "on";
	elseif($request=="2")
	return "off";
	elseif($request=="3")
	return "desirable";
	elseif($request=="4")
	return "auto";
	elseif($request=="5")
	return "onNoNegotiate";
}
/*@formatRmonAlarm
 *@NAME: formatPhysicalChassis
*@IN: $request le retour de la requête SNMP
*@OUT:
*@TREAT:
*@EXCEPTION: 	/
*/
function formatRmonAlarm($request)
{
	preg_match("#::([a-zA-Z]*\.[0-9]{1,6})#",$request,$regs);
	return $regs[1];
}
/*@DEPRECATED
 *@NAME: formatPhysicalChassis
*@IN: $request le retour de la requête SNMP
*@OUT:
*@TREAT:
*@EXCEPTION: 	/
*/
function formatPhysicalChassis($request)
{
	preg_match("#\(([1-9]{1,2})\)#",$request,$regs);
	return $regs[1];
}
/*@DEPRECATED
 *@NAME: secConvertTo
*@IN: $time un nombre de seconde
*@OUT: une chaine de caractère  $jour." j ". $heure." h ".$min." min ".$sec." s"
*@TREAT: Enlève le "Timeticks:" présent dans la réponse SNMP et nettoie la chaine
*@EXCEPTION: 	/
*/
function secConvertTo($time)
{
	// On extrait le nombre de jours
	$jour = floor($time/86400);
	$reste = $time%86400;
	// puis le nombre d'heures
	$heure = floor($reste/3600);
	$reste = $reste%3600;
	// puis les minutes
	$min = floor($reste/60);
	// puis les secondes
	$sec = $reste%60;
	return $jour." j ". $heure." h ".$min." min ".$sec." s";
}
/*@NAME: TimeTicksToSec
 *@IN: $request le retour de la requête SNMP
*@OUT: un tableau associatif array('day'=>$jour,'hour'=>$heure,'minute'=>$minute,'second'=>$seconde );
*@TREAT: formate et converti le timeticks
*@EXCEPTION: 	/
*/
function TimeTicksToSec($request )
{
	//echo'<br />'.$tt.'<br />';
	preg_match("#\(([0-9]*)\)#",$request,$regs);
	$tick=$regs[1];
	$jour = (int) ($tick/100/60/60/24);
	$t=100*60*60*24*$jour;
	$tick=$tick-$t;
	$heure = (int)($tick/100/60/60);
	$t=100*60*60*$heure;
	$tick=$tick-$t;
	$minute = (int)($tick/100/60);
	$t=100*60*$minute;
	$tick=$tick-$t;
	$seconde = (int)($tick/100);
	$c = array('day'=>$jour,'hour'=>$heure,'minute'=>$minute,'second'=>$seconde );
	return $c;
}
/*@NAME: formatTimeticks
 *@IN: $request le retour de la requête SNMP
*@OUT: requête SNMP formatée, un INTEGER >0
*@TREAT: Enlève le "Timeticks:" présent dans la réponse SNMP et nettoie la chaine
*@EXCEPTION: 	/
*/
function formatTimeticks($request)
{
	if(preg_match("#Timeticks:\s+\(([0-9]*)\)#",$request,$regs))
	{
		$request = $regs[1];
	}
	return trim($request);
}
/*@NAME: formatString
 *@IN: $request le retour de la requête SNMP
*@OUT: la requête SNMP formatée
*@TREAT: formate la requete SNMP de type STRING
*@EXCEPTION: 	/
*/
function formatString($request)
{
	$request=preg_replace("#STRING:#",'',$request);
	$request=preg_replace('#\"#','',$request);
	if(preg_match('#^Hex-\s+(.*)#',$request,$regs))
	{
		$request = hex2bin($request);
	}
	return trim($request);
}
/*@NAME: formatHexString
 *@IN: $request le retour de la requête SNMP
*@OUT: la requête SNMP formatée
*@TREAT: formate la requete SNMP de type Hex-STRING
*@EXCEPTION: 	/
*/
function formatHexString($request)
{
	//Hex-STRING: 00 09 B7 4F 78 01
	$request=preg_replace("#Hex-STRING:#",'',$request);
	$request=preg_replace('#\"#','',$request);
	//Il semblerait que la librairie PHP ne connaisse pas le type Hex-STRING pourtant défini dans les standards!
	//Les fonction PHP retourne un chaine sur se format là: STRING: 0:9:b7:4f:78:1
	//On va donc décortiquer la chaine de caractère pour rajouter les '0' manquants, supprimer les ":" et mettre les lettres Hexadécimal en majuscule
	//on retourne une chaine sur se format là  00 09 b7 4f 78 01
	if(preg_match('#STRING:\s+([0-9a-fA-F]{1,2})\:([0-9a-fA-F]{1,2})\:([0-9a-fA-F]{1,2})\:([0-9a-fA-F]{1,2})\:([0-9a-fA-F]{1,2})\:([0-9a-fA-F]{1,2})#',$request,$regs))
	{
		$request='';
		$i=1;
		while($i<count($regs))
		{
			if(strlen($regs[$i])==1)
			{
				$request.='0'.strtoupper($regs[$i]).' ';
			}
			else
			{
				$request.=strtoupper($regs[$i]).' ';
			}
			$i++;
		}

	}
	return trim($request);
}
/*@NAME: formatInteger
 *@IN: $request le retour de la requête SNMP
*@OUT: la requête SNMP formatée
*@TREAT: formate la requete SNMP de type integer
*@EXCEPTION: 	/
*/
function formatInteger ($request)
{
	if(preg_match("#^INTEGER:[a-zA-Z\s\(]*([0-9]*)#",$request,$regs))
		return trim($regs[1]);
	elseif(preg_match("#INTEGER: ([0-9]*)#",$request,$regs))
	return trim($regs[1]);
	else
		return $request;
}
/*@NAME: formatCounter
 *@IN: $request le retour de la requête SNMP
*@OUT: la requête SNMP formatée in integer >0
*@TREAT: formate la requete SNMP de type Counter32 ou Counter64
*@EXCEPTION: 	/
*/
function formatCounter($request)
{
	if(preg_match("#Counter32:\s+([0-9]*)#",$request,$regs))
		return trim($regs[1]);
	elseif(preg_match("#Counter64:\s+([0-9]*)#",$request,$regs))
		return trim($regs[1]);
	else
		return $request;
}
/*@NAME: formatGauge32
 *@IN: $request le retour de la requête SNMP
*@OUT: la requête SNMP formatée in integer >0
*@TREAT: formate la requete SNMP de type Gauge32
*@EXCEPTION: 	/
*/
function formatGauge32($request)
{
	if(preg_match("#Gauge32:\s+([0-9]*)#",$request,$regs))
		return trim($regs[1]);
	else
		return $request;
}
/*@NAME: formatOID
 *@IN: $request le retour de la requête SNMP
*@OUT: requête SNMP formatée
*@TREAT: Enlève le "OID:" présent dans la réponse SNMP et nettoie la chaine
*@EXCEPTION: 	/
*/
function formatOID($request)
{
	$request=preg_replace("#OID:#",'',$request);
	return trim($request);
}
?>
