<?php 
/**
 * Esia UI forms_select
 * @author Nicolas Biersart
 * @param array $params un tableau associatif contenant les paramètres passé à la fonction
 * @param Smarty_Internal_Template $template template object
 * @return string   la sortie au format HTML.
 * @uses ui_forms_select
 */
function smarty_function_eui_forms_select($params, $template)
{
	$output='';
	if(array_key_exists('label',$params))
	{
		$output.='<label for="'.$params['id'].'"';
		if(array_key_exists('labelclass',$params))
		{
			$output.=' class="'.$params['labelclass'].'"';
		}
		if(array_key_exists('labelstyle',$params))
		{
			$output.=' style="'.$params['labelstyle'].'"';
		}
		if(array_key_exists('onclick',$params))
		{
			$output.=' onclick="'.$params['onclick'].'"';
		}		
		$output.='>';
		if(isset($params['beforeLabel'])) {
			$output.=$params['beforeLabel'];
		}
		$output.=$params['label'].'</label>';
	}
	//création de la balise select
	$output .= '<select';
	if(array_key_exists('name',$params))
	{
		$output.=' name="'.$params['name'].'"';
	}
	if(array_key_exists('id',$params))
	{
		$output.=' id="'.$params['id'].'"';
	}
	if(array_key_exists('class',$params))
	{
		$output.=' class="'.$params['class'].'"';
	}	
	if(array_key_exists('style', $params))
	{
		$output.=' style="'.$params['style'].'"';
	}
	if(array_key_exists('others',$params))
	{
		$output.=' '.$params['others'];
	}
	if(array_key_exists('onchange',$params))
	{
		$output.=' onchange="'.$params['onchange'].'"';
	}
	$output.='>';
	//on vérifie s'il y a des  option à ajouter au select
	if(isset($params['firstValue']))
	{
		$output.='<option value="'.$params['firstValue'].'" >'.$params['firstText'].'</option>';
	}
	if(isset($params['value']))
	{
		foreach($params['value'] as $key => $value)
		{
			$opt_key = $key;
			$opt_value = $value;
			if(array_key_exists('id',$value) && array_key_exists('name',$value))
			{
				$opt_key = $value['id'];
				$opt_value = $value['name'];
			}
			$output.='<option value="'.$opt_key.'"';
			if(isset($params['selected']))
			{
				if($params['selected'] == $opt_key)
				{
					$output.=' selected="selected"';
				}
			}
			$output.='>'.$opt_value.'</option>';
		}
	}
	$output.='</select>';
	$output.='<script type="text/javascript">
				<!--
					$("#'.$params['id'].'").chosen({no_results_text: "'.$param['noResult'].'",search_contains:true});
				-->
				</script>';
	return $output;
}

?>