<?php
function smarty_function_eui_input_text($params,&$smarty)
{
	$pattern_ip		= '^(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)$';
	$pattern_domain         = '^(([a-zA-Z]|[a-zA-Z][a-zA-Z0-9\-]*[a-zA-Z0-9])\.)*([A-Za-z]|[A-Za-z][A-Za-z0-9\-]*[A-Za-z0-9])$';

	$pattern_private_a = '10(\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)){3}';
	$pattern_private_b = '172\.(1[6-9]|2[0-9]|3[0-1])(\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)){2}';
	$pattern_private_c = '192\.168(\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)){2}';

	$pattern_all_private = "^($pattern_private_a|$pattern_private_b|$pattern_private_c)$";

	$patterns = array(
			"ip"		=> $pattern_ip,
			"private_ip"=> $pattern_all_private,
			"domain"	=> $pattern_domain,
			"host"		=> "($pattern_ip|$pattern_domain)",
			"hostname"	=> '^[a-zA-Z0-9][a-zA-Z0-9-_]{0,61}[a-zA-Z0-9]{0,1}$',
	);

	$pattern_hostname	= '^[a-zA-Z0-9][a-zA-Z0-9-_]{0,61}[a-zA-Z0-9]{0,1}$';
	$pattern_domain		= '^(([a-zA-Z]|[a-zA-Z][a-zA-Z0-9\-]*[a-zA-Z0-9])\.)*([A-Za-z]|[A-Za-z][A-Za-z0-9\-]*[A-Za-z0-9])$';

	if ( isset($params["other"])){
		$arr=$params["other"];
		unset($params["other"]);
		$params=array_merge($params,$arr);
	}

	if(empty($params["name"])){
		trigger_error("assign: missing 'name' parameter");
		return;
	}

	if(empty($params["type"])){
		trigger_error("assign: missing 'type' parameter");
		return;
	}

	if(empty($patterns[$params["type"]])){
		trigger_error("assign: bad 'type' value : ".$params["type"]);
		return;
	}

	$name=$params["name"];
	$pattern=$patterns[$params["type"]];
	$attr='type="text" name="'.$name.'" pattern="'.$pattern.'"';
	if( $params["type"] == "ip" || $params["type"] == "private_ip" ){
		if(isset($params["maxlength"])){
			trigger_error("assign: 'maxlength' parameter not needed for 'type' parameter");
			return;
		}
		$params["maxlength"]=15;
	}
	if ( isset($params["maxlength"])) {
		if(is_int($params["maxlength"])){
			$attr=$attr.' maxlength="'.$params["maxlength"].'"';
		}
		else{
			trigger_error("assign: 'maxlength' parameter must be integer ");
			return;
		}
	}

	if( isset($params["id"]))    $attr=$attr.' id="'.$params["id"].'"';
	if( isset($params["class"]))    $attr=$attr.' class="'.$params["class"].'"';
	if( isset($params["value"]))	$attr=$attr.' value="'.$params["value"].'"';
	if( isset($params["placeholder"]))    $attr=$attr.' placeholder="'.$params["placeholder"].'"';


	if( isset($params["required"]) && $params["required"] ) $attr=$attr.' required';
	if( isset($params["readonly"]) && $params["readonly"] ) $attr=$attr.' readonly';
	if( isset($params["multiple"]) && $params["multiple"] ) $attr=$attr.' multiple';

	if( isset($params["label"])){
		$att_label="";
		if( isset($params["class_label"]))    $att_label='class="'.$params["class_label"].'"';

		$output='<label for="'.$name.'"'." $att_label".'>'.$params["label"].'</label>';
	}
	else $output="";

	$output=$output."<input $attr />";
	return $output;
}