<?php
/**
 * @name uploadFile
 * @description classe gérant l'upload de fichier sur le serveur Esia
 * @author Nicolas Biersart <n.biersart@esia-network.com>
 * @contributor
 * @copyright Nicolas Biersart 2012
 * @license
 * @esia 1.00
 * @version 1.0.0
 * @date 19/11/2012
 */
class uploadFile
{
	private $dir;
	private $taille_max;
	/*@NAME: construct
	 *@IN: $d repertoire de destination
	*	$t taille maximun du fichier
	*@OUT: /
	*@TREAT: constructeur par défaut
	*@EXCEPTION: 	/
	*/
	public function __construct ($d,$t)
	{
		$this->dir=$d;
		$this->taille_max=$t;
	}
	/*@NAME: uploadImage
	 *@IN: $nom du fichier
	*	$nom sur le serveur
	*@OUT: /
	*@TREAT: upload une image dans el repertoire désiré et test tout les paramètre (taille,etc)
	*@EXCEPTION: 	/
	*/
	public function uploadImage($n,$name_in_serveur)
	{
		//test l'existence du fichier
		if (!isset($_FILES["$n"])&&empty($_FILES["$n"]['type']))
		{
			//le fichier n'existe pas
			throw new FileUploadException('file no found');
		}
		//test si il n'y a pas d'erreur
		if ($_FILES["$n"]['error'])
		{
			switch ($_FILES["$n"]['error'])
			{
				case 1: // UPLOAD_ERR_INI_SIZE
					throw new FileUploadException('file exceeds the maximum size by server (php.ini)'); break;
				case 2: // UPLOAD_ERR_FORM_SIZE
					throw new FileUploadException('file exceeds the maximum size by HTML form'); break;
				case 3: // UPLOAD_ERR_PARTIAL
					throw new FileUploadException('File transfer was interrupted'); break;
				case 4: // UPLOAD_ERR_NO_FILE
					throw new FileUploadException('the size of file was null'); break;
				default:  throw new FileUploadException('Unknown error');
			}
		}
		// On vérifie le type du fichier
		if ($_FILES["$n"]['type'] != 'image/png' && $_FILES["$n"]['type'] != 'image/jpeg' && $_FILES["$n"]['type'] != 'image/jpg' && $_FILES["$n"]['type'] != 'image/gif')
			throw new FileUploadException('Bad extention');
		if ($_FILES["$n"]['size'] > $this->taille_max)// On vérifie le poids de l'image
			throw new FileUploadException('file exceeds the maximum size by esia ');
		if (!file_exists($this->dir))
			throw new FileUploadException('Directory no found: '.$this->dir);
		// On définit l'extention du fichier puis on le nomme par le timestamp actuel
		if ($_FILES["$n"]['type'] == 'image/jpeg') {
			$extention = '.jpeg';
		}
		if ($_FILES["$n"]['type'] == 'image/jpeg') {
			$extention = '.jpg';
		}
		if ($_FILES["$n"]['type'] == 'image/png') {
			$extention = '.png';
		}
		if ($_FILES["$n"]['type'] == 'image/gif') {
			$extention = '.gif';
		}
		//$nom_fichier = "$zone-$name-etage$i".$extention;
		//echo   $nom_fichier."<br />";
		// On upload le fichier sur le serveur.
	 $lien=$this->dir.$name_in_serveur.$extention;

		if (move_uploaded_file($_FILES["$n"]['tmp_name'], $lien)===FALSE)
		{
			throw new FileUploadException('Upload Error: '.$lien);
		}
		return $lien;
	}
}
class FileUploadException extends Exception {}
?>
