<?php
/**
 * @name login.php
 * @description page d'authentification et de déconnexion des utilisateurs
 * @author Nicolas Biersart <n.biersart@esia-network.com>
 * @contributor
 * @copyright Nicolas Biersart 2012
 * @license
 * @esia 1.00
 * @version 1.0.0
 * @date 16/04/2013
 */
//include_once 'common.php';
$path = rtrim ($_SERVER['DOCUMENT_ROOT'],'/');
include $path.'/esia.conf.php';
include_once USR_CLASS;
include_once LIB_LOG;
include_once MVCMODEL;
require_once(SMARTY_DIR . 'Smarty.class.php');
//connection à la base de donnée
try
{
	$dbconnection = new PDO('pgsql:host='.DB_HOST.';port='.DB_PORT.';dbname='.DB_NAME, DB_USERNAME, DB_PWD);
	$dbconnection->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_WARNING);
}
catch(Exception $e)
{
	echo 'PDO SQL ERROR: '.$e->getMessage().'<br />';
	echo 'N° : '.$e->getCode();
}
session_start();
$smarty = new Smarty();
//configuration de la langue de l'application
include $path.'/lang/'.LANG.'/'.LANG.'.php';

//configuration moteur template
$theme = Model_esia::getApplicationTheme($dbconnection);
$smarty->template_dir = $path.'/theme/'.$theme.'/template/';
$smarty->compile_dir = $path.'/theme/'.$theme.'/templates_c/';
$smarty->config_dir = $path.'/configs/';
$smarty->cache_dir = $path.'/cache/';
$smarty->assign('css', '/theme/'.$theme.'/design.css');
$smarty->assign('lang', LANG);
$smarty->assign('title','Esia Network Management');
$smarty->assign('l_login', $lang['LOGIN']);
$smarty->assign('l_password', $lang['PASSWORD']);
$smarty->assign('l_connection', $lang['CONNECTION']);
$banner = Model_esia::getConfiguration($dbconnection,'DEFAULT_BANNER');
$smarty->assign('banner_path',$banner['DEFAULT_BANNER']['value']);
$bannerFond = Model_esia::getConfiguration($dbconnection,'DEFAULT_BANNER_FONTCOLOR');
$smarty->assign('bannerFond',$bannerFond['DEFAULT_BANNER_FONTCOLOR']['value']);
//on veut se déconnecter
if(isset($_GET['log'])&&!empty($_GET['log'])&&$_GET['log']=='logout')
{
	$user = new User($dbconnection);
	$user->disconnect();
}
else
{
	//on tente de se connecter
	if(isset($_POST['username'])&&!empty($_POST['username'])&&isset($_POST['password'])&&!empty($_POST['password']))
	{
		try
		{
			$user = new User($dbconnection);
			$user->connect($_POST['username'],$_POST['password']);
			$user->generateSessionID();
			$smarty->assign('login','1');
			$smarty->assign('l_login_success', $lang['LOGIN_SUCCESS']);
			$esialog = new EsiaLog(FILE_LOG,$_POST['username']);
			$esialog->write('ESIA', 'connection successfull');
			//on regarde pour la redirection si url est vide alors on va sur la page d'index.php
			if($user->getHomePage() != '/index.php')
			{		
				if(isset($_POST['url'])&&!empty($_POST['url']))
				{
					//empềche de se faire rediriger vers /login.php
					if($_POST['url']=='/' || preg_match('#login.php#',$_POST['url']))
                    {
				        if($user->getHomePage() == null)
				        {
				        	$dashboards = Model_esia::getDashboards($dbconnection,'LANG_DASHBOARD_HOME_NEW');
				        	$smarty->assign('url', '/dashboard/default.php?id='.$dashboards[0]['id']);
				        }
				        elseif(is_numeric($user->getHomePage()))
				        {
				        	$smarty->assign('url', '/dashboard/default.php?id='.$user->getHomePage());
				        }
				        else
				        {
				        	$smarty->assign('url',$user->getHomePage());	
				        }
                    }
                    else
                    {
				       $smarty->assign('url',$_POST['url']);
                    }
                }
                else
                {
				        if($user->getHomePage() == null) $smarty->assign('url','/index.php');
				        elseif(is_numeric($user->getHomePage())) $smarty->assign('url', '/dashboard/default.php?id='.$user->getHomePage());
				        else $smarty->assign('url',$user->getHomePage());
                }
			}
			else
			{
				if(isset($_POST['url'])&&!empty($_POST['url']))
				{
					//empềche de se faire rediriger vers /login.php
					if($_POST['url']=='/' || preg_match('#login.php#',$_POST['url']))
					{
						$dashboards = Model_esia::getDashboards($dbconnection,'LANG_DASHBOARD_HOME_NEW',$user->getId());
						$dashboards = array_shift($dashboards);
						$smarty->assign('url', '/dashboard/default.php?id='.$dashboards['id']);
					}
					else
					{
						$smarty->assign('url',$_POST['url']);
					}
				}
				else
				{
					$dashboards = Model_esia::getDashboards($dbconnection,'LANG_DASHBOARD_HOME_NEW',$user->getId());
					$dashboards = array_shift($dashboards);
					$smarty->assign('url', '/dashboard/default.php?id='.$dashboards['id']);
				}
			}
		}
		catch(UserException $e)
		{
			$smarty->assign('l_login_failed', $lang['LOGIN_FAILED']);
            if(! $_POST['url']=='/' || ! preg_match('#login.php#',$_POST['url']))
            {
                $smarty->assign('url',$_POST['url']);
            }
		}
	}
	else
	{
		header('Location: /index.php');
	}
}
$smarty->display('login.html');
?>
