<?php
/**
 * @name node_graph
 * @description page affichant les graphiques, il récupère les différents liens présent dans cacti/munin
 * @author Nicolas Biersart <n.biersart@esia-network.com>
 * @contributor
 * @copyright Nicolas Biersart 2012
 * @license
 * @esia 1.00
 * @version 1.0.0
 * @date 19/11/2012
 */
$path = $_SERVER['DOCUMENT_ROOT'];
include_once $path.'common.php';
include_once DEVICE_CLASS;


$smarty->assign("l_export",$lang["EXPORT"]);

if(isset($_GET['graphurl'])&&!empty($_GET['graphurl']))
{
	header("Content-Type: image/png");
	$path = urldecode($_GET['graphurl']);
	$path = html_entity_decode($path);
	$img = ImageCreateFromPNG($path);
	if(!$img)
	{
		/* Création d'une image vide */
		$img  = imagecreatetruecolor(150, 30);
		$bgc = imagecolorallocate($img, 255, 255, 255);
		$tc  = imagecolorallocate($img, 0, 0, 0);

		imagefilledrectangle($img, 0, 0, 150, 30, $bgc);

		/* On y affiche un message d'erreur */
		imagestring($img, 1, 5, 5, 'Erreur de chargement ' .$path, $tc);
	}
	imagepng($img);
	imagedestroy($img);
}
else
{
	if(is_numeric($_GET['id']))
	{
		//on instancie le noeud
		$node =  Model_esia::InstanceNode($dbconnection, $_GET['id']);
		if($user->getDroits($dbconnection,"device_view",$node->getName()) ==1)	//vérification des droits d'accès
		{
			$smarty->assign('node_name',$node->getName());
			$smarty->assign('node_id',$node->getId());
			if(isset($_GET['divid']))$smarty->assign('divid', $_GET['divid']);
			$graph =false;
			//$graph = Model_esia::getGraphParameter($dbconnection,$node->getId());
			if(isset($_GET['action']) && $_GET['action']=='view')
			{
				$smarty->assign('action','view');
				$service = Model_esia::getServices($dbconnection,null,$_GET['serviceid']);
				
				$service[0]['name'] = Model_esia::getCommonName($lang,$service[0]['name'],$service[0]['check_plugin_name']);
				if(!empty($service))
				{
					$smarty->assign('graph_software','esia');
					$smarty->assign('service',$service[0]);
				}
			}
			else
			{
					//récupération service 
				$today = new DateTimeImmutable();
				$smarty->assign('today',$today->format('Y-m-d'));
				$minute = $today->format('i');
				$minute = (int) ($minute/10);
				$minute = $minute*10;
				if($minute < 10)
				{
					$minute = '0'.$minute;
				}
				$smarty->assign('hour',$today->format('H').':'.$minute);
				$inter_day = new DateInterval('P1D');
				//$yesterday = $today;
				$yesterday = $today->sub($inter_day);
				$smarty->assign('yesterday',$yesterday->format('Y-m-d')); 
				$inter_year = new DateInterval('P365D');
				$today = $today->sub($inter_year);
				$smarty->assign('today_oneyear',$today->format('Y-m-d'));
				$yesterday = $yesterday->sub($inter_year);
				
				$smarty->assign('yesterday_oneyear',$yesterday->format('Y-m-d'));
				$service = Model_esia::getServices($dbconnection,$node->getId());
				$i=0;
				$size = count($service);
				$sername = array();
				while($i < $size)
				{
					$name = Model_esia::getCommonName($lang,$service[$i]['name'],$service[$i]['check_plugin_name']);
					$sername[$service[$i]['id']] = $name;
					$service[$i]['name'] = $name;
					$i++;
				}
				if(!empty($service))
				{
					$smarty->assign('graph_software','esia');
					$smarty->assign('node_services',$service);
					$smarty->assign('node_services_name',$sername);
				}
				else
				{
					//$smarty->assign('node_graphs',$graph_array);
					$smarty->assign('action','no_graph');
					$smarty->assign('l_no_graph', $lang['NO_GRAPH']);
				}
			}
		}
	}
	$smarty->assign('l_export',$lang["EXPORT"]);	
	$smarty->assign('l_export_csv',$lang["EXPORT_CSV"]);
	$smarty->assign('l_export_img',$lang["EXPORT_IMG"]);
	$smarty->assign('l_graph_page', $lang['GRAPH_PAGE']);
	$smarty->assign('l_up', $lang['GRAPH_UP']);
	$smarty->assign('l_cacti_graph', $lang['CACTI_SRV_ACCESS']);
	$smarty->display('node_graph.html');
}
?>
