<?php
/**
 * @name srv_control.php
 * @description Fichier principal du plugin serveur
 * @author Nicolas Biersart <n.biersart@esia-sa.com>
 * @contributor
 * @copyright Nicolas Biersart 2012
 * @license
 * @esia 1.00
 * @version 1.0.0
 * @date 09/11/2012
 */
$path = $_SERVER['DOCUMENT_ROOT'];
// $webp_name doit être identique au nom de la base de données !!!
//Inclusion des librairie
include_once $path.'common.php';
/*DESCRIPTION: inclus les variables habituelles pour la gestion d'un noeud et vérifie les droits d'accès
 *NECESSITE: la variable $webp_name configurée
 *           la variable $webp_model est incluste
 *APRES l'inclusion du common_node_control les variables suivantes sont créées:
 *PHP:
 *      $node objet de type device
 *      $template_path chemin d'accès vers le répertoire template du plugin (exemple: /usr/local/esia/public_html/plugin/server/templates/)
 *      $apache_plugin_path chemin apache du plugin (exemple: /plugin/server/)
 *      $node_info = array('id'=>$node->getId(),
                    'name'=>$node->getName(),
				    'ip'=>$node->getIPAddress(),
				    'id'=>$node->getId(),
				    'description'=>$node->getDescription(),
				    'group'=>$node->getGroup());
 * SMARTY
        $webp_name nom du plugin 
        $node avec les donnée de node_info (voir au dessus)
 *      $apache_path chemin apache du plugin (exemple: /plugin/server/)
 *      $node_status pour l'affichage commun des noeuds si $_GET['tab'] est vide
 *
 */
include_once $path.'/inc/common_node_control.php';
try
{
	$smarty->assign('node_control_id',$node->getId());
	//affiche les graphs
	if($user->getDroits($dbconnection,"acquit_access",$node->getName()) ==1)
	{
		$smarty->assign('acq_access','1');
	}
	if(isset($_GET['action']) && $_GET['action']=='graph')
	{
		$smarty->assign('mode','graph');
	}
	elseif(isset($_GET['action']) && $_GET['action']=='view')
	{
		//affiche un graph en particulié
		$smarty->assign('mode','view_graph');
		$smarty->assign('local_graph_id',$_GET['local_graph_id']);
		$smarty->assign('rra_id',$_GET['rra_id']);
	}
	elseif(isset($_GET['action']) && $_GET['action']=='historic')
	{
		//affiche l'historique d'un noeud
		$smarty->assign('mode','historic');
	}
	else
	{
		//affiche le service
		$smarty->assign('mode','service');
	}
}
catch(EsiaDbException $e)
{
	//au niveux de la requête de la base de donnée cela arrive si on demande les infos d'un noeud qui n'existe pas
	$smarty->assign('node_bad_access',$lang['NODE_NO_ACCESS']);
	$smarty->assign('node_bad_access_1',$lang['NODE_NO_ACCESS_1']);
}
//affichage de la page
$temps = microtime();
$temps = explode(' ', $temps);
$fin = $temps[1] + $temps[0];

// On affiche la différence entre des deux valeurs
$smarty->assign('execute_time',round(($fin - $debut),6) );

$smarty->display('node_view.html');
?>
