<?php
/**
 * @name common
 * @description fichier commun à toutes les pages web de l'application
 *		vérifie qu'un utilisateur est authentifié: objet $user est disponnible il contient les infos de l'utilisateur (droit d'accès etc)
 *		Initie la connexion à la base de donnée: objet PDO $dbconnection
 *		Instancie l'objet smarty: objet $smarty dispo
 *		Met en place le CSS et les variables de langue
 *		Initialise les élément commun à chaque page (menu,etc)
 * @author Nicolas Biersart <n.biersart@esia-network.com>
 * @contributor
 * @copyright Nicolas Biersart 2012
 * @license
 * @esia 1.00
 * @version 1.0.0
 * @date 15/04/2013
 */
 $path = rtrim ($_SERVER['DOCUMENT_ROOT'],'/');
include_once $path.'/esia.conf.php';
include_once LIB_LOG;
include_once MVCMODEL;
if(!empty($_GET['flow']))
{
	$chan = urldecode($_GET['flow']);
	//connection à la base de donnée
	try
	{
		$dbconnection = new PDO('pgsql:host='.DB_HOST.';port='.DB_PORT.';dbname='.DB_NAME, DB_USERNAME, DB_PWD);
		$dbconnection->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_WARNING);
	}
	catch(Exception $e)
	{
		echo 'PDO SQL ERROR: '.$e->getMessage().'<br />';
		echo 'N° : '.$e->getCode();
	}
	$channel = Model_esia::getRSSChannel($dbconnection,$chan,'LOCAL')[0];
	if($channel['enable']==1)
	{
		$today = new DateTime($channel['publish']);
		// $url = $_SERVER['REQUEST_SCHEME'].'://'.$_SERVER['HTTP_HOST'];
		$serverFQDN = Model_esia::getConfiguration($dbconnection, 'ESIA_URL');
		$serverFQDN = $serverFQDN['ESIA_URL']['value'];
		$url = $_SERVER['REQUEST_SCHEME'] . '://' . trim($serverFQDN, '/');
		//CREATION des informations sur le channel
		$dom = new DOMDocument('1.0', 'UTF-8');
		$el_rss = $dom->createElement('rss');
		$el_rss_version=$dom->createAttribute('version');
		$el_rss_version->value='2.0';
		$el_rss->appendChild($el_rss_version);
		$el_channel = $dom->createElement('channel');
		$el_title = $dom->createElement('title',$channel['name']);
		$el_description= $dom->createElement('description',$channel['description']);
		$el_buildate= $dom->createElement('lastBuildDate',$today->format(DateTimeInterface::RSS));
		
		$el_link= $dom->createElement('link',$url.$_SERVER['REQUEST_URI']);
		$el_language= $dom->createElement('language',$channel['lang']);
		$el_channel->appendChild($el_title);
		$el_channel->appendChild($el_description);
		$el_channel->appendChild($el_buildate);
		$el_channel->appendChild($el_link);
		if(!empty($channel['image']))
		{
			$image = $channel['image'];
			$el_url= $dom->createElement('url',$url.'/'.$image);
			$el_image= $dom->createElement('image');
			$el_image->appendChild($el_url);
			$el_channel->appendChild($el_image);
		}
		foreach($channel['list_category'] as $category)
		{
			$el_cate = $dom->createElement('category',$category['name']);
			$el_channel->appendChild($el_cate);
		}
		
		$message = Model_esia::getRSSMessages($dbconnection,$channel['id']);
		
		foreach($message as $msg)
		{
			$publish = new DateTime($msg['publish']);
			$el_item = $dom->createElement('item');
			$el_title = $dom->createElement('title',$msg['title']);
			$el_item->appendChild($el_title);
			
			$el_description= $dom->createElement('description',nl2br($msg['message']));
			$el_item->appendChild($el_description);
			
			$el_pubDate= $dom->createElement('pubDate',$publish->format(DateTimeInterface::RSS));
			$el_item->appendChild($el_pubDate);
			
			$el_author = $dom->createElement('author',$msg['author']);
			$el_item->appendChild($el_author);
			if(!empty($msg['link']))
			{
				$el_link= $dom->createElement('link',$msg['link']);
				$el_item->appendChild($el_link);
			}
			if(!empty($msg['image']))
			{
				$el_image= $dom->createElement('image',$msg['image']);
				$el_item->appendChild($el_image);
			}
			$category = explode(',', $msg['category']);
			foreach($category as $cate)
			{
				$el_cate = $dom->createElement('category',$cate);
				$el_item->appendChild($el_cate);
			}
			$el_channel->appendChild($el_item);
		}
		$el_rss->appendChild($el_channel);
		$dom->appendChild($el_rss);
		echo $dom->saveXML();
	}
	else 
	{
		echo "BAD ACCESS";
	}
}
else
{
	echo "BAD ACCESS";
}
?>
