<?php
/**
 * @name search.php
 * @description moteur de recherche d'Esia
 * @author Nicolas Biersart <n.biersart@esia-network.com>
 * @contributor
 * @copyright Nicolas Biersart 2012
 * @license
 * @esia 1.00
 * @version 1.0.0
 * @date 17/04/2013
 */
include_once 'common.php';
//on récupère les mots clés du moteur de recherche
/*$keywords = Model_esia::getSearchKeyWords($dbconnection);

foreach($keywords as $key)
{
	$klang = $keywords[$key['keyword']]['name'];
	$keywords[$key['keyword']]['name']=$lang[$klang];
}

$smarty->assign('list_keyword',$keywords);
$smarty->assign('l_search_nofound',$lang['SEARCH_NO_FOUND']);
*/
try
{
	//on regarde si on a entré une recherche
	if(isset($_POST['textsearch'])&&$_POST['textsearch']!="")
	{
		$list_search =array();
		$smarty->assign('text_search',$_POST['textsearch'] );
		//on vérifie qu'on a pas selectionné un mot-clé dans le select
		if(isset($_POST['keyword'])&&$_POST['keyword']!="0" )
		{
			//on ajoute le mot-clé à la recherche
			$text =$_POST['keyword'].' '.$_POST['textsearch'];
		}
		else
		{
			$text = $_POST['textsearch'];
		}
		//test l'existance d'un mot clé
		if(preg_match('#^(.*)\s#',$text,$regs))
		{
			$keyword = $regs[1];
			if(array_key_exists($regs[1],$keywords))
			{
				//il y a un mot clé
				$keyword = $keywords[$regs[1]];
				$path = rtrim ($_SERVER['DOCUMENT_ROOT'],'/');
				//on inclus le fichier effectuant cette recherche
				include_once $path.'/'.$keyword['file'];
				//on appel la fonction de recherche
				$list_search = $keyword['function']($dbconnection,$text,$user->getId());
				$smarty->assign('list_search',$list_search );
				//mot-clé selectionné
				$smarty->assign('selecKeyword',$keyword['keyword']);
			}
		}
		else
		{
			//si pas de mot clé spécifié on recherche un noeud sur le nom/description
			$list_search =SearchNodeNameOrDescription($dbconnection, $text,$user->getId());
			$smarty->assign('list_search',$list_search );
			$smarty->assign('selecKeyword',null);
		}
	}
	else
	{
		$smarty->assign('text_search',null);
		$smarty->assign('selecKeyword',null);
	}
}
catch(EsiaDbException $e)
{
	$smarty->assign('search_error',$e->getMessage());
}
/*@NAME: SearchNodeNameOrDescription
 *@IN: $dbconnection l'objet de connexion PDO
*	$text texte à rechercher
*	$userid (optionnelle) si spécifié on tiendra compte des droits des utilisateurs
*@OUT:	un tableau contenant:
*	$list_search[]['name'] nom du lien
*	$list_search[]['link'] lien vers la page désirée
*	$list_search[]['description'] une description  qui sera affichée en dessous du lien
*@TREAT: effectue une recherche sur le nom ou la description du noeud.
*@EXCEPTION: 	EsiaDbException si une erreur survient
*/
function SearchNodeNameOrDescription($dbconnection,$text,$userid=null)
{
	$text = preg_replace('#^node\s#','',$text);
	$list_search = array();
	$list = Model_esia::SearchNode($dbconnection, $text,$userid);
	$devType = Model_esia::getDeviceType($dbconnection);
	foreach($list as $node)
	{
		//page de control du noeud suivant sont type
		$page_control='/node_view.php?nodeid='.$node->getId();
		//page de contrôle
		if(!empty($devType[$node->getType()]['web_plugin_control_page']))
		{
			$page_control = Model_esia::replacePageControlVariable($devType[$node->getType()]['web_plugin_control_page'],$node);
			$page_control = $devType[$node->getType()]['web_plugin_apache_path'].$page_control;
		}
		$descr = htmlentities($node->getDescription() , ENT_QUOTES);
		$list_search[]= array('name'=>$node->getName().'('.$node->getGroup().')',
				'link'=>$page_control,
			'description'=>$node->getIPAddress().'<br />'.$descr);
	}
	return $list_search;
}
//affichage de la page
$smarty->display('search.html');
