<?php
/**
 * @name check_snmp_akcp.
 * @description check permettant de modifier les paramètres.
 * @author Quentin GEORGE <q.george@esia-sa.com>
 * @date 25/11/2019
 */
$path = $_SERVER['DOCUMENT_ROOT'];
include_once $path.'/common.php';

$limitExpansion = "min=\"0\"";
$limitModule = "min=\"0\"";
$limitSensorPort = "min=\"1\"";
$PLUGIN['name'] = $_GET['name'];
$type = "";
$alertStep = 1;

// "i" après le délimiteur du pattern, recherche pas sensible à la casse
if (preg_match("/_TEMP/i", $PLUGIN["name"]))
{
	// Temperature Sensor
	$type="temp";
	$alertUnit="C°";
	$alertMinMax = "min=\"-55\" max=\"300\"";
	$alertStep = 0.1;
}
elseif (preg_match("/_HUMI/i", $PLUGIN["name"]))
{
	// Humidity Sensor
	$type="humi";
	$alertUnit="%";
	$alertMinMax = "min=\"0\" max=\"100\"";
}
elseif (preg_match("/_CONT/i", $PLUGIN["name"]))
{
	// Contact Sensor
	$type="cont";
}

if(isset($_GET['id']))
{
	echo '<style type="text/css">.mytext {width: 100px;}</style>';
	echo '<table id="simpleTable'.$_GET['id'].'" style="border-spacing:2;">';

	echo '<tr><td>'.$lang['COM_PORT'].'</td>';
	echo '<td colspan="2"><input type="number" step="1" id="plug-'.$_GET['id'].'-configuration-parameter-expansion" data-option="E" data-index="0" '.$limitExpansion.' class="mytext"/></td>';

	echo '<td style="width:30px;"></td><td>'.$lang['MODULE'].'</td>';
	echo '<td colspan="2"><input type="number" step=".1" id="plug-'.$_GET['id'].'-configuration-parameter-module" data-option="M" data-index="0" '.$limitModule.' class="mytext"/></td></tr>';

	echo '<tr><td>'.$lang['LGD_PORT'].'</td>';
	echo '<td colspan="2"><input type="number" step="1" id="plug-'.$_GET['id'].'-configuration-parameter-port" data-option="S" data-index="1" '.$limitSensorPort.' class="mytext"/></td>';

	echo '<td style="width:30px;"></td><td>'.$lang['SUB_PORT'].'</td>';
	echo '<td colspan="2"><input type="number" step="1" id="plug-'.$_GET['id'].'-configuration-parameter-subport" data-option="S" data-index="2" '.$limitSensorPort.' class="mytext"/></td></tr>';

	if ($type == "temp" || $type == "humi") {
		echo '<tr><td>'.$lang['WARNING_LOW'].'</td>';
		echo '<td><input type="number" step="' . $alertStep . '" id="plug-'.$_GET['id'].'-configuration-parameter-minwarn" data-option="w" data-index="1" '.$alertMinMax.' class="mytext"/></td><td>'.$alertUnit.'</td>';

		echo '<td style="width:30px;"></td><td>'.$lang['WARNING_HIGH'].'</td>';
		echo '<td><input type="number" step="' . $alertStep . '" id="plug-'.$_GET['id'].'-configuration-parameter-maxwarn" data-option="w" data-index="2" '.$alertMinMax.' class="mytext"/></td><td>'.$alertUnit.'</td></tr>';

		echo '<tr><td>'.$lang['CRITICAL_LOW'].'</td>';
		echo '<td><input type="number" step="' . $alertStep . '" id="plug-'.$_GET['id'].'-configuration-parameter-mincrit" data-option="c" data-index="1" '.$alertMinMax.' class="mytext"/></td><td>'.$alertUnit.'</td>';

		echo '<td style="width:30px;"></td><td>'.$lang['CRITICAL_HIGH'].'</td>';
		echo '<td><input type="number" step="' . $alertStep . '" id="plug-'.$_GET['id'].'-configuration-parameter-maxcrit" data-option="c" data-index="2" '.$alertMinMax.' class="mytext"/></td><td>'.$alertUnit.'</td></tr>';
	}
	elseif ($type == "cont") {
		echo '<tr><td>'.$lang['CONTACT_NORMAL_STATE'].'</td>';
		echo '<td><select id="plug-'.$_GET['id'].'-configuration-parameter-input" data-option="I" data-index="0" class="mytext parameter-select">
			<option value="0">'.$lang['CLOSED'].'</option>
			<option value="1">'.$lang['OPEN'].'</option>
		</select></td></tr>';

		echo '<tr><td>'.$lang['ALERT_TYPE'].'</td>';
		echo '<td><select id="plug-'.$_GET['id'].'-configuration-parameter-alerttype" data-option="a" data-index="0" class="mytext parameter-select">
			<option value="w">'.$lang['LGD_WARN'].'</option>
			<option value="c">'.$lang['LGD_CRI'].'</option>
			<option value="o">'.$lang['LGD_OK'].'</option>
		</select></td></tr>';
	}

	echo '</table>';
	echo '<script type="text/javascript">eventSimplification('.$_GET['id'].',LoadOption,ModifyParam)</script>';
}
else
{
	header('HTTP/1.0 404 No Found');
	exit(0);
}
?>

<script type="text/javascript">
$(document).ready(function() {
	$(".parameter-select").chosen({disable_search:true,allow_single_deselect:false,width:"100px"});
});
</script>
