<?php
$path = $_SERVER['DOCUMENT_ROOT'];
include_once $path.'common.php';
include_once $path.'/api/client/client.class.php';
include_once $path.'/plugin/gesa/model_gesa.php';

try{
    //ECATP local ou Galaxy ?
    $esia_server=Model_esia::InstanceNode($dbconnection,$_GET['server_id']);
    $type = $esia_server->getType();
    $ipv4 = $esia_server->getIPAddress();

    $error = "";

    //Authentication API locale or Remote
    $api = new ClientApi();

    if( $type == 'galaxy' ){ //Remote connection
        include_once $path.'/Model_adm.php';
        include_once '/usr/local/esia/keystore/scripts/keystore.lib.php';
	    $advconfigs = Model_adm::getAdvanceNodeConfig($dbconnection,$esia_server->getId());
	    $id = -1;
	    foreach($advconfigs as $elem)
	    {
		    if($elem['name']=='API')
		    {
			    $id = $elem['id'];
		    }
	    }
	    $cred_json = loadSettings($dbconnection,$id );
	    $credentials = json_decode($cred_json,true);
	    $api->authentication($credentials['url'],$credentials['username'],$credentials['password'],$credentials['port']);

	    $urlnode=$credentials['url'].":".$credentials['port'];
    }
    else if( $ipv4 == '127.0.0.1' ){ //Local connection
        $url = $_SERVER['REQUEST_SCHEME']."://127.0.0.1";
        $port = $_SERVER['SERVER_PORT'];
        $login = $user->getName();

        //le user n'a pas le hash mais si on fait un InstanceUser on récupére celui-ci
        $u = Model_esia::InstanceUser($dbconnection,$login);
        $hash = $u->getHashPassword();

        $api->digestauth($url,$login,$hash,$port);

        $urlnode="";
    }
}
catch(BadUserPassException $ex){
    $error .= $e->getMessage().' <br />';
}
catch(Exception $ex){
    $error .= $e->getMessage().' <br />';
}

try{
    //Récupération des informations
    $ecatp['service'] = $api->get('system/service/ecatp-server');
    $ecatp['service']['since'] = DateTime::createFromFormat('D Y-m-d H:i:s e',$ecatp['service']['since'])->format($lang['DEFAULT_DATETIME_fORMAT']);

    $ecatp['settings'] = $api->get('system/settings/ecatp-server');
    if( $ecatp['service']['status'] == 'running' ){
        $ecatp['ecatp'] = $api->get('ecatp/status');
        $ecatp['ecatp']['last_send'] = DateTime::createFromFormat('U', $ecatp['ecatp']['last_send'])->format($lang['DEFAULT_DATETIME_fORMAT']);
    }
    $ecatp['service']['status'] = $lang[strtoupper($ecatp['service']['status'])];

    $ecatp_unity = $api->get('ecatp/unity-list');
    $nodes = $api->get('unity/all');

    //Préparation pour envoyer à la vue
    $unitys = array();
    foreach($nodes as $node){
        $unity['sn'] = $node['unity_sn'];
        $unity['name'] = $node['name'];
        $unity['description'] = $node['description'];
        $unity['name'] = $node['name'];
        $unity['public_addr'] = $node['public_address'];
        $unity['private_addr'] = $node['private_address'];
        $unity['url'] = $urlnode.$node['page_control'];
        $unity['nb_nodes'] = count($node['linked_nodes']);
        $unity['nb_services'] = $node['services_nb'];

        if( isset($ecatp_unity[$unity['sn']]) ){
            if($unity['nb_nodes'] == 0){
                $unity['status'] = 'new';
                $unity['status_text'] = $lang['NEW_UNITY'];
            }
            else{
                $unity['status'] = 'connected';
                $unity['status_text'] = $lang['GESA_CONNECTED'];
            }
        }
        else{
            $unity['status'] = 'unreacheable';
            $unity['status_text'] = $lang['GESA_DISCONNECTED'];
        }
        $unitys[] = $unity;
    }
}
catch(Exception $ex){
    $error .= $ex->getMessage().' <br />';
}

//Récupérer aussi le nombre de noeuds de la unity afin de savoir si elle est nouvelle ou pas
$smarty->assign('errors',$error);
$smarty->assign('ecatp',$ecatp);
$smarty->assign('unity_list',$unitys);
$smarty->display('unity-list.html');
