#!/usr/bin/php
<?php
/**
 * @name Ajout du nouvel alert_mail
 * @author Julien GEORGE <j.george@esia-sa.com>
 * @date 11/10/2018
 */

function execute_query($dbconnection,$sql){
	$query = $dbconnection->prepare($sql);
        $ret = $query->execute();

         if( $ret === false ){
         	$err = $query->errorInfo();
                 echo $err[2]."\n";
                 exit(0);
        }
	return $query->fetchAll(PDO::FETCH_ASSOC);
}

function clean_string($str){
	$arr = explode("\n",$str);
	$ret = array();
	foreach($arr as $row){
		$row = trim($row);
		if( !empty($row)){
			$ret[] = $row;
		}
	}
	return implode("\n",$ret);
}

$SIMILAR = 99.99;
if( isset($argv[1] ) ){
	$SIMILAR = $argv[1];
}

$_SERVER['DOCUMENT_ROOT']='/usr/local/public_html';
include_once '/usr/local/esia/public_html/esia.conf.php';

$dbconnection = new PDO('pgsql:host='.DB_HOST.';port='.DB_PORT.';dbname='.DB_NAME, DB_USERNAME, DB_PWD);
$dbconnection->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_WARNING);

$sql="SELECT config_value FROM esia_configuration WHERE config_key='MAIL_FORMAT_MESSAGE';";

$dir="/usr/local/esia/sql/update_alert_mail";
$clt_format = execute_query($dbconnection,$sql)[0]['config_value'];
$old_format = file_get_contents("$dir/old_mail_format.txt");
$new_format = trim(file_get_contents("$dir/new_mail_format.txt"));

$cleaned_clt_format = clean_string($clt_format);
$cleaned_old_format = clean_string($old_format);

similar_text($cleaned_clt_format,$cleaned_old_format,$similar);

if( $similar > $SIMILAR ){
	$sql="UPDATE esia_configuration SET config_value=? WHERE config_key='MAIL_FORMAT_MESSAGE';";		
	$query = $dbconnection->prepare($sql);
	$ret = $query->execute(array($new_format));

	if( $ret === false ){
		$err = $query->errorInfo();
                 echo $err[2]."\n";
                 exit(1);
	}
	echo "Alert mail updated\n";
	exit (0);
}

echo "Alert mail not changed (status $similar% from origin)\n";
exit (0);
?>
